'----------------------------------------------------------------------
' Bag.inc
'----------------------------------------------------------------------
Declare Function NewBag() As iBag

Interface iBag Guid$("{DE5F2295-C83D-42A7-BB0C-48E44E99D360}")
	Inherit IUnknown
	Method Add( ByRef pItem As iBagEntry ) As Long
	Method Clear()
	Property Get Contains( ByRef pItem As iBagEntry ) As Long
	Property Get Count() As Long
	Method IndexOf( ByRef pItem As iBagEntry ) As Long
	Method Remove( ByRef pItem As iBagEntry )
	Method RemoveAt( ByVal i As Long )
	Property Get Item( ByVal index As Long ) As iBagEntry
End Interface
Declare Function BagGetCollectionSize( ByVal capacity As Long ) As Long

'----------------------------------------------------------------------
' BlankDataSource.inc
'----------------------------------------------------------------------

Interface iDataSource Guid$("{f5cec2ff-a658-4126-a99d-6b2f52c6ebaf}")
	Inherit IUnknown
	Property Get Value( ByVal r As Long, ByVal c As Long ) As String
	Property Set Value( ByVal r As Long, ByVal c As Long, ByRef value As String )
	Property Get RowCount() As Long
	Property Set RowCount( ByVal value As Long )
	Property Get ColCount() As Long
	Property Set ColCount( ByVal value As Long )
End Interface

'----------------------------------------------------------------------
' CollectionPrimes.inc
'----------------------------------------------------------------------
Declare Function GetCollectionSize( ByVal capacity As Long ) As Long

'----------------------------------------------------------------------
' ColorList.inc
'----------------------------------------------------------------------
Declare Function NewColorList Lib "infoview.dll" Alias "NEWCOLORLIST" () As iColorList

Interface iColorList Guid$("{ae17be9b-7785-410f-b0f2-2102322fab48}")
	Inherit IUnknown
	Property Get Item( ByVal offset As Long ) As iIVColor
	Property Get Count() As Long
	Method Clear() As String
	Method Add( ByRef value As iIVColor ) As Long
	Method Remove( ByVal offset As Long ) As String
End Interface

'----------------------------------------------------------------------
' CompoundSupport.inc
'----------------------------------------------------------------------
Declare Function NewRenderFlatBack Lib "infoview.dll" Alias "NEWRENDERFLATBACK" ( ByVal color1 As Dword, ByVal Border As Dword, Optional ByRef color2 As Dword, Optional ByRef radius As Long, Optional ByRef direction As Long ) As iRender
Declare Function NewSysRenderFlatBack Lib "infoview.dll" Alias "NEWSYSRENDERFLATBACK" ( ByVal color1 As Dword, ByVal borderColor As Dword, Optional ByRef color2 As Dword, Optional ByRef radius As Long, Optional ByRef direction As Long ) As iRender
Declare Function NewBevelBack Lib "infoview.dll" Alias "NEWBEVELBACK" ( ByVal edge As Long, ByVal color1 As Dword, Optional ByRef color2 As Dword ) As iRender
Declare Function NewSysBevelBack Lib "infoview.dll" Alias "NEWSYSBEVELBACK" ( ByVal edge As Long, ByVal color1 As Dword, Optional ByRef color2 As Dword ) As iRender

'----------------------------------------------------------------------
' CurrentManager.inc
'----------------------------------------------------------------------
Declare Function NewCurrentManager Lib "infoview.dll" Alias "NEWCURRENTMANAGER" () As iCurrentManager

Interface iCurrentManager Guid$("{6c2b88cc-7bc5-4ea5-b9c3-c053fb8aa9dd}")
	Inherit IUnknown
	Property Get IsRowManager() As Long
	Property Set IsRowManager( ByVal value As Long )
	Property Get Current() As Long
	Property Set Current( ByRef value As Long )
	Property Get Count() As Long
End Interface

Interface iHasDatasource Guid$("{33e74a9a-2739-4180-a894-3fc9cd8614b3}")
	Inherit IUnknown
	Property Get DataSource() As iDataSource
	Property Set DataSource( ByRef value As iDataSource )
End Interface

Interface iReceive Guid$("{113f4bfe-80c4-4dbe-954e-f99ad27a731f}")
	Inherit IUnknown
	Method Receive( sender As iSend, ByVal msg As Long, ByVal a As Long, ByVal b As Long )
End Interface

Interface iSend Guid$("{7b1b3f52-c3bc-40b0-bf3f-9e239ed67dc8}")
	Inherit IUnknown
	Method Subscribe( value As iReceive )
	Method Unsubscribe( value As iReceive )
End Interface

'----------------------------------------------------------------------
' DataColumn.inc
'----------------------------------------------------------------------
Declare Function NewDataColumn() As iDataColumn

Interface iDataColumn Guid$("{544c7676-bd96-4276-aaae-ba007f2e03a2}")
	Inherit IUnknown
	Property Get ColumnName() As String
	Property Set ColumnName( ByRef value As String )
	Property Get Heading() As String
	Property Set Heading( ByRef value As String )
	Property Get DataTable() As iDataTable
	Property Set DataTable( ByRef value As iDataTable )
End Interface

'----------------------------------------------------------------------
' DataRow.inc
'----------------------------------------------------------------------
Declare Function BufferToString Lib "infoview.dll" Alias "BUFFERTOSTRING" ( ByRef buf() As Byte ) As String
Declare Sub StringToBuffer Lib "infoview.dll" Alias "STRINGTOBUFFER" ( ByRef value As String, ByRef buf() As Byte )
Declare Function NewDataRow() As iDataRow

Interface iDataRow Guid$("{7c95c6c5-e752-4bd2-89be-65180f2afca2}")
	Inherit IUnknown
	Property Get IsNull( ByVal offset As Long ) As Long
	Method SetNull( ByVal offset As Long, ByVal value As Long )
	Method SetAllNull( ByVal value As Long )
	Property Get Value(ByVal offset As Long) As String
	Property Set Value(ByVal offset As Long, ByRef value As String )
	Property Get DataTable() As iDataTable
	Property Set DataTable( ByRef value As iDataTable )
	Property Get AsLong( ByVal offset As Long ) As Long
	Property Set AsLong( ByVal offset As Long, ByVal value As Long )
	Property Get AsCur( ByVal offset As Long ) As Currency
	Property Set AsCur( ByVal offset As Long, ByVal value As Currency )
	Property Get AsDbl( ByVal offset As Long, fmt As String ) As Double
	Property Set AsDbl( ByVal offset As Long, fmt As String, ByVal value As Double )
	Property Get AsBool( ByVal offset As Long ) As Long
	Property Set AsBool( ByVal offset As Long, ByVal value As Long )
	Property Get AsDate( ByVal offset As Long ) As String
	Property Set AsDate( ByVal offset As Long, ByVal value As String )
	Property Get AsTime( ByVal offset As Long ) As String
	Property Set AsTime( ByVal offset As Long, ByVal value As String )
	Property Get AsDateTime( ByVal offset As Long ) As String
	Property Set AsDateTime( ByVal offset As Long, ByVal value As String )
End Interface

'----------------------------------------------------------------------
' DataSet.inc
'----------------------------------------------------------------------
Declare Function NewDataSet Lib "infoview.dll" Alias "NEWDATASET" ( ByRef DataSetName As String ) As iDataSet

Interface iDataSet Guid$("{091e29f0-f3da-4b2e-a13d-60d931df1c7f}")
	Inherit IUnknown
	Property Get Name As String
	Property Set Name( ByRef value As String )
	Method Add( ByRef value As iDataTable )
	Property Get DataTable( ByVal offset As Integer ) As iDataTable
	Method Find( ByRef tableName As String ) As Long
	Method Erase()
	Method Remove( ByVal offset As Integer )
End Interface

'----------------------------------------------------------------------
' DataTable.inc
'----------------------------------------------------------------------
Declare Function NewDataTable Lib "infoview.dll" Alias "NEWDATATABLE" ( ByRef tableName As String, Optional ByRef ds As iDataSet ) As iDataTable
Declare Sub AddDataTableRow Lib "infoview.dll" Alias "ADDDATATABLEROW" ( ByRef table As iDataTable, values() As String )

Interface iDataTable Guid$("{a35004f4-ffe7-403d-8975-3cdb203fa7fe}")
	Inherit IUnknown
	Property Get TableName() As String
	Property Set TableName( ByRef value As String )
	Property Get Capacity() As Long
	Property Set Capacity( ByVal pVal As Long )
	Property Get ColCount() As Long
	Method AddDelimetedColumns( ByRef delimetedColumns As String, ByVal delimeter As String )
	Method AddColumn( ByRef columnName As String, Optional ByRef heading As String ) As iDataColumn
	Method RemoveColumn( ByVal offset As Long )
	Property Get Column(ByVal offset As Long ) As iDataColumn
	Property Get ColumnIndex( ByVal pName As String ) As Long
	Property Get ColumnName( ByVal offset As Long ) As String
	Method Clear()
	Method ClearRows()
	Method NewRow() As iDataRow
	Method AddRow( ByRef value As iDataRow )
	Method RemoveRow( ByVal offset As Long )
	Method AddNewDelimetedRow( ByRef delimetedValues As String, ByVal delimeter As String )
	Property Get RowCount() As Long
	Property Get Row( ByVal r As Long ) As iDataRow
	Property Get NullDisplayValue() As String
	Property Set NullDisplayValue( ByRef value As String )
	Property Get DataSet() As iDataSet
	Property Set DataSet( ByRef value As iDataSet )
	Property Get Version() As Long
	Method NextVersion()
End Interface

'----------------------------------------------------------------------
' DataTableShared.inc
'----------------------------------------------------------------------

'----------------------------------------------------------------------
' DataView.inc
'----------------------------------------------------------------------
Declare Function DataView_FilterAll Lib "infoview.dll" Alias "DATAVIEW_FILTERALL" ( ByVal dr As iDataRow ) As Long
Declare Function NewDataView Lib "infoview.dll" Alias "NEWDATAVIEW" ( ByRef dt As iDataTable ) As iDataView

Interface iDataView Guid$("{675f95e9-9184-43c4-aa58-2694a8053e82}")
	Inherit IUnknown
	Property Get DataTable() As iDataTable
	Property Set DataTable( ByRef value As iDataTable )
	Property Get FilterMethod() As Dword
	Property Set FilterMethod( ByVal value As Dword )
	Property Get Sort() As String
	Property Set Sort( ByRef value As String )
	Property Get CaseSensitive() As Long
	Property Set CaseSensitive( ByVal value As Long )
	Property Get Rows() As Long
	Property Get Row( ByVal offset As Long ) As iDataRow
	Property Get IsCurrent() As Long
	Method Refresh()
End Interface

'----------------------------------------------------------------------
' EvenRowMapper.inc
'----------------------------------------------------------------------

Interface iValueToLong Guid$("{c4dae399-86e5-4c34-be0a-a9fa7cc5ee90}")
	Inherit IUnknown
	Property Get ValueToLong( ByRef value As WString ) As Long
	Property Get LongToValue( ByVal value As Long ) As WString
End Interface

'----------------------------------------------------------------------
' ExtensionList.inc
'----------------------------------------------------------------------
Declare Function NewExtensionList Lib "infoview.dll" Alias "NEWEXTENSIONLIST" () As iExtensionList

Interface iExtensionList Guid$("{67140677-dbc0-42c2-b077-48f4301c98ab}")
	Inherit IUnknown
	Method GoTo( ByVal offset As Long )
	Property Get Current() As iExtend
	Method Next() As Long
	Method Prev() As Long
	Method Reset()
	Property Get Item( ByVal offset As Long ) As iExtend
	Property Get Count() As Long
	Method Add( ByRef value As iExtend ) As String
	Method Remove( ByRef offset As Long ) As String
	Method Clear() As String
End Interface

'----------------------------------------------------------------------
' FeatureList.inc
'----------------------------------------------------------------------
Declare Function NewFeatureList Lib "infoview.dll" Alias "NEWFEATURELIST" () As iFeatureList

Interface iFeatureList Guid$("{3822498b-d2c3-4410-8d5d-388bdf01eb1b}")
	Inherit IUnknown
	Property Get Item( ByVal offset As Long ) As iFeature
	Property Set Item( ByVal offset As Long, ByRef value As iFeature )
	Method Notify()
	Method Add( ByRef value As iFeature ) As Long
	Method Remove( ByRef value As iFeature )
	Method Clear() As String
End Interface

'----------------------------------------------------------------------
' FlowLayout.inc
'----------------------------------------------------------------------
Declare Function NewFlowLayout Lib "infoview.dll" Alias "NEWFLOWLAYOUT" () As iLayout

Interface iFlowLayout Guid$("{373554bb-cbd0-4a55-a555-c1edbb274b1d}")
	Inherit IUnknown
	Property Get IsRightDown() As Long
	Property Set IsRightDown( ByVal value As Long )
	Property Get IsCurItemARow() As Long
	Property Set IsCurItemARow( ByVal value As Long )
	Property Get SelectType() As Long
	Property Set SelectType( ByVal value As Long )
	Property Get HotType() As Long
	Property Set HotType( ByVal value As Long )
	Property Get BackRenderer( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Get ContentRenderer( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Get DrawFocus() As iRender
	Property Set DrawFocus( ByRef value As iRender )
	Property Get DrawOverride() As iUserRender
	Property Set DrawOverride( value As iUserRender )
	Property Get BackDefault( ByVal state As Long ) As iRender
	Property Set BackDefault( ByVal state As Long, ByRef value As iRender )
	Property Get BackOverride( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Set BackOverride( ByVal offset As Long, ByVal state As Long, ByRef value As iRender )
	Method BackOverrideClear( ByVal offset As Long )
	Property Get ContentDefault( ByVal state As Long ) As iRender
	Property Set ContentDefault( ByVal state As Long, ByRef value As iRender )
	Property Get ContentOverride( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Set ContentOverride( ByVal offset As Long, ByVal state As Long, ByRef value As iRender )
	Method ContentOverrideClear( ByVal offset As Long )
	Property Get Width() As Long
	Property Set Width( ByRef value As Long )
	Property Get Height() As Long
	Property Set Height( ByRef value As Long )
End Interface

Interface iLayout Guid$( "{b87daa5f-0140-4b31-8bd1-ff4f0c56e666}")
	Inherit IUnknown
	Property Get PadLeft() As Long
	Property Set PadLeft( ByRef value As Long )
	Property Get PadTop() As Long
	Property Set PadTop( ByRef value As Long )
	Property Get PadRight() As Long
	Property Set PadRight( ByRef value As Long )
	Property Get PadBottom() As Long
	Property Set PadBottom( ByRef value As Long )
	Property Get OtherLayout() As iLayout
	Property Set OtherLayout( value As iLayout )
	Property Get SuspendPaint() As Long
	Property Set SuspendPaint( ByVal value As Long )
	Property Get XGutter() As Long
	Property Set XGutter( ByRef value As Long )
	Property Get YGutter() As Long
	Property Set YGutter( ByRef value As Long )
	Property Get CurItem() As Long
	Property Set CurItem( ByVal value As Long )
	Property Get OtherItem() As Long
	Property Set OtherItem( ByVal value As Long )
	Property Get OtherItemCurrent() As Long
	Property Set OtherItemCurrent( ByVal value As Long )
	Method SetOtherBounds( ByVal start As Long, ByVal final As Long )
	Property Get IsHotTracking() As Long
	Property Get HWnd() As Dword
	Property Set HWnd( ByVal value As Dword )
	Method GotoItem( ByVal offset As Long )
	Property Get SizeItem( ByVal offset As Long ) As Long
	Property Get SizeOverride( ByVal offset As Long ) As Long
	Property Set SizeOverride( ByVal offset As Long, ByVal value As Long ): ' <0 = remove custom size
	Method SizeOverrideClear( ByVal offset As Long )
	Property Get FirstItem() As Long
	Property Set FirstItem( value As Long )
	Property Get MinFirst() As Long
	Property Get MaxFirst() As Long
	Property Get SelStart() As Long
	Property Set SelStart( ByVal value As Long )
	Property Get ItemCount() As Long
	Property Get VisibleCount() As Long
	Property Get PageItemCount() As Long
	Property Get ItemIndex( ByVal offset As Long ) As Long
	Method GetFullBounds( rc As RECT )
	Method GetDrawnBounds( rc As RECT )
	Method GetRect( ByVal offset As Long, rc As RECT )
	Method GetBorder( ByVal x As Long, ByVal y As Long ) As Long
	Method Hit( ByVal x As Long, ByVal y As Long ) As Long
	Method EnsureLayoutUpdated( ByRef newBounds As RECT )
	Method RequestLayoutUpdate( ByRef newBounds As RECT )
End Interface

Interface iRender Guid$( "{c840a61d-d562-4b33-8d81-b243cbde20e5}")
	Inherit IUnknown
	Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
End Interface

'----------------------------------------------------------------------
' Font.inc
'----------------------------------------------------------------------
Declare Function NewFont Lib "infoview.dll" Alias "NEWFONT" ( face_ As WString, ByVal height_ As Long, ByVal bold_ As Long, ByVal italic_ As Long, ByVal angle_ As Long ) As iFont

Interface iFont Guid$("{59e9afd4-3272-48ae-a3c9-a59a71b704f6}")
	Inherit IUnknown
	Property Get Baseline() As Long
	Property Get Height() As Long
	Property Get Width( value As WString ) As Long
	Property Get AvgCharWidth() As Long
	Property Get Handle() As Dword
	Property Set Handle( ByVal value As Dword )
	Method New( face_ As WString, ByVal height_ As Long, ByVal bold_ As Long, ByVal italic_ As Long, ByVal angle_ As Long )
End Interface

'----------------------------------------------------------------------
' InfoViewEnumAndType.inc
'----------------------------------------------------------------------

Interface iUserRender Guid$("{b1e4420b-e97c-46af-93af-286788c6b663}")
	Inherit IUnknown
	Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long, ByRef value As WString, ByVal part As Long, ByVal state As Long, ByRef renderer As iRender ) As Long
End Interface

Interface iValueToString Guid$("{75310dc4-5c3c-4609-8b87-dff4e5abe02f}")
	Inherit IUnknown
	Property Get ValueToString( ByRef value As WString ) As WString
	Property Get StringToValue( ByRef value As WString ) As WString
End Interface

'----------------------------------------------------------------------
' IVBase.inc
'----------------------------------------------------------------------
Declare Sub IVClearTrack()
Declare Function NewIVBase Lib "infoview.dll" Alias "NEWIVBASE" ( ByVal hParent As Dword, _
					Optional ByRef l As Long, _
					Optional ByRef t As Long, _
					Optional ByRef w As Long, _
					Optional ByRef h As Long, _
					Optional ByRef childId As Long ) As iWin

Interface iIVBase Guid$("{ca082619-262a-4bdc-8799-6179c35ee9ce}")
	Inherit IUnknown
	Property Get Row() As Long
	Property Set Row( ByVal value As Long )
	Property Get RowCount() As Long
	Property Set RowCount( ByVal value As Long )
	Property Get Col() As Long
	Property Set Col( ByVal value As Long )
	Property Get ColCount() As Long
	Property Set ColCount( ByVal value As Long )
	Property Get Views() As iExtensionList
	Property Get Extensions() As iExtensionList
	Method ActivateView()
End Interface

Interface iWin Guid$("{9880cedb-b3de-4997-b6bb-d6c1178788d8}")
	Inherit IUnknown
	Method Proc( ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long, ByRef ret As Long) As Long
	Property Get HWnd() As Dword
	Property Get Parent() As Dword
	Property Set Parent( ByVal value As Dword )
	Method Resize( ByVal w As Long, ByVal h As Long )
	Method Move( ByVal l As Long, ByVal t As Long )
	Property Get ChildId() As Long
	Property Set ChildId( ByVal childId As Long )
End Interface
Declare Function GetIV_ControlProc() As Dword
Declare Function IV_ControlProc( ByVal hWnd As Dword, ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long) As Long

'----------------------------------------------------------------------
' IVCol.inc
'----------------------------------------------------------------------
Declare Function NewIVCol Lib "infoview.dll" Alias "NEWIVCOL" ( win As iWin ) As iExtend

Interface iIVCol Guid$("{8f4b4ef3-665d-4824-8221-90f5e6167bf4}")
	Inherit IUnknown
	Property Get Layout() As iLayout
	Property Set Layout( ByRef value As iLayout )
	Property Get CopyHeaders() As Long
	Property Set CopyHeaders( ByVal value As Long )
	Property Get DrawControlBack() As iRender
	Property Set DrawControlBack( ByRef value As iRender )
End Interface

Interface iExtend Guid$("{071a4670-b6c6-4fd2-8d44-5d4caa0af66b}")
	Inherit IUnknown
	Method Extend( ByRef value As iWin )
	Method Unextend()
	Method Execute( ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long, ByRef ret As Long) As Long
End Interface

'----------------------------------------------------------------------
' IVColor.inc
'----------------------------------------------------------------------
Declare Sub IVColor_ColorListClear Lib "infoview.dll" Alias "IVCOLOR_COLORLISTCLEAR" ()
Declare Sub IVColor_OnSysColorChange Lib "infoview.dll" Alias "IVCOLOR_ONSYSCOLORCHANGE" ()
Declare Function NewIVColor Lib "infoview.dll" Alias "NEWIVCOLOR" ( ByVal value As Dword ) As iIVColor
Declare Function NewSysIVColor Lib "infoview.dll" Alias "NEWSYSIVCOLOR" ( ByVal sysColor As Long ) As iIVColor

Interface iIVColor Guid$("{aabdc38b-8401-4ec7-8288-e7d3b4041fcc}")
	Inherit IUnknown
	Property Get Value() As Dword
	Property Set Value( ByRef value As Dword )
	Property Get SysColor() As Long
	Property Set SysColor( ByRef value As Long )
	Method TestRelease()
End Interface

'----------------------------------------------------------------------
' IVRow.inc
'----------------------------------------------------------------------
Declare Function NewIVRow Lib "infoview.dll" Alias "NEWIVROW" ( win As iWin ) As iExtend

Interface iIVRow Guid$("{fc4dcd27-c340-45f3-82b4-1ff1a0e77f5d}")
	Inherit IUnknown
	Property Get CopyHeaders() As Long
	Property Set CopyHeaders( ByVal value As Long )
	Property Get Layout() As iLayout
	Property Set Layout( ByRef value As iLayout )
	Property Get DrawControlBack() As iRender
	Property Set DrawControlBack( ByRef value As iRender )
End Interface

'----------------------------------------------------------------------
' IVRowCol.inc
'----------------------------------------------------------------------
Declare Function NewIVRowCol Lib "infoview.dll" Alias "NEWIVROWCOL" ( win As iWin ) As iExtend

Interface iIVRowCol Guid$( "{770c3baf-c13b-497f-ac3e-beec83fe815d}" )
	Inherit IUnknown
	Property Get AllowResize() As Long
	Property Set AllowResize( ByVal value As Long )
	Property Get HLayout() As iLayout
	Property Set HLayout( ByRef value As iLayout )
	Property Get VLayout() As iLayout
	Property Set VLayout( ByRef value As iLayout )
	Property Get CopyHeaders() As Long
	Property Set CopyHeaders( ByVal value As Long )
	Property Get DrawVGrid() As iRender
	Property Set DrawVGrid( ByRef value As iRender )
	Property Get DrawHGrid() As iRender
	Property Set DrawHGrid( ByRef value As iRender )
	Property Get DrawContentBack() As iRender
	Property Set DrawContentBack( ByRef value As iRender )
	Property Get DrawControlBack() As iRender
	Property Set DrawControlBack( ByRef value As iRender )
	Property Get Extensions() As iExtensionList
End Interface
Declare Function Between( ByVal value As Long, ByVal a As Long, ByVal b As Long ) As Long

'----------------------------------------------------------------------
' IVSwitchViews.inc
'----------------------------------------------------------------------

Interface iIVBaseSwitchViews Guid$("{4556544f-1041-49ae-8696-7ec42e936e4e}")
	Inherit IUnknown
	Property Get NextKey() As Dword
	Property Set NextKey( ByVal value As Dword )
	Property Get PrevKey() As Dword
	Property Set PrevKey( ByVal value As Dword )
	Method Next()
	Method Prev()
End Interface

'----------------------------------------------------------------------
' LongiRenderMap.inc
'----------------------------------------------------------------------
Declare Function NewLongRenderMap Lib "infoview.dll" Alias "NEWLONGRENDERMAP" () As iLongRenderMap

Interface iLongRenderMap Guid$("{551b8f6d-66c9-48c7-b2ef-4503800f3e49}")
	Inherit IUnknown
	Method Add( ByVal pKey As Long, ByVal pItem As iRender ) As Long
	Method Clear()
	Property Get Contains( ByRef pKey As Long ) As Long
	Property Get Count() As Long
	Method IndexOf( ByRef pKey As Long ) As Long
	Method Remove( ByRef pKey As Long )
	Method RemoveAt( ByVal i As Long )
	Property Get Value( ByVal pKey As Long ) As iRender
	Property Set Value( ByVal pKey As Long, ByRef value As iRender )
	Property Get Key( ByVal index As Long ) As Long
End Interface

Interface iLongRenderPair Guid$("{41883467-5292-4ae7-ae60-fe440a9114bf}")
	Inherit IUnknown
	Property Get Value() As iRender
	Property Set Value( ByVal value As iRender )
	Property Get Key () As Long
	Property Set Key ( ByVal pVal As Long)
End Interface

Interface iBagEntry Guid$("{88765CD3-3E71-41CC-B0F3-29C8A4CE395A}")
	Inherit IUnknown
	Method Same( ByVal value As iBagEntry ) As Long
	Property Get HashCode () As Long
	Property Set HashCode ( ByVal pHashCode As Long)
	Property Get Next () As Long
	Property Set Next ( ByVal pNext As Long)
End Interface

'----------------------------------------------------------------------
' LongLongMap.inc
'----------------------------------------------------------------------
Declare Function NewLongLongMap Lib "infoview.dll" Alias "NEWLONGLONGMAP" () As iLongLongMap

Interface iLongLongMap Guid$("{83a6cfd5-ce9f-4db2-a7e5-7b1b319a21fd}")
	Inherit IUnknown
	Method Add( ByVal pKey As Long, ByVal pItem As Long ) As Long
	Method Clear()
	Property Get Contains( ByRef pKey As Long ) As Long
	Property Get Count() As Long
	Method IndexOf( ByRef pKey As Long ) As Long
	Method Remove( ByRef pKey As Long )
	Method RemoveAt( ByVal i As Long )
	Property Get Value( ByVal pKey As Long ) As Long
	Property Set Value( ByVal pKey As Long, value As Long )
	Property Get Key( ByVal index As Long ) As Long
End Interface

Interface iLongLongPair Guid$("{bffad939-059f-41a6-b081-618363e9fb55}")
	Inherit IUnknown
	Property Get Value() As Long
	Property Set Value( ByVal value As Long )
	Property Get Key () As Long
	Property Set Key ( ByVal pVal As Long)
End Interface

'----------------------------------------------------------------------
' LongStateRenderMap.inc
'----------------------------------------------------------------------
Declare Function NewLongStateRenderMap Lib "infoview.dll" Alias "NEWLONGSTATERENDERMAP" () As iLongStateRenderMap

Interface iLongStateRenderMap Guid$("{ed79f931-1b11-483d-b2eb-6bed5335509c}")
	Inherit IUnknown
	Method Add( ByVal pKey As Long, ByVal pItem As iRender ) As Long
	Method Clear()
	Property Get Contains( ByRef pKey As Long ) As Long
	Property Get Count() As Long
	Method IndexOf( ByRef pKey As Long ) As Long
	Method Remove( ByRef pKey As Long )
	Method RemoveAt( ByVal i As Long )
	Property Get Value( ByVal pKey As Long ) As iRender
	Property Set Value( ByVal pKey As Long, ByRef value As iRender )
	Property Get Key( ByVal index As Long ) As Long
End Interface

Interface iLongStateRenderPair Guid$("{247a58d0-da36-4330-bc91-09efd6302963}")
	Inherit IUnknown
	Property Get Value() As iRender
	Property Set Value( ByVal value As iRender )
	Property Get Key () As Long
	Property Set Key ( ByVal pVal As Long)
End Interface

'----------------------------------------------------------------------
' PosItem.inc
'----------------------------------------------------------------------
Declare Function NewPosItem Lib "infoview.dll" Alias "NEWPOSITEM" ( ByVal c As Long, ByVal l As Long, ByVal t As Long, ByVal w As Long, ByVal h As Long, ByVal anchor As Long ) As iPosItem

Interface iPosItem Guid$("{0c6140fd-342c-4a33-a650-636ff2be02c9}")
	Inherit IUnknown
	Property Get Col() As Long
	Property Set Col( ByVal value As Long )
	Property Get Left() As Long
	Property Set Left( ByVal value As Long )
	Property Get Top() As Long
	Property Set Top( ByVal value As Long )
	Property Get Width() As Long
	Property Set Width( ByVal value As Long )
	Property Get Height() As Long
	Property Set Height( ByVal value As Long )
	Property Get Anchor() As Long
	Property Set Anchor( ByVal value As Long )
	Method Rect( rc As RECT )
End Interface

'----------------------------------------------------------------------
' PositionedLayout.inc
'----------------------------------------------------------------------
Declare Function NewPositionedLayout Lib "infoview.dll" Alias "NEWPOSITIONEDLAYOUT" () As iLayout

Interface iPositionedLayout Guid$("{8d0f2b9d-343d-4dc9-ba30-94007c7ac657}")
	Inherit IUnknown
	Property Get Layout() As RECT
	Property Set Layout( value As RECT )
	Property Set Def( value As WString )
	Property Get Item() As iPosList
	Property Get SelectType() As Long
	Property Set SelectType( ByVal value As Long )
	Property Get HotType() As Long
	Property Set HotType( ByVal value As Long )
	Property Get DrawBackRender( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Get DrawBack( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Set DrawBack( ByVal offset As Long, ByVal state As Long, ByRef value As iRender )
	Method DrawBackClear( ByVal offset As Long )
	Property Get DrawContentRender( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Get DrawContent( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Set DrawContent( ByVal offset As Long, ByVal state As Long, ByRef value As iRender )
	Method DrawContentClear( ByVal offset As Long )
End Interface

'----------------------------------------------------------------------
' PosList.inc
'----------------------------------------------------------------------
Declare Function NewPosList Lib "infoview.dll" Alias "NEWPOSLIST" () As iPosList

Interface iPosList Guid$("{5e86dab3-8b4e-4d02-a88b-88c8770c4aed}")
	Inherit IUnknown
	Property Get Count() As Long
	Property Get Item(ByVal index As Long) As iPosItem
	Method Add( value As iPosItem ) As Long
	Method Clear()
End Interface

'----------------------------------------------------------------------
' RenderBar.inc
'----------------------------------------------------------------------
Declare Function NewRenderBar Lib "infoview.dll" Alias "NEWRENDERBAR" ( ByVal clr As Dword, ByVal side As Long, Optional ByRef thickness As Long ) As iRender

Interface iRenderBar Guid$("{e56043f7-f530-41d8-bf38-101f07f0802d}")
	Inherit IUnknown
	Property Get Color() As Dword
	Property Set Color( ByRef value As Dword )
	Property Get Side() As Long
	Property Set Side( ByVal value As Long )
	Property Get Thickness() As Long
	Property Set Thickness( ByRef value As Long )
End Interface

'----------------------------------------------------------------------
' RenderBevel.inc
'----------------------------------------------------------------------
Declare Function NewRenderBevel Lib "infoview.dll" Alias "NEWRENDERBEVEL" ( ByVal edge As Long ) As iRender

Interface iRenderBevel Guid$("{19a96b9a-8eba-439c-bb9e-4af513cbb603}")
	Inherit IUnknown
	Property Get Edge() As Long
	Property Set Edge( ByRef value As Long )
End Interface

'----------------------------------------------------------------------
' RenderBound.inc
'----------------------------------------------------------------------
Declare Function NewRenderBound Lib "infoview.dll" Alias "NEWRENDERBOUND" ( drawContent As iRender, ds As iDataSource, Optional promptLoc As Long, Optional promptSize As Long, Optional drawPrompt As iRender ) As iRender

Interface iRenderBound Guid$("{b8a7ce58-dd65-4dea-85ee-496045412a9c}")
	Inherit IUnknown
	Property Get Datasource() As iDataSource
	Property Set Datasource( ByRef value As iDataSource )
	Property Get DrawContent() As iRender
	Property Set DrawContent( ByRef value As iRender )
	Property Get DrawPrompt() As iRender
	Property Set DrawPrompt( ByRef value As iRender )
	Property Get PromptLoc() As Long
	Property Set PromptLoc( ByRef value As Long )
	Property Get PromptSize() As Long
	Property Set PromptSize( ByRef value As Long )
End Interface

Interface iAlign Guid$("{f8de15d9-b7e2-423a-bb15-72d1882e11da}")
	Inherit IUnknown
	Property Get Align() As Dword
	Property Set Align( ByRef value As Dword )
End Interface

'----------------------------------------------------------------------
' RenderButton.inc
'----------------------------------------------------------------------
Declare Function NewRenderButton Lib "infoview.dll" Alias "NEWRENDERBUTTON" ( ByVal State As Dword ) As iRender

Interface iRenderButton Guid$("{bc105664-52a8-453b-bff0-7f272e890330}")
	Inherit IUnknown
	Property Get State() As Dword
	Property Set State( ByRef value As Dword )
End Interface

'----------------------------------------------------------------------
' RenderCheckbox.inc
'----------------------------------------------------------------------
Declare Function NewRenderCheckbox Lib "infoview.dll" Alias "NEWRENDERCHECKBOX" ( Optional ByRef map As iValueToLong ) As iRender

Interface iRenderCheckbox Guid$("{3acbed23-70e6-40d0-8c76-fb5b2d255474}")
	Inherit IUnknown
	Property Get Map() As iValueToLong
	Property Set Map( ByRef value As iValueToLong )
End Interface

Interface iValue Guid$("{081a3833-2308-4273-bda0-1c10b35610c3}")
	Inherit IUnknown
	Property Get Value() As WString
	Property Set Value( ByRef value As WString )
End Interface

'----------------------------------------------------------------------
' RenderCompound.inc
'----------------------------------------------------------------------
Declare Function NewRenderCompound Lib "infoview.dll" Alias "NEWRENDERCOMPOUND" () As iRender

Interface iRenderCompound Guid$("{6835d43c-0ee9-4ca0-9849-c316d9b385b3}")
	Inherit IUnknown
	Method Add( ByRef value As iRender )
	Method Clear()
End Interface

'----------------------------------------------------------------------
' RenderFill.inc
'----------------------------------------------------------------------
Declare Function NewRenderFill Lib "infoview.dll" Alias "NEWRENDERFILL" ( ByVal color1 As Dword, Optional ByRef color2 As Dword, Optional ByRef radius As Long, Optional ByRef angle As Long ) As iRender
Declare Function NewSysRenderFill Lib "infoview.dll" Alias "NEWSYSRENDERFILL" ( ByVal color1 As Dword, Optional ByRef color2 As Dword, Optional ByRef radius As Long, Optional ByRef angle As Long ) As iRender

Interface iRenderFill Guid$("{c8ba9b69-5fc2-4422-a88c-3869afe5488e}")
	Inherit IUnknown
	Property Get Color1() As iIVColor
	Property Get Color2() As iIVColor
	Property Get Radius() As Long
	Property Set Radius( ByRef value As Long )
	Property Get Angle() As Long
	Property Set Angle( ByVal value As Long )
End Interface

'----------------------------------------------------------------------
' RenderFocus.inc
'----------------------------------------------------------------------
Declare Function NewRenderFocus Lib "infoview.dll" Alias "NEWRENDERFOCUS" () As iRender

'----------------------------------------------------------------------
' RenderFrame.inc
'----------------------------------------------------------------------
Declare Function NewRenderFrame Lib "infoview.dll" Alias "NEWRENDERFRAME" () As iRender

'----------------------------------------------------------------------
' RenderIcon.inc
'----------------------------------------------------------------------
Declare Function NewRenderIcon Lib "infoview.dll" Alias "NEWRENDERICON" ( ByVal siz As Long, Optional position As Long, Optional ByRef map As iValueToLong ) As iRender
Declare Sub SetRenderIcon Lib "infoview.dll" Alias "SETRENDERICON" ( ByVal obj As iRender, ByVal offset As Long, ByVal hIcon As Dword )
Declare Sub SetRenderIconList Lib "infoview.dll" Alias "SETRENDERICONLIST" ( ByVal obj As iRender, ByRef icons() As Dword )

Interface iRenderIcon Guid$("{ab5b28e3-75da-402c-bfff-43b2ebfc351a}")
	Inherit IUnknown
	Property Get Icon( ByVal offset As Long ) As Dword
	Property Set Icon( ByVal offset As Long, ByVal value As Dword )
	Property Get Size() As Long
	Property Set Size( ByVal value As Long )
	Property Get Position() As Long
	Property Set Position( ByVal value As Long )
	Property Get Map() As iValueToLong
	Property Set Map( ByRef value As iValueToLong )
End Interface

'----------------------------------------------------------------------
' RenderImage.inc
'----------------------------------------------------------------------
Declare Function NewRenderImage Lib "infoview.dll" Alias "NEWRENDERIMAGE" ( Optional ByRef Stretch As Long, Optional ByRef map As iValueToLong ) As iRender
Declare Sub SetRenderImage Lib "infoview.dll" Alias "SETRENDERIMAGE" ( ByVal obj As iRender, ByVal offset As Long, ByVal hImage As Dword )
Declare Sub SetRenderImageList Lib "infoview.dll" Alias "SETRENDERIMAGELIST" ( ByVal obj As iRender, ByRef Images() As Dword )

Interface iRenderImage Guid$("{4160209f-b95f-4a60-80ea-80751d3a8bf1}")
	Inherit IUnknown
	Property Get Image( ByVal offset As Long ) As Dword
	Property Set Image( ByVal offset As Long, ByVal value As Dword )
	Property Get Map() As iValueToLong
	Property Set Map( ByRef value As iValueToLong )
	Property Get Stretch() As Dword
	Property Set Stretch( ByVal value As Dword )
End Interface

'----------------------------------------------------------------------
' RenderInflate.inc
'----------------------------------------------------------------------
Declare Function NewRenderInflate Lib "infoview.dll" Alias "NEWRENDERINFLATE" ( ByVal x As Long, ByVal y As Long ) As iRender

Interface iRenderInflate Guid$("{1a4043a3-afc6-40ba-8444-2f2abf98623c}")
	Inherit IUnknown
	Property Get X() As Long
	Property Set X( ByVal value As Long )
	Property Get Y() As Long
	Property Set Y( ByVal value As Long )
End Interface

'----------------------------------------------------------------------
' RenderNothing.inc
'----------------------------------------------------------------------
Declare Function NewRenderNothing Lib "infoview.dll" Alias "NEWRENDERNOTHING" () As iRender

'----------------------------------------------------------------------
' RenderOffset.inc
'----------------------------------------------------------------------
Declare Function NewRenderOffset Lib "infoview.dll" Alias "NEWRENDEROFFSET" ( ByVal l As Long, ByVal t As Long, ByVal r As Long, ByVal b As Long ) As iRender

Interface iRenderOffset Guid$("{0929b6f7-4e13-4c17-92f9-9119ea152238}")
	Inherit IUnknown
	Property Get Left() As Long
	Property Set Left( ByVal value As Long )
	Property Get Top() As Long
	Property Set Top( ByVal value As Long )
	Property Get Right() As Long
	Property Set Right( ByVal value As Long )
	Property Get Bottom() As Long
	Property Set Bottom( ByVal value As Long )
End Interface

'----------------------------------------------------------------------
' RenderOutline.inc
'----------------------------------------------------------------------
Declare Function NewRenderOutline Lib "infoview.dll" Alias "NEWRENDEROUTLINE" ( ByVal color1 As Dword, Optional ByRef radius As Long ) As iRender
Declare Function NewSysRenderOutline Lib "infoview.dll" Alias "NEWSYSRENDEROUTLINE" ( ByVal color1 As Dword, Optional ByRef radius As Long ) As iRender

Interface iRenderOutline Guid$("{e966ce5d-f65a-49c2-926d-d6feac369a40}")
	Inherit IUnknown
	Property Get Color1() As iIVColor
	Property Get Radius() As Long
	Property Set Radius( ByRef value As Long )
	Property Get PenWidth() As Long
	Property Set PenWidth( ByVal value As Long )
End Interface

'----------------------------------------------------------------------
' RenderRadio.inc
'----------------------------------------------------------------------
Declare Function NewRenderRadio Lib "infoview.dll" Alias "NEWRENDERRADIO" ( Optional ByRef map As iValueToLong ) As iRender

Interface iRenderRadio Guid$("{ba6516a5-c16a-4ede-8399-e161cd361e28}")
	Inherit IUnknown
	Property Get Map() As iValueToLong
	Property Set Map( ByRef value As iValueToLong )
End Interface

'----------------------------------------------------------------------
' RenderRow.inc
'----------------------------------------------------------------------
Declare Function NewRenderRow Lib "infoview.dll" Alias "NEWRENDERROW" ( value As WString, Optional map As iValueToString, Optional align As Dword, Optional Color As Dword ) As iRender
Declare Function NewSysRenderRow Lib "infoview.dll" Alias "NEWSYSRENDERROW" ( value As WString, Optional align As Dword, Optional Color As Dword ) As iRender

Interface iRenderRow Guid$("{5f9517d8-a4b4-4aca-9103-0b789bb48d8f}")
	Inherit IUnknown
	Property Get Color() As iIVColor
	Property Set Color( ByRef value As iIVColor )
	Property Get Font() As iFont
	Property Get Map() As iValueToString
	Property Set Map( ByRef value As iValueToString )
End Interface

'----------------------------------------------------------------------
' RenderRows.inc
'----------------------------------------------------------------------
Declare Function NewRenderRows Lib "infoview.dll" Alias "NEWRENDERROWS" () As iRender

Interface iRenderRows Guid$("{e107e8e7-2c27-4ca4-8242-29d1cb0b0b04}")
	Inherit IUnknown
	Method Add( ByRef value As iRender )
	Method Clear()
End Interface

'----------------------------------------------------------------------
' RenderSplit.inc
'----------------------------------------------------------------------
Declare Function NewRenderSplit Lib "infoview.dll" Alias "NEWRENDERSPLIT" ( ByVal topHeight As Long, ByVal dir As Long, ByVal c1 As Dword, ByVal c2 As Dword, ByVal c3 As Dword, ByVal c4 As Dword ) As iRender

Interface iRenderSplit Guid$("{d8493414-30f2-4a91-824d-85050f866597}")
	Inherit IUnknown
	Property Get TopHeight() As Long
	Property Set TopHeight( ByRef value As Long )
	Property Get Direction() As Long
	Property Set Direction( ByRef value As Long )
	Property Get Color1() As Dword
	Property Set Color1( ByRef value As Dword )
	Property Get Color2() As Dword
	Property Set Color2( ByRef value As Dword )
	Property Get Color3() As Dword
	Property Set Color3( ByRef value As Dword )
	Property Get Color4() As Dword
	Property Set Color4( ByRef value As Dword )
End Interface

'----------------------------------------------------------------------
' RenderText.inc
'----------------------------------------------------------------------
Declare Function NewRenderText Lib "infoview.dll" Alias "NEWRENDERTEXT" ( value As WString, Optional map As iValueToString, Optional align As Dword, Optional Color As Dword, Optional hFont As iFont ) As iRender
Declare Function NewSysRenderText Lib "infoview.dll" Alias "NEWSYSRENDERTEXT" ( value As WString, Optional align As Dword, Optional Color As Dword, Optional hFont As iFont ) As iRender

Interface iRenderText Guid$("{ff2bb618-6654-423f-a6ff-7f670b95702e}")
	Inherit IUnknown
	Property Get Color() As iIVColor
	Property Set Color( ByRef value As iIVColor )
	Property Get Font() As iFont
	Property Set Font( ByVal value As iFont )
	Property Get Map() As iValueToString
	Property Set Map( ByRef value As iValueToString )
End Interface

Interface iHasFont Guid$("{e2ba5314-8029-4d9a-8255-bba3710a755c}")
	Inherit IUnknown
	Property Get Font() As iFont
	Property Set Font( ByVal value As iFont )
End Interface

'----------------------------------------------------------------------
' RenderTextRotated.inc
'----------------------------------------------------------------------
Declare Function NewRenderTextRotated Lib "infoview.dll" Alias "NEWRENDERTEXTROTATED" ( ByRef value As WString, Optional angle As Long, Optional Color As Dword, Optional face As WString, Optional height As Long, _
					Optional Bold As Long, Optional italic As Long ) As iRender

Interface iRenderTextRotated Guid$("{2509a589-d875-4a2e-9ade-8802d1dff642}")
	Inherit IUnknown
	Property Get Color() As iIVColor
	Property Get Angle() As Long
	Property Set Angle( ByRef value As Long )
	Property Get Face() As WString
	Property Set Face( ByRef value As WString )
	Property Get Height() As Long
	Property Set Height( ByRef value As Long )
	Property Get Bold() As Long
	Property Set Bold( ByRef value As Long )
	Property Get Italic() As Long
	Property Set Italic( ByRef value As Long )
End Interface

'----------------------------------------------------------------------
' RenderThemeHeader.inc
'----------------------------------------------------------------------
Declare Sub Render_OnThemeChanged()
Declare Function NewRenderThemeHeader Lib "infoview.dll" Alias "NEWRENDERTHEMEHEADER" ( ByVal State As Dword ) As iRender

Interface iRenderThemeHeader Guid$("{b25f3e55-677b-4eb1-bd9d-7bf635338208}")
	Inherit IUnknown
	Property Get State() As Dword
	Property Set State( ByRef value As Dword )
End Interface

'----------------------------------------------------------------------
' RenderTransparentImage.inc
'----------------------------------------------------------------------
Declare Function NewRenderTransparentImage Lib "infoview.dll" Alias "NEWRENDERTRANSPARENTIMAGE" ( Optional ByRef Stretch As Long, Optional ByRef map As iValueToLong, Optional ByRef transparentColor As Dword ) As iRender
Declare Sub SetRenderTransparentImage Lib "infoview.dll" Alias "SETRENDERTRANSPARENTIMAGE" ( ByVal obj As iRender, ByVal offset As Long, ByVal hImage As Dword )
Declare Sub SetRenderTransparentImageList Lib "infoview.dll" Alias "SETRENDERTRANSPARENTIMAGELIST" ( ByVal obj As iRender, ByRef Images() As Dword )

Interface iRenderTransparentImage Guid$("{a059f813-791c-4578-bca2-2c3192c93826}")
	Inherit IUnknown
	Property Get Image( ByVal offset As Long ) As Dword
	Property Set Image( ByVal offset As Long, ByVal value As Dword )
	Property Get TransparentColor() As Dword
	Property Set TransparentColor( ByVal value As Dword )
	Property Get Map() As iValueToLong
	Property Set Map( ByRef value As iValueToLong )
	Property Get Stretch() As Dword
	Property Set Stretch( ByVal value As Dword )
End Interface

'----------------------------------------------------------------------
' Send.inc
'----------------------------------------------------------------------
Declare Function NewSend() As iSend

Interface iPublish Guid$("{11d67d09-d3f8-4a14-baa6-6315fe399fc2}")
	Inherit IUnknown
	Method Publish( sender As iSend, ByVal msg As Long, ByVal a As Long, ByVal b As Long )
End Interface

'----------------------------------------------------------------------
' SequentialLayout.inc
'----------------------------------------------------------------------
Declare Function NewSequentialLayout Lib "infoview.dll" Alias "NEWSEQUENTIALLAYOUT" () As iLayout

Interface iSequentialLayout Guid$( "{59884037-f858-4957-a7ad-f7a2a17354e5}")
	Inherit IUnknown
	Property Get IsRowSelection() As Long
	Property Get IsHorizontal() As Long
	Property Set IsHorizontal( ByVal value As Long )
	Method GetAlign( ByVal offset As Long ) As Long
	Property Get DefaultAlign() As Long
	Property Set DefaultAlign( ByRef value As Long )
	Property Get AlignOverride( ByVal offset As Long ) As Long
	Property Set AlignOverride( ByVal offset As Long, ByRef value As Long )
	Method ClearAlignOverride( ByVal offset As Long )
	Property Get IsCurrentItemARow() As Long
	Property Set IsCurrentItemARow( ByVal value As Long )
	Property Get SelectType() As Long
	Property Set SelectType( ByVal value As Long )
	Property Get HotType() As Long
	Property Set HotType( ByVal value As Long )
	Property Get Frozen() As Long
	Property Set Frozen( ByVal value As Long )
	Property Get BackRenderer( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Get ContentRenderer( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Get DrawFocus() As iRender
	Property Set DrawFocus( ByRef value As iRender )
	Property Get DrawOverride() As iUserRender
	Property Set DrawOverride( value As iUserRender )
	Property Get BackDefault( ByVal state As Long ) As iRender
	Property Set BackDefault( ByVal state As Long, ByRef value As iRender )
	Property Get BackOverride( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Set BackOverride( ByVal offset As Long, ByVal state As Long, ByRef value As iRender )
	Method BackOverrideClear( ByVal offset As Long )
	Property Get ContentDefault( ByVal state As Long ) As iRender
	Property Set ContentDefault( ByVal state As Long, ByRef value As iRender )
	Property Get ContentOverride( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Set ContentOverride( ByVal offset As Long, ByVal state As Long, ByRef value As iRender )
	Method ContentOverrideClear( ByVal offset As Long )
	Property Get Gutter() As Long
	Property Set Gutter( ByRef value As Long )
	Property Get SizeDefault() As Long
	Property Set SizeDefault( ByRef value As Long )
	Property Get OtherSize() As Long
	Property Set OtherSize( ByRef value As Long )
	Method GetOtherBounds( ByRef start As Long, ByRef final As Long )
End Interface

'----------------------------------------------------------------------
' SimpleLayout.inc
'----------------------------------------------------------------------
Declare Function NewSimpleLayout Lib "infoview.dll" Alias "NEWSIMPLELAYOUT" () As iLayout

Interface iSimpleLayout Guid$("{cfa231cd-09b0-4cf0-8aaa-89039e8b858d}")
	Inherit IUnknown
	Property Get Def() As WString
	Property Set Def( value As WString )
	Property Get Item() As iSimpLines
	Property Get SelectType() As Long
	Property Set SelectType( ByVal value As Long )
	Property Get HotType() As Long
	Property Set HotType( ByVal value As Long )
	Property Get DrawBackRender( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Get DrawBack( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Set DrawBack( ByVal offset As Long, ByVal state As Long, ByRef value As iRender )
	Method DrawBackClear( ByVal offset As Long )
	Property Get DrawContentRender( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Get DrawContent( ByVal offset As Long, ByVal state As Long ) As iRender
	Property Set DrawContent( ByVal offset As Long, ByVal state As Long, ByRef value As iRender )
	Method DrawContentClear( ByVal offset As Long )
End Interface

'----------------------------------------------------------------------
' SimpLine.inc
'----------------------------------------------------------------------
Declare Function NewSimpLine Lib "infoview.dll" Alias "NEWSIMPLINE" () As iSimpLine

Interface iSimpLine Guid$("{aad26932-c022-4906-ab3b-1004a5992f5a}")
	Inherit IUnknown
	Property Get Count() As Long
	Property Get Item(ByVal index As Long) As iSimpProp
	Property Get FixedWidth() As Long
	Property Get RelativeWidth() As Long
	Property Get FixedHeight() As Long
	Property Get RelativeHeight() As Long
	Method Add( value As iSimpProp ) As Integer
	Method Remove( value As iSimpProp )
	Method Clear()
End Interface

'----------------------------------------------------------------------
' SimpLines.inc
'----------------------------------------------------------------------
Declare Function NewSimpLines Lib "infoview.dll" Alias "NEWSIMPLINES" () As iSimpLines

Interface iSimpLines Guid$("{05bad751-c86b-4c01-a025-8810e9c72e6f}")
	Inherit IUnknown
	Property Get FixedHeight() As Long
	Property Get RelativeHeight() As Long
	Property Get FixedWidth() As Long
	Property Get RelativeWidth() As Long
	Property Get Count() As Long
	Property Get Line(ByVal index As Long) As iSimpLine
	Method Add() As Integer
	Method Clear()
End Interface

'----------------------------------------------------------------------
' SimpProp.inc
'----------------------------------------------------------------------
Declare Function NewSimpProp Lib "infoview.dll" Alias "NEWSIMPPROP" ( c As Long, w As Long, h As Long ) As iSimpProp

Interface iSimpProp Guid$("{7eed1d10-705c-4a3f-aa5b-6c71c6eb63a0}")
	Inherit IUnknown
	Property Get Def() As WString
	Property Get Col() As Long
	Property Set Col( ByRef value As Long )
	Property Get Width() As Long
	Property Set Width( ByRef value As Long )
	Property Get Height() As Long
	Property Set Height( ByRef value As Long )
End Interface

'----------------------------------------------------------------------
' SixRowMapper.inc
'----------------------------------------------------------------------
Declare Function NewSixRows Lib "infoview.dll" Alias "NEWSIXROWS" () As iValueToLong

'----------------------------------------------------------------------
' StateRender.inc
'----------------------------------------------------------------------
Declare Function NewStateRender Lib "infoview.dll" Alias "NEWSTATERENDER" () As iStateRender

Interface iStateRender Guid$("{9ff1e6c4-2a58-4da6-8450-2507781a105f}")
	Inherit IUnknown
	Property Get Item( ByVal stat As Long) As iRender
	Property Set Item( ByVal stat As Long, ByRef value As iRender )
End Interface

'----------------------------------------------------------------------
' Support.inc
'----------------------------------------------------------------------
Declare Function GetNextChildId Lib "infoview.dll" Alias "GETNEXTCHILDID" () As Long
Declare Sub DrawGradientBar Lib "infoview.dll" Alias "DRAWGRADIENTBAR" ( ByVal hdc As Dword, ByRef rc As RECT, ByVal c1 As Dword, ByVal c2 As Dword, ByVal vert As Long )
Declare Function SystemError Lib "infoview.dll" Alias "SYSTEMERROR" () As WString
Declare Sub GetShifts( ByRef sk As ShiftKeys )

'----------------------------------------------------------------------
' SyncDSRowColToIVBase.inc
'----------------------------------------------------------------------
Declare Function NewSyncDSRowColToIVBase Lib "infoview.dll" Alias "NEWSYNCDSROWCOLTOIVBASE" ( ByRef ds As iDataSource, ByRef bs As iIVBase ) As iFeature

Interface iSyncDSRowColToIVBase Guid$("{9e98ceae-33dd-4781-8180-1aaf6efbf3c7}")
	Inherit IUnknown
	Property Get Datasource() As iDataSource
	Property Set Datasource( ByRef value As iDatasource )
	Property Get Base() As iIVBase
	Property Set Base( ByVal value As iIVBase )
End Interface

Interface iFeature Guid$("{68b63c52-0483-4379-96ba-2741c95d1d99}")
	Inherit IUnknown
	Method Execute() As String
End Interface

'----------------------------------------------------------------------
' TableDataSource.inc
'----------------------------------------------------------------------
Declare Function NewDataTableDataSource Lib "infoview.dll" Alias "NEWDATATABLEDATASOURCE" ( Optional dt As iDataTable ) As iDataSource

Interface iDataTableDataSource Guid$("{9700ce15-4961-48e4-a5eb-acd2f30d6304}")
	Inherit IUnknown
	Property Get DataTable() As iDataTable
	Property Set DataTable( ByRef value As iDataTable )
	Property Get Pivot() As Long
	Property Set Pivot( ByVal value As Long )
End Interface

'----------------------------------------------------------------------
' TestDataSource.inc
'----------------------------------------------------------------------
Declare Function NewTestDatasource Lib "infoview.dll" Alias "NEWTESTDATASOURCE" () As iDataSource

Interface iTestDataSource Guid$("{218e518f-0b93-4f28-96dc-674d8ddede85}")
	Inherit IUnknown
	Property Get Pivot() As Long
	Property Set Pivot( ByVal value As Long )
End Interface

'----------------------------------------------------------------------
' TestDemo.inc
'----------------------------------------------------------------------

'----------------------------------------------------------------------
' TestDemoDirect.inc
'----------------------------------------------------------------------

'----------------------------------------------------------------------
' TestSupport.inc
'----------------------------------------------------------------------

'----------------------------------------------------------------------
' WinTrack.inc
'----------------------------------------------------------------------
Declare Function NewWinTrack Lib "infoview.dll" Alias "NEWWINTRACK" () As iWinTrack

Interface iWinTrack Guid$("{2E27A20C-3F8C-405A-8DEA-B03EC6FB0EFC}")
	Inherit IUnknown
	Method Add( ByRef obj As iWin )
	Property Get Count() As Long
	Method Clear()
	Method Remove( ByRef obj As iWin ) As iWin
	Property Get Get( ByVal hWnd As Dword ) As iWin
End Interface
