#Compile Exe "AATest.exe"
#Dim All
#Compiler PBWin 10
#Register All

#Resource Manifest, 1, "theme.xml"

%UNICODE = 1
#Include Once "win32api.inc"
#Include Once "InfoViewEnumAndType.inc"
#Include Once "InfoViewInternal.inc"
#Include Once "ctl\IVBase.inc"
#Include Once "ctl\IVCol.inc"
#Include Once "ctl\IVRowCol.inc"
#Include Once "ctl\IVRow.inc"
#Include Once "datatable\CurrentManager.inc"
#Include Once "datatable\DataColumn.inc"
#Include Once "datatable\DataRow.inc"
#Include Once "datatable\DataTable.inc"
#Include Once "datatable\DataTableShared.inc"
#Include Once "datatable\Dataset.inc"
#Include Once "datatable\Dataview.inc"
#Include Once "datatable\Send.inc"
#Include Once "datatable\TableDataSource.inc"
#Include Once "demo\IVSwitchViews.inc"
#Include Once "demo\EvenRowMapper.inc"
#Include Once "demo\FeatureList.inc"
#Include Once "demo\SixRowMapper.inc"
#Include Once "demo\SyncDSRowColToIVBase.inc"
#Include Once "demo\TestDataSource.inc"
#Include Once "layout\FlowLayout.inc"
#Include Once "layout\SequentialLayout.inc"
#Include Once "layout\SimpleLayout.inc"
#Include Once "layout\SimpProp.inc"
#Include Once "layout\SimpLine.inc"
#Include Once "layout\SimpLines.inc"
#Include Once "layout\PosItem.inc"
#Include Once "layout\PosList.inc"
#Include Once "layout\PositionedLayout.inc"
#Include Once "misc\Bag.inc"
#Include Once "misc\BlankDataSource.inc"
#Include Once "misc\ColorList.inc"
#Include Once "misc\ExtensionList.inc"
#Include Once "misc\Font.inc"
#Include Once "misc\IVColor.inc"
#Include Once "misc\LongiRenderMap.inc"
#Include Once "misc\LongLongMap.inc"
#Include Once "misc\LongStateRenderMap.inc"
#Include Once "misc\StateRender.inc"
#Include Once "misc\Support.inc"
#Include Once "misc\WinTrack.inc"
#Include Once "render\RenderInflate.inc"
#Include Once "render\RenderNothing.inc"
#Include Once "render\RenderOffset.inc"
#Include Once "render\back\RenderButton.inc"
#Include Once "render\back\RenderFill.inc"
#Include Once "render\back\RenderSplit.inc"
#Include Once "render\back\RenderThemeHeader.inc"
#Include Once "render\compound\CompoundSupport.inc"
#Include Once "render\compound\RenderBound.inc"
#Include Once "render\compound\RenderCompound.inc"
#Include Once "render\compound\RenderRows.inc"
#Include Once "render\deco\RenderBar.inc"
#Include Once "render\deco\RenderBevel.inc"
#Include Once "render\deco\RenderFocus.inc"
#Include Once "render\deco\RenderFrame.inc"
#Include Once "render\deco\RenderOutline.inc"
#Include Once "render\value\RenderCheckbox.inc"
#Include Once "render\value\RenderIcon.inc"
#Include Once "render\value\RenderImage.inc"
#Include Once "render\value\RenderRadio.inc"
#Include Once "render\value\RenderRow.inc"
#Include Once "render\value\RenderText.inc"
#Include Once "render\value\RenderTextRotated.inc"
#Include Once "render\value\RenderTransparentImage.inc"

#Resource Icon,     1, "res\blue.ico"
#Resource Icon,     2, "res\green.ico"
#Resource Icon,     3, "res\cyan.ico"
#Resource Icon,     4, "res\red.ico"
#Resource Icon,     5, "res\black.ico"
#Resource Icon,     100, "res\husky.ico"
#Resource Icon,     101, "res\selhusky.ico"

#Resource Bitmap, 1, "res\Background.bmp"
#Resource Bitmap, 2, "res\TileBackground.bmp"
#Resource Bitmap, 3, "res\Logo.bmp"
#Resource Bitmap, 4, "res\Monitor.bmp"
#Resource Res "res\infoview.res"

$TEST_CLASS = "lcTest2"
%CTL_LISTBOX = 100
%CTL_TABLE   = 101
%CTL_LISTCOLOR = 102
%CTL_LISTPART = 103

%LIST_WIDTH = 200

Global hTest As Dword
Global ghWnd As Dword
Global iv As iIVBase
Global vrc As iIVRowCol
Global vc As iIVCol
Global vr As iIVRow

#Include Once "TestSupport.inc"
#Include Once "TestDemo.inc"
#Include Once "TestDemoDirect.inc"


Function PBMain () As Long
	Local rc As RECT
	Local win As iWin
	Local ds As iDataSource
	Local e As iExtend
	Local hWnd As Dword

	hTest = Test_CreateWindow()
	ghWnd = hTest

	GetClientRect( hTest, rc )

	CreateListBox( hTest )

	' Base view container
	win = NewIVBase(hTest, %LIST_WIDTH, 0, rc.Right-%LIST_WIDTH, rc.Bottom, %CTL_TABLE )
	iv = win
	hWnd = win.HWnd

	Call DemoTableMax()

	Call Test_OnSize( hTest, rc.Right, rc.Bottom )
	SetFocus( win.HWnd )

	ShowWindow( hTest, %SW_ShowNormal )
	UpdateWindow( hTest )

	Call Test_Run( hTest )
End Function

Function Test_WndProc( ByVal hTest As Dword, ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long) As Long
	Function = 0
	Select Case As Long wMsg
		Case %WM_SysColorChange:  Call Test_OnSysColorChange( hTest )
		Case %WM_Activate:        Call Test_OnActivate( hTest, wParam ): Exit Function
		Case %WM_Size:            Call Test_OnSize( hTest, Lo(Word, lParam), Hi(Word, lParam) ): Exit Function
		Case %WM_Destroy:
			PostQuitMessage( 0 ): Exit Function
		Case %WM_DrawItem:        Call Test_OnDrawItem( hTest, lParam ): Function = %TRUE: Exit Function: ' Listbox support
		Case %WM_Notify:          Call Test_OnNotify( hTest, lParam ): Exit Function: ' Listbox support

		Case %WM_Command:         Call Test_OnCommand( hTest, Lo(Word, wParam), Hi(Word, wParam), lParam ): Exit Function: ' InfoView
	End Select
	Function = DefWindowProc( hTest, wMsg, wParam, lParam )
End Function

Function Test_OnActivate( ByVal hTest As Dword, ByVal wParam As Long ) As Long
	Call SetAppActiveWindow( IIf&(wParam, hTest, 0 ) )
	Function = %MA_ACTIVATE
End Function

Sub Test_OnSysColorChange( ByVal hTest As Dword )
	Call EnumChildWindows( hTest,  CodePtr( Test_SysColorChange ), 0 ): ' Ensure child controls know of change
End Sub

Function Test_SysColorChange( ByVal hTest As Dword, ByVal lParam As Long ) As Long
	SendMessage( hTest, %WM_SYSCOLORCHANGE, 0, 0 )
	Function = %TRUE
End Function

Sub Test_RegisterClasses()
	Local wc As WNDCLASS
	Local className As WStringZ*20
	Static init As Long

	If init Then Exit Sub: ' Quick check for already registered
	init=-1
	If GetClassInfo(%NULL, $TEST_CLASS, wc) Then Exit Sub: ' Already registered

	className = $TEST_CLASS
	wc.style = 0: '%CS_HREDRAW Or %CS_VREDRAW
	wc.lpfnWndProc = CodePtr( Test_WndProc )
	wc.cbClsExtra = 0
	wc.cbWndExtra = 0: ' No window data
	wc.hInstance = GetModuleHandle( ByVal 0 )
	wc.hIcon = LoadIcon( ByVal %NULL, ByVal %IDI_APPLICATION )
	wc.hCursor = LoadCursor(%NULL, ByVal %IDC_ARROW)
	wc.hbrBackground = GetSysColorBrush(%COLOR_3DFACE): ' %COLOR_3DFACE
	wc.lpszMenuName =  0
	wc.lpszClassName = VarPtr(className)
	If RegisterClass( wc )=0 Then
		MsgBox "RegisterClass for Test failed"
		End
	End If
End Sub

Function Test_CreateWindow() Common As Dword
	Local hTest As Dword

	Call Test_RegisterClasses()
	hTest = CreateWindowEx( 0, $TEST_CLASS, "InfoView Test", %WS_OverlappedWindow Or %WS_ClipChildren Or %WS_Visible, 100, 100, 640, 480, %NULL, 0, GetModuleHandle( ByVal 0 ), ByVal 0 )
	Function = hTest
End Function

Global hawnd As Dword

Sub SetAppActiveWindow( ByVal hWnd As Dword )
	hawnd = hWnd
End Sub

Function Test_Run(ByVal hTest As Long) As Long
	Local msg As tagMSG

	Do While GetMessage( msg, %NULL, 0, 0 )>0
		If IsWindow(hawnd)=0 Or IsDialogMessage( hawnd, msg ) = 0 Then
			TranslateMessage( msg )
			DispatchMessage( msg )
		End If
	Loop
End Function
