
Sub DemoTableMin()
	Local obj As iExtend
	Local o As iIVRowCol
	Local seq As iSequentialLayout
	Local lay As iLayout
	Local hFont As iFont
	Local r As iRender
	Local win As iWin
	Local ds As iDataSource
	Local hds As iHasDataSource

	ds = LoadSample()
	win = iv
	obj = NewIVRowCol( win )
	o = obj

	iv.views.Clear()

	hFont = NewFont( "Arial", 16, 0, 0, 0 )

	' ================================================
	' Vertical setup ( rows )
	' ================================================
	lay = o.VLayout
	seq = lay
	If IsInterface( seq, iSequentialLayout ) Then
		seq.HotType = %IVSelect.None
		seq.SelectType = %IVSelect.None
		seq.IsHorizontal = 0
		seq.IsCurrentItemARow = 1
		seq.Frozen = 0
		seq.SizeDefault = 20
	End If
	lay.YGutter = 0
	lay.SizeOverride( -1 ) = 0: ' No header

	' ================================================
	' Horizontal setup ( cols/cells )
	' ================================================
	lay = o.HLayout
	seq = lay
	If IsInterface( seq, iSequentialLayout ) Then
		seq.HotType = %IVSelect.None
		seq.SelectType = %IVSelect.None
		seq.IsHorizontal = 1
		seq.IsCurrentItemARow = 0
		seq.Frozen = 0
		seq.SizeDefault = 100
	End If
	lay.XGutter = 0
	lay.SizeOverride( -1 ) = 0: ' No header

	' Backs
	r = NewSysRenderFill( %COLOR_WINDOW ):        seq.BackDefault( %IVState.Normal )    = r
	r = NewSysRenderFill( %COLOR_HIGHLIGHT ):     seq.BackDefault( %IVState.Selected )  = r
	r = NewRenderThemeHeader( %IVState.Hot ):     seq.BackDefault( %IVState.Hot )       = r

	' Content
	r = NewSysRenderText( "", %DT_LEFT, %COLOR_WINDOWTEXT, hFont ):       seq.ContentDefault( %IVState.Normal )   = r
	r = NewSysRenderText( "", %DT_LEFT, %COLOR_HIGHLIGHTTEXT, hFont ):    seq.ContentDefault( %IVState.Selected ) = r
	r = NewSysRenderText( "", %DT_LEFT, %COLOR_WINDOWTEXT, hFont ):       seq.ContentDefault( %IVState.hot )      = r

	' No Focus

	' Set view and force paint
	iv.views.Add( obj )
	hds = iv
	hds.DataSource = ds
	iv.ActivateView()
	InvalidateRect( win.HWnd, ByVal %NULL, 0 )
End Sub

Sub DemoTableMax()
	Local obj As iExtend
	Local o As iIVRowCol
	Local seq As iSequentialLayout
	Local lay As iLayout
	Local hFont As iFont
	Local r As iRender
	Local win As iWin
	Local i As Long
	Local ds As iDataSource
	Local hds As iHasDataSource

	ds = LoadSample()
	win = iv
	obj = NewIVRowCol( win )
	o = obj
	o.AllowResize = %IVResize.Both Or %IVResize.HeaderOnly
	r = NewSysRenderFill( %COLOR_BTNFACE, %COLOR_BTNSHADOW ): o.DrawVGrid = r
	r = NewSysRenderFill( %COLOR_BTNFACE, %COLOR_BTNSHADOW, 0, -90 ): o.DrawHGrid = r

	iv.views.Clear()

	hFont = NewFont( "Arial", 16, 0, 0, 0 )

	' ================================================
	' Vertical setup ( rows )
	' ================================================
	lay = o.VLayout
	lay.YGutter = 4

	seq = lay
	If IsInterface( seq, iSequentialLayout ) Then
		seq.HotType = %IVSelect.None
		seq.SelectType = %IVSelect.None
		seq.IsHorizontal = 0
		seq.IsCurrentItemARow = 1
		seq.Frozen = 2
		seq.SizeDefault = 20

		' Frozen
		r = NewRenderFill( RGB(253,222,159) ):
		seq.BackOverride( 0, %IVState.Normal )    = r
		seq.BackOverride( 1, %IVState.Normal )    = r

		' Headers
		r = NewRenderThemeHeader( %IVState.Normal ):  seq.BackOverride( -1, %IVState.Normal ) = r
		r = NewRenderThemeHeader( %IVState.Hot ):     seq.BackOverride( -1, %IVState.Hot ) = r
	End If


	' ================================================
	' Horizontal setup ( cols/cells )
	' ================================================
	lay = o.HLayout
	lay.XGutter = 4

	seq = lay
	If IsInterface( seq, iSequentialLayout ) Then
		seq.HotType = %IVSelect.Content
		seq.SelectType = %IVSelect.Content
		seq.IsHorizontal = 1
		seq.IsCurrentItemARow = 0
		seq.Frozen = 2
		seq.SizeDefault = 100
		seq.DefaultAlign = %IVAlign.Left Or %IVAlign.Top
		seq.AlignOverride( 3 ) = %IVAlign.Right
		seq.AlignOverride( 5 ) = %IVAlign.Center

		' Frozen
		r = NewRenderFill( RGB(253,222,159) ):
		seq.BackOverride( 0, %IVState.Normal )    = r
		seq.BackOverride( 1, %IVState.Normal )    = r

		r = newRenderFill( RGB(253,222,159) ):                   seq.BackOverride( 3, %IVState.Normal ) = r
		r = newRenderFill( RGB(253,226,170), RGB(250,180,33) ):  seq.BackOverride( 5, %IVState.Normal ) = r

		' Backs
		r = NewSysRenderFill( %COLOR_WINDOW ):        seq.BackDefault( %IVState.Normal )    = r
		r = NewSysRenderFill( %COLOR_HIGHLIGHT ):     seq.BackDefault( %IVState.Selected )  = r
		r = NewRenderThemeHeader( %IVState.Hot ):     seq.BackDefault( %IVState.Hot )       = r

		' Headers
		r = NewRenderThemeHeader( %IVState.Normal ):  seq.BackOverride( -1, %IVState.Normal ) = r
		r = NewRenderThemeHeader( %IVState.Hot ):     seq.BackOverride( -1, %IVState.Hot )    = r
		For i = 1 To 10
			lay.SizeOverride( i ) = 50 + i*10
		Next
		' Content
		r = NewSysRenderText( "", %DT_LEFT, %COLOR_WINDOWTEXT, hFont ):       seq.ContentDefault( %IVState.Normal )   = r
		r = NewSysRenderText( "", %DT_LEFT, %COLOR_HIGHLIGHTTEXT, hFont ):    seq.ContentDefault( %IVState.Selected ) = r
		r = NewSysRenderText( "", %DT_LEFT, %COLOR_WINDOWTEXT, hFont ):       seq.ContentDefault( %IVState.hot )      = r

		' Focus
		r = NewRenderFocus():  seq.DrawFocus = r
	End If

	' Set view and force paint
	iv.views.Clear()
	iv.views.Add( obj )
	hds = iv
	hds.DataSource = ds
	iv.ActivateView()
	InvalidateRect( win.HWnd, ByVal %NULL, 0 )
End Sub

Sub DemoListMin()
	Local obj As iExtend
	Local o As iIVRowCol
	Local seq As iSequentialLayout
	Local lay As iLayout
	Local hFont As iFont
	Local r As iRender
	Local win As iWin
	Local ds As iDataSource
	Local hds As iHasDataSource

	ds = LoadSample()
	win = iv
	obj = NewIVRowCol( win )
	o = obj
	ds = LoadSample()

	iv.views.Clear()

	hFont = NewFont( "Arial", 16, 0, 0, 0 )

	' ================================================
	' Vertical setup ( rows )
	' ================================================
	lay = o.VLayout
	seq = lay
	If IsInterface( seq, iSequentialLayout ) Then
		seq.HotType = %IVSelect.None
		seq.SelectType = %IVSelect.Content
		seq.IsHorizontal = 0
		seq.IsCurrentItemARow = 1
		seq.Frozen = 0
		seq.SizeDefault = 20

		' Backs
		r = NewSysRenderFill( %COLOR_WINDOW ):        seq.BackDefault( %IVState.Normal )    = r
		r = NewSysRenderFill( %COLOR_HIGHLIGHT ):     seq.BackDefault( %IVState.Selected )  = r
		'r = NewSysRenderFill( %COLOR_WINDOW ):        seq.BackDefault( %IVState.Hot )       = r
		'r = NewRenderThemeHeader( %IVState.Hot ):     seq.BackDefault( %IVState.Hot )       = r
	End If
	lay.YGutter = 0
	lay.SizeOverride( -1 ) = 0: ' No header

	' ================================================
	' Horizontal setup ( cols/cells )
	' ================================================
	lay = o.HLayout
	seq = lay
	If IsInterface( seq, iSequentialLayout ) Then
		seq.HotType = %IVSelect.None
		seq.SelectType = %IVSelect.None
		seq.IsHorizontal = 1
		seq.IsCurrentItemARow = 0
		seq.Frozen = 0
		seq.SizeDefault = 100
	End If
	lay.XGutter = 0
	lay.SizeOverride( -1 ) = 0: ' No header


	' Content
	r = NewSysRenderText( "", %DT_LEFT, %COLOR_WINDOWTEXT, hFont ):       seq.ContentDefault( %IVState.Normal )   = r
	r = NewSysRenderText( "", %DT_LEFT, %COLOR_HIGHLIGHTTEXT, hFont ):    seq.ContentDefault( %IVState.Selected ) = r
	r = NewSysRenderText( "", %DT_LEFT, %COLOR_WINDOWTEXT, hFont ):       seq.ContentDefault( %IVState.hot )      = r

	' No Focus

	' Set view and force paint
	iv.views.Clear()
	iv.views.Add( obj )
	hds = iv
	hds.DataSource = ds
	iv.ActivateView()
	InvalidateRect( win.HWnd, ByVal %NULL, 0 )
End Sub

Sub DemoListMax()
	Local obj As iExtend
	Local o As iIVRowCol
	Local seq As iSequentialLayout
	Local lay As iLayout
	Local hFont As iFont
	Local r As iRender
	Local win As iWin
	Local i As Long
	Local ds As iDataSource
	Local hds As iHasDataSource

	ds = LoadSample()

	win = iv
	obj = NewIVRowCol( win )
	o = obj
	o.AllowResize = %IVResize.Both Or %IVResize.HeaderOnly
	r = NewSysRenderFill( %COLOR_BTNFACE, %COLOR_BTNSHADOW ): o.DrawVGrid = r
	r = NewSysRenderFill( %COLOR_BTNFACE, %COLOR_BTNSHADOW, 0, -90 ): o.DrawHGrid = r

	iv.views.Clear()

	hFont = NewFont( "Arial", 16, 0, 0, 0 )

	' ================================================
	' Vertical setup ( rows )
	' ================================================
	lay = o.VLayout
	lay.YGutter = 4

	seq = lay
	If IsInterface( seq, iSequentialLayout ) Then
		seq.HotType = %IVSelect.Content
		seq.SelectType = %IVSelect.Content
		seq.IsHorizontal = 0
		seq.IsCurrentItemARow = 1
		seq.Frozen = 2
		seq.SizeDefault = 20

		' Frozen
		r = NewRenderFill( RGB(253,222,159) ):
		seq.BackOverride( 0, %IVState.Normal )    = r
		seq.BackOverride( 1, %IVState.Normal )    = r

		' Headers
		r = NewRenderThemeHeader( %IVState.Normal ):  seq.BackOverride( -1, %IVState.Normal ) = r
		r = NewRenderThemeHeader( %IVState.Hot ):     seq.BackOverride( -1, %IVState.Hot ) = r

		' Backs
		r = NewSysRenderFill( %COLOR_WINDOW ):        seq.BackDefault( %IVState.Normal )    = r
		r = NewSysRenderFill( %COLOR_HIGHLIGHT ):     seq.BackDefault( %IVState.Selected )  = r
		r = NewRenderThemeHeader( %IVState.Hot ):     seq.BackDefault( %IVState.Hot )       = r

	End If

	' ================================================
	' Horizontal setup ( cols/cells )
	' ================================================
	lay = o.HLayout
	lay.XGutter = 4

	seq = lay
	If IsInterface( seq, iSequentialLayout ) Then
		seq.HotType = %IVSelect.Content
		seq.SelectType = %IVSelect.Content
		seq.IsHorizontal = 1
		seq.IsCurrentItemARow = 0
		seq.Frozen = 2
		seq.SizeDefault = 100
		seq.AlignOverride( 3 ) = %IVAlign.Right
		seq.AlignOverride( 5 ) = %IVAlign.Center

		' Frozen
		r = NewRenderFill( RGB(253,222,159) ):
		seq.BackOverride( 0, %IVState.Normal )    = r
		seq.BackOverride( 1, %IVState.Normal )    = r

		r = newRenderFill( RGB(253,222,159) ):                   seq.BackOverride( 3, %IVState.Normal ) = r
		r = newRenderFill( RGB(253,226,170), RGB(250,180,33) ):  seq.BackOverride( 5, %IVState.Normal ) = r

		' Headers
		r = NewRenderThemeHeader( %IVState.Normal ):  seq.BackOverride( -1, %IVState.Normal ) = r
		r = NewRenderThemeHeader( %IVState.Hot ):     seq.BackOverride( -1, %IVState.Hot )    = r
		For i = 1 To 10
			lay.SizeOverride( i ) = 50 + i*10
		Next
		' Content
		r = NewSysRenderText( "", %DT_LEFT, %COLOR_WINDOWTEXT, hFont ):       seq.ContentDefault( %IVState.Normal )   = r
		r = NewSysRenderText( "", %DT_LEFT, %COLOR_HIGHLIGHTTEXT, hFont ):    seq.ContentDefault( %IVState.Selected ) = r
		r = NewSysRenderText( "", %DT_LEFT, %COLOR_WINDOWTEXT, hFont ):       seq.ContentDefault( %IVState.hot )      = r

		' Focus
		r = NewRenderFocus():  seq.DrawFocus = r
	End If

	' Set view and force paint
	iv.views.Clear()
	iv.views.Add( obj )
	hds = iv
	hds.DataSource = ds
	iv.ActivateView()
	InvalidateRect( win.HWnd, ByVal %NULL, 0 )
End Sub

Sub DemoForm()
	Local obj As iExtend
	Local o As iIVCol
	Local seq As iSequentialLayout
	Local lay As iLayout
	Local hFont As iFont
	Local pFont As iFont
	Local r As iRender
	Local p As iRender
	Local b As iRender
	Local c As iRenderCompound
	Local win As iWin
	Local i As Long
	Local ds As iDataSource
	Local hds As iHasDataSource

	ds = LoadSample()

	win = iv
	obj = NewIVCol( win )
	o = obj

	iv.views.Clear()

	hFont = NewFont( "Arial", 16, 0, 0, 0 )
	pFont = NewFont( "Arial", 12, 0, 1, 0 )

	o.CopyHeaders = 1
	r = NewSysRenderFill( %COLOR_BTNFACE ):   o.DrawControlBack = r

	lay = o.Layout
	lay.YGutter = 4
	lay.padTop = 4
	lay.padBottom = 4
	lay.padLeft = 4
	lay.padRight = 4
	lay.SizeOverride( -1 ) = 0

	seq = lay
	If IsInterface( seq, iSequentialLayout ) Then
		seq.HotType = %IVSelect.Content
		seq.SelectType = %IVSelect.Content
		seq.IsHorizontal = 0
		seq.IsCurrentItemARow = 0
		seq.Frozen = 2
		seq.SizeDefault = 17

		' Frozen
		b = NewBevelBack( %IVFrame.SunkenOuter, RGB(253,222,159) )
		r = TextNudge( GetSysColor( %COLOR_WINDOWTEXT ), hFont, 3, b )
		'r = NewSysRenderText( "", %DT_LEFT, %COLOR_WINDOWTEXT, hFont )
		r = LeftPrompt( ds, r, RGB(200,156,3 ), pFont )

		'r = NewRenderFill( RGB(253,222,159) ):
		seq.ContentOverride( 0, %IVState.Normal )    = r
		seq.ContentOverride( 1, %IVState.Normal )    = r

		' Headers
		r = NewRenderNothing()
		seq.BackOverride( -1, %IVState.Normal ) = r
		seq.BackOverride( -1, %IVState.Selected ) = r
		seq.BackOverride( -1, %IVState.Hot ) = r

		' Backs
'    r = NewSysRenderFill( %COLOR_WINDOW ):        seq.BackDefault( %IVState.Normal )    = r
'    r = NewSysRenderFill( %COLOR_HIGHLIGHT ):     seq.BackDefault( %IVState.Selected )  = r
'    r = NewRenderThemeHeader( %IVState.Hot ):     seq.BackDefault( %IVState.Hot )       = r

		' Content
		b = NewBevelBack( %IVFrame.SunkenOuter, GetSysColor( %COLOR_WINDOW) )
		r = TextNudge( GetSysColor( %COLOR_WINDOWTEXT), hFont, 3, b )
		'r = NewSysRenderText( "", %DT_LEFT, %COLOR_WINDOWTEXT, hFont )
		r = LeftPrompt( ds, r, RGB(200,156,3 ), pFont )
		seq.ContentDefault( %IVState.Normal )   = r

		'r = NewSysRenderText( "", %DT_LEFT, %COLOR_HIGHLIGHTTEXT, hFont )
		b = NewBevelBack( %IVFrame.SunkenOuter, GetSysColor( %COLOR_HIGHLIGHT) )
		r = TextNudge( GetSysColor( %COLOR_HIGHLIGHTTEXT), hFont, 3, b )
		r = LeftPrompt( ds, r, RGB(200,156,3 ), pFont )
		seq.ContentDefault( %IVState.Selected ) = r

		'r = NewSysRenderText( "", %DT_LEFT, %COLOR_WINDOWTEXT, hFont )
		b = NewBevelBack( %IVFrame.SunkenOuter, GetSysColor( %COLOR_INFOBK ) )
		r = TextNudge( GetSysColor( %COLOR_WINDOWTEXT), hFont, 3, b )
		r = LeftPrompt( ds, r, RGB(200,156, 3 ), pFont )
		seq.ContentDefault( %IVState.hot )      = r

		' Focus
		r = NewRenderFocus():  seq.DrawFocus = r
	End If

	' Set view and force paint
	iv.views.Clear()
	iv.views.Add( obj )
	hds = iv
	hds.DataSource = ds
	iv.ActivateView()
	InvalidateRect( win.HWnd, ByVal %NULL, 0 )
End Sub

Sub DemoFormImage()
	Local obj As iExtend
	Local o As iIVCol
	Local seq As iSequentialLayout
	Local lay As iLayout
	Local hFont As iFont
	Local pFont As iFont
	Local r As iRender
	Local b As iRender
	Local p As iRender
	Local win As iWin
	Local i As Long
	Local ds As iDataSource
	Local hds As iHasDataSource

	ds = LoadSample()

	win = iv
	obj = NewIVCol( win )
	o = obj

	iv.views.Clear()

	hFont = NewFont( "Arial", 16, 0, 0, 0 )
	pFont = NewFont( "Arial", 12, 0, 0, 0 )

	o.CopyHeaders = 1

	Local hImg As Dword
	r = NewRenderImage( %ImageStretch.Fill)
	hImg = LoadImage( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(1), %IMAGE_BITMAP, 1024, 768, %LR_DEFAULTCOLOR )
	SetRenderImage( r, 0, hImg )
	o.DrawControlBack = r

	lay = o.Layout
	lay.YGutter = 4
	lay.SizeOverride( -1 ) = 0
	lay.padTop = 4
	lay.padBottom = 4
	lay.padLeft = 4
	lay.padRight = 4

	seq = lay
	If IsInterface( seq, iSequentialLayout ) Then
		seq.HotType = %IVSelect.Content
		seq.SelectType = %IVSelect.Content
		seq.IsHorizontal = 0
		seq.IsCurrentItemARow = 0
		seq.Frozen = 2
		seq.SizeDefault = 26

		seq.AlignOverride( -1 ) = %IVAlign.Right

		' Frozen

		' Headers
		r = NewRenderNothing()
		seq.BackOverride( -1, %IVState.Normal ) = r
		seq.BackOverride( -1, %IVState.Selected ) = r
		seq.BackOverride( -1, %IVState.Hot ) = r

		' Backs

		' Content
		r = TextNudge( GetSysColor( %COLOR_WINDOWTEXT), hFont, 4 )
		r = PromptBottom( ds, r, RGB(54,95,145), pFont )
		seq.ContentDefault( %IVState.Normal )   = r

		b = BackNudge( GetSysColor( %COLOR_HIGHLIGHT), 4 )
		r = TextNudge( GetSysColor( %COLOR_HIGHLIGHTTEXT), hFont, 4, b )
		r = PromptBottom( ds, r, RGB(54,95,145), pFont )
		seq.ContentDefault( %IVState.Selected ) = r

		b = BackNudge( GetSysColor( %COLOR_INFOBK), 4 )
		r = TextNudge( GetSysColor( %COLOR_WINDOWTEXT), hFont, 4, b )
		r = PromptBottom( ds, r, RGB(54,95,145), pFont )
		seq.ContentDefault( %IVState.hot )      = r

		' Focus
		r = NewRenderFocus():  seq.DrawFocus = r
	End If

	' Set view and force paint
	iv.views.Clear()
	iv.views.Add( obj )
	hds = iv
	hds.DataSource = ds
	iv.ActivateView()
	InvalidateRect( win.HWnd, ByVal %NULL, 0 )
End Sub

Sub DemoCards()
	Local obj As iExtend
	Local o As iIVRow
	Local flay As iFlowLayout
	Local lay As iLayout
	Local r As iRender
	Local win As iWin
	Local ds As iDataSource
	Local hds As iHasDataSource
	Local dtds As iDataTableDataSource
	Local dt As iDataTable
	Local c As iRenderCompound

	ds = LoadPeople()

	win = iv
	obj = NewIVRow( win )
	o = obj
	lay = o.Layout
	lay.PadLeft = 8
	lay.PadRight = 8
	lay.PadTop = 4
	lay.PadBottom = 4

	flay = lay

	flay.HotType = %IVSelect.Content
	flay.SelectType = %IVSelect.Content
	flay.IsRightDown = 0
	flay.Width = -4: ' 3 cols
	flay.Height = -4: ' 3 rows
	flay.IsCurItemARow = 1
	lay.XGutter = 4
	lay.YGutter = 4

	' Backs
	r = NewRenderCompound()
	c = r
	r = NewRenderFlatBack( RGB(255,255,233), RGB(145,101,0), RGB(252,223,124), 10, -45 ): c.Add( r )
	r = NewRenderIcon( 64, %Position.BottomRight ): c.Add( r )
	SetRenderIcon( r, 0, LoadImage(GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(100), %IMAGE_ICON, 64, 64, 0 ) )
	r = c
	flay.BackDefault( %IVState.Normal )   = r

	r = NewRenderCompound()
	c = r
	r = NewSysRenderFlatBack( %COLOR_HIGHLIGHT, %COLOR_WINDOWTEXT, %COLOR_HIGHLIGHT, 10, -45 ): c.Add( r )
	r = NewRenderIcon( 64, %Position.BottomRight ): c.Add( r )
	SetRenderIcon( r, 0, LoadImage(GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(101), %IMAGE_ICON, 64, 64, 0 ) )
	r = c
	flay.BackDefault( %IVState.Selected )   = r

	r = NewRenderCompound()
	c = r
	r = NewRenderFlatBack( RGB(237,224,225), RGB(69,39,41), RGB(221,193,196), 10, -45 ): c.Add( r )
	r = NewRenderIcon( 64, %Position.BottomRight ): c.Add( r )
	SetRenderIcon( r, 0, LoadImage(GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(100), %IMAGE_ICON, 64, 64, 0 ) )
	r = c
	flay.BackDefault( %IVState.Hot )   = r


	r = SequentialFormBottom( %IVState.Normal, ds ):    flay.ContentDefault( %IVState.Normal )   = r: hds = r: hds.DataSource = ds
	r = SequentialFormBottom( %IVState.Selected, ds ):  flay.ContentDefault( %IVState.Selected ) = r: hds = r: hds.DataSource = ds
	r = SequentialFormBottom( %IVState.Hot, ds ):       flay.ContentDefault( %IVState.Hot )      = r: hds = r: hds.DataSource = ds


	r = NewRenderFocus():  flay.DrawFocus = r

	' Set view and force paint
	iv.views.Clear()
	iv.views.Add( obj )
	hds = iv
	hds.DataSource = ds
	iv.ActivateView()
	InvalidateRect( win.HWnd, ByVal %NULL, 0 )
End Sub

Sub DemoSimpleCards()
	Local obj As iExtend
	Local o As iIVRow
	Local flay As iFlowLayout
	Local lay As iLayout
	Local r As iRender
	Local win As iWin
	Local ds As iDataSource
	Local hds As iHasDataSource
	Local dtds As iDataTableDataSource
	Local dt As iDataTable
	Local c As iRenderCompound

	ds = LoadPeople()

	win = iv
	obj = NewIVRow( win )
	o = obj
	lay = o.Layout
	lay.PadLeft = 8
	lay.PadRight = 8+4
	lay.PadTop = 4
	lay.PadBottom = 4+4

	flay = lay

	flay.HotType = %IVSelect.Content
	flay.SelectType = %IVSelect.Content
	flay.IsRightDown = 0
	flay.Width = -4: ' 3 cols
	flay.Height = 76: ' 3 rows
	flay.IsCurItemARow = 1
	lay.XGutter = 4
	lay.YGutter = 4

	' Backs
	r = NewRenderCompound()
	c = r
	r = NewRenderOffset( 4, 4, 0, 0 ):                                                    c.Add( r )
	r = NewRenderFlatBack( RGB(128,128,128), RGB(128,128,128)):                           c.Add( r )
	r = NewRenderOffset( -4, -4, -4, -4 ):                                                c.Add( r )
	r = NewRenderFlatBack( RGB(255,255,233), RGB(145,101,0), RGB(252,223,124), 0, -45 ):  c.Add( r )
	r = c
	flay.BackDefault( %IVState.Normal )   = r

	r = NewRenderCompound()
	c = r
	r = NewRenderOffset( 4, 4, 0, 0 ):                                                          c.Add( r )
	r = NewRenderFlatBack( RGB(128,128,128), RGB(128,128,128) ):                                c.Add( r )
	r = NewRenderOffset( -4, -4, -4, -4 ):                                                      c.Add( r )
	r = NewSysRenderFlatBack( %COLOR_HIGHLIGHT, %COLOR_WINDOWTEXT, %COLOR_HIGHLIGHT, 0, -45 ):  c.Add( r )
	r = c
	flay.BackDefault( %IVState.Selected )   = r

	r = NewRenderCompound()
	c = r
	r = NewRenderOffset( 4, 4, 0, 0 ):                                                  c.Add( r )
	r = NewRenderFlatBack( RGB(128,128,128), RGB(128,128,128) ):                        c.Add( r )
	r = NewRenderOffset( -4, -4, -4, -4 ):                                              c.Add( r )
	r = NewRenderFlatBack( RGB(237,224,225), RGB(69,39,41), RGB(221,193,196), 0, -45 ): c.Add( r )
	r = c
	flay.BackDefault( %IVState.Hot )   = r

	r = SimpleLayout( %IVState.Normal, ds ):    flay.ContentDefault( %IVState.Normal )   = r: hds = r: hds.DataSource = ds
	r = SimpleLayout( %IVState.Selected, ds ):  flay.ContentDefault( %IVState.Selected ) = r: hds = r: hds.DataSource = ds
	r = SimpleLayout( %IVState.Hot, ds ):       flay.ContentDefault( %IVState.Hot )      = r: hds = r: hds.DataSource = ds

	r = NewRenderFocus():  flay.DrawFocus = r

	' Set view and force paint
	iv.views.Clear()
	iv.views.Add( obj )
	hds = iv
	hds.DataSource = ds
	iv.ActivateView()
	InvalidateRect( win.HWnd, ByVal %NULL, 0 )
End Sub







Sub DemoPositionedCards()
	Local obj As iExtend
	Local o As iIVRow
	Local flay As iFlowLayout
	Local lay As iLayout
	Local r As iRender
	Local win As iWin
	Local ds As iDataSource
	Local hds As iHasDataSource
	Local dtds As iDataTableDataSource
	Local dt As iDataTable
	Local c As iRenderCompound

	ds = LoadPeople()

	win = iv
	obj = NewIVRow( win )
	o = obj
	lay = o.Layout
	lay.PadLeft = 8
	lay.PadRight = 8+4
	lay.PadTop = 4
	lay.PadBottom = 4+4

	flay = lay

	flay.HotType = %IVSelect.Content
	flay.SelectType = %IVSelect.Content
	flay.IsRightDown = 0
	flay.Width = -4: ' 3 cols
	flay.Height = 113: ' 3 rows
	flay.IsCurItemARow = 1
	lay.XGutter = 4
	lay.YGutter = 4

	' Backs
	r = NewRenderCompound()
	c = r
	r = NewRenderOffset( 4, 4, 0, 0 ):                                                    c.Add( r )
	r = NewRenderFlatBack( RGB(128,128,128), RGB(128,128,128)):                           c.Add( r )
	r = NewRenderOffset( -4, -4, -4, -4 ):                                                c.Add( r )
	r = NewRenderFlatBack( RGB(255,255,233), RGB(145,101,0), RGB(252,223,124), 0, -45 ):  c.Add( r )
	r = c
	flay.BackDefault( %IVState.Normal )   = r

	r = NewRenderCompound()
	c = r
	r = NewRenderOffset( 4, 4, 0, 0 ):                                                          c.Add( r )
	r = NewRenderFlatBack( RGB(128,128,128), RGB(128,128,128) ):                                c.Add( r )
	r = NewRenderOffset( -4, -4, -4, -4 ):                                                      c.Add( r )
	r = NewSysRenderFlatBack( %COLOR_HIGHLIGHT, %COLOR_WINDOWTEXT, %COLOR_HIGHLIGHT, 0, -45 ):  c.Add( r )
	r = c
	flay.BackDefault( %IVState.Selected )   = r

	r = NewRenderCompound()
	c = r
	r = NewRenderOffset( 4, 4, 0, 0 ):                                                  c.Add( r )
	r = NewRenderFlatBack( RGB(128,128,128), RGB(128,128,128) ):                        c.Add( r )
	r = NewRenderOffset( -4, -4, -4, -4 ):                                              c.Add( r )
	r = NewRenderFlatBack( RGB(237,224,225), RGB(69,39,41), RGB(221,193,196), 0, -45 ): c.Add( r )
	r = c
	flay.BackDefault( %IVState.Hot )   = r

	r = PositionedLayout( %IVState.Normal, ds ):    flay.ContentDefault( %IVState.Normal )   = r: hds = r: hds.DataSource = ds
	r = PositionedLayout( %IVState.Selected, ds ):  flay.ContentDefault( %IVState.Selected ) = r: hds = r: hds.DataSource = ds
	r = PositionedLayout( %IVState.Hot, ds ):       flay.ContentDefault( %IVState.Hot )      = r: hds = r: hds.DataSource = ds

	r = NewRenderFocus():  flay.DrawFocus = r

	' Set view and force paint
	iv.views.Clear()
	iv.views.Add( obj )
	hds = iv
	hds.DataSource = ds
	iv.ActivateView()
	InvalidateRect( win.HWnd, ByVal %NULL, 0 )
End Sub

Sub DemoCardsFixed()
	Local obj As iExtend
	Local o As iIVRow
	Local flay As iFlowLayout
	Local lay As iLayout
	Local r As iRender
	Local win As iWin
	Local ds As iDataSource
	Local hds As iHasDataSource
	Local dtds As iDataTableDataSource
	Local dt As iDataTable

	ds = LoadPeople()

	' Custom headings
	dtds = ds
	dt = dtds.DataTable
	dt.Column(0).Heading = "Id"
	dt.Column(1).Heading = "First"
	dt.Column(2).Heading = "Last"
	dt.Column(3).Heading = "Phone"
	dt.Column(4).Heading = "Promo"
	dt.Column(5).Heading = "Change"

	win = iv
	obj = NewIVRow( win )
	o = obj

	lay = o.Layout
	lay.PadLeft = 8
	lay.PadRight = 8
	lay.PadTop = 4
	lay.PadBottom = 4

	flay = lay

	flay.HotType = %IVSelect.Content
	flay.SelectType = %IVSelect.Content
	flay.IsRightDown = 1
	flay.Width = 160
	flay.Height = 126
	flay.IsCurItemARow = 1
	lay.XGutter = 4
	lay.YGutter = 4

	r = NewRenderFlatBack( RGB(255,255,233), RGB(145,101,0), RGB(252,223,124), 10, -45 ):       flay.BackDefault( %IVState.Normal )   = r
	r = NewSysRenderFlatBack( %COLOR_HIGHLIGHT, %COLOR_WINDOWTEXT, %COLOR_HIGHLIGHT, 10, -45 ): flay.BackDefault( %IVState.Selected ) = r
	r = NewRenderFlatBack( RGB(237,224,225), RGB(69,39,41), RGB(221,193,196), 10, -45 ):        flay.BackDefault( %IVState.Hot)       = r

	r = SequentialFormLeft( %IVState.Normal, ds ):    flay.ContentDefault( %IVState.Normal )   = r: hds = r:  hds.DataSource = ds
	r = SequentialFormLeft( %IVState.Selected, ds ):  flay.ContentDefault( %IVState.Selected ) = r: hds = r: hds.DataSource = ds
	r = SequentialFormLeft( %IVState.Hot, ds ):       flay.ContentDefault( %IVState.Hot )      = r: hds = r: hds.DataSource = ds


	r = NewRenderFocus():  flay.DrawFocus = r

	' Set view and force paint
	iv.views.Clear()
	iv.views.Add( obj )
	hds = iv
	hds.DataSource = ds
	iv.ActivateView()
	InvalidateRect( win.HWnd, ByVal %NULL, 0 )
End Sub

Function PositionedLayout( ByVal st As Long, ds As iDataSource ) As iRender
	Local lay As iLayout
	Local simp As iPositionedLayout
	Local hFont As iFont
	Local pFont As iFont
	Local rn As iRender
	Local m As iValueToLong
	Local r As iRender
	Local p As iRender
	Local clr As Dword
	Local dtds As iDataTableDataSource
	Local dt As iDataTable
	Local rc As RECT

	' Custom headings
	dtds = ds
	dt = dtds.DataTable

	hFont = NewFont( "Arial", 16, 0, 0, 0 )
	pFont = NewFont( "Arial", 12, 0, 1, 0 )
	dt.Column(0).Heading = "Id"
	dt.Column(4).Heading = "Promo"

	lay = NewPositionedLayout()
	rn = lay
	simp = lay

	' 2 80 char, 2 80 char, 1 80 char
	simp.Def = Build$("1:4:4:80:30:ltr", $CrLf, "2:89:4:80:30:rt", $CrLf, "4:4:39:80:30:lt", $CrLf, "3:89:39:80:30:lrt", $CrLf, "0:4:74:165:30:ltrb")
	SetRect( rc, 0, 0, 174, 113 )
	simp.Layout = rc
	lay.PadLeft = 4
	lay.PadTop = 4
	lay.PadRight = 4
	lay.PadBottom = 4

	simp.HotType = %IVSelect.None
	simp.SelectType = %IVSelect.None
	lay.XGutter = 4
	lay.YGutter = 4

	m = NewSixRows()
	r = NewRenderIcon(16, %Position.TopLeft, m)
	' Add 5 icons (so we have one with no icon, should render blank)
	SetRenderIcon( r, 4, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(5) ) )
	SetRenderIcon( r, 3, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(4) ) )
	SetRenderIcon( r, 2, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(3) ) )
	SetRenderIcon( r, 1, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(2) ) )
	SetRenderIcon( r, 0, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(1) ) )
	r = IconNudge( r, 3 )

	Select Case st
		Case %IVState.Normal:   p = PromptBottom( ds, r, RGB(200,156,4), pFont )
		Case %IVState.Selected: p = PromptBottom( ds, r, GetSysColor( %COLOR_HIGHLIGHTTEXT), pFont )
		Case %IVState.Hot:      p = PromptBottom( ds, r, RGB(0,0,255), pFont )
	End Select
	simp.DrawContent( 5, %IVState.Normal ) = p
	simp.DrawContent( 5, %IVState.Selected ) = p
	simp.DrawContent( 5, %IVState.Hot ) = p


	' Headers
	Select Case st
		Case %IVState.Normal: clr = RGB(255,189,36)
		Case %IVState.Selected: clr = RGB(255,255,255)
		Case %IVState.Hot: clr = RGB(0,0,255)
	End Select
	r = NewRenderBar( clr, %IVSide.Bottom, 1 )
	simp.DrawBack( -1, %IVState.Normal ) = r
	simp.DrawBack( -1, %IVState.Selected ) = r
	simp.DrawBack( -1, %IVState.Hot ) = r

	' Backs

	' Content
	Local c As iRenderCompound
	Local pr As iRender
	Select Case st
		Case %IVState.Normal:
			r = TextNudge( GetSysColor( %COLOR_WINDOWTEXT ), hFont, 4 )
			r = PromptBottom( ds, r, RGB(200,156,4), pFont )
		Case %IVState.Selected:
			r = TextNudge( GetSysColor( %COLOR_HIGHLIGHTTEXT ), hFont, 4 )
			r = PromptBottom( ds, r, GetSysColor( %COLOR_HIGHLIGHTTEXT), pFont )
		Case %IVState.Hot:
			r = TextNudge( RGB(0,0,255), hFont, 4 )
			r = PromptBottom( ds, r, RGB(0,0,255), pFont )
	End Select
	simp.DrawContent( %IVSpecial.Default, %IVState.Normal ) = r
	simp.DrawContent( %IVSpecial.Default, %IVState.Selected ) = r
	simp.DrawContent( %IVSpecial.Default, %IVState.Hot ) = r

	' Focus
	'r = NewRenderFocus():  simp.DrawFocus = r

	Function = rn
End Function


Function SimpleLayout( ByVal st As Long, ds As iDataSource ) As iRender
	Local lay As iLayout
	Local simp As iSimpleLayout
	Local hFont As iFont
	Local pFont As iFont
	Local rn As iRender
	Local m As iValueToLong
	Local r As iRender
	Local p As iRender
	Local clr As Dword
	Local dtds As iDataTableDataSource
	Local dt As iDataTable

	' Custom headings
	dtds = ds
	dt = dtds.DataTable

	hFont = NewFont( "Arial", 16, 0, 0, 0 )
	pFont = NewFont( "Arial", 12, 0, 1, 0 )
	dt.Column(0).Heading = "Id"
	dt.Column(4).Heading = "Promo"

	lay = NewSimpleLayout()
	rn = lay
	simp = lay

	' first line 60/40 split, second line: first and last fixed 40px, with rest to other field
	simp.Def = "1:-6:30,2:-4:30" + $CrLf + "0:40:30,3::30,4:40:30"
	lay.PadLeft = 4
	lay.PadTop = 4
	lay.PadRight = 4
	lay.PadBottom = 4

	simp.HotType = %IVSelect.None
	simp.SelectType = %IVSelect.None
	lay.XGutter = 4
	lay.YGutter = 4

	m = NewSixRows()
	r = NewRenderIcon(16, %Position.TopLeft, m)
	' Add 5 icons (so we have one with no icon, should render blank)
	SetRenderIcon( r, 4, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(5) ) )
	SetRenderIcon( r, 3, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(4) ) )
	SetRenderIcon( r, 2, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(3) ) )
	SetRenderIcon( r, 1, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(2) ) )
	SetRenderIcon( r, 0, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(1) ) )
	r = IconNudge( r, 3 )

	Select Case st
		Case %IVState.Normal:   p = PromptBottom( ds, r, RGB(200,156,4), pFont )
		Case %IVState.Selected: p = PromptBottom( ds, r, GetSysColor( %COLOR_HIGHLIGHTTEXT), pFont )
		Case %IVState.Hot:      p = PromptBottom( ds, r, RGB(0,0,255), pFont )
	End Select
	simp.DrawContent( 5, %IVState.Normal ) = p
	simp.DrawContent( 5, %IVState.Selected ) = p
	simp.DrawContent( 5, %IVState.Hot ) = p


	' Headers
	Select Case st
		Case %IVState.Normal: clr = RGB(255,189,36)
		Case %IVState.Selected: clr = RGB(255,255,255)
		Case %IVState.Hot: clr = RGB(0,0,255)
	End Select
	r = NewRenderBar( clr, %IVSide.Bottom, 1 )
	simp.DrawBack( -1, %IVState.Normal ) = r
	simp.DrawBack( -1, %IVState.Selected ) = r
	simp.DrawBack( -1, %IVState.Hot ) = r

	' Backs

	' Content
	Local c As iRenderCompound
	Local pr As iRender
	Select Case st
		Case %IVState.Normal:
			r = TextNudge( GetSysColor( %COLOR_WINDOWTEXT ), hFont, 4 )
			r = PromptBottom( ds, r, RGB(200,156,4), pFont )
		Case %IVState.Selected:
			r = TextNudge( GetSysColor( %COLOR_HIGHLIGHTTEXT ), hFont, 4 )
			r = PromptBottom( ds, r, GetSysColor( %COLOR_HIGHLIGHTTEXT), pFont )
		Case %IVState.Hot:
			r = TextNudge( RGB(0,0,255), hFont, 4 )
			r = PromptBottom( ds, r, RGB(0,0,255), pFont )
	End Select
	simp.DrawContent( %IVSpecial.Default, %IVState.Normal ) = r
	simp.DrawContent( %IVSpecial.Default, %IVState.Selected ) = r
	simp.DrawContent( %IVSpecial.Default, %IVState.Hot ) = r

	' Focus
	'r = NewRenderFocus():  simp.DrawFocus = r

	Function = rn
End Function

Function SequentialFormLeft( ByVal st As Long, ds As iDataSource ) As iRender
	Local obj As iRender
	Local seq As iSequentialLayout
	Local lay As iLayout
	Local hFont As iFont
	Local pFont As iFont
	Local r As iRender
	Local p As iRender
	Local win As iWin
	Local i As Long
	Local hds As iHasDataSource
	Local ivhds As iHasDataSource
	Local clr As Dword
	Local m As iValueToLong
	Local c As iRenderCompound
	Local pr As iRender

	win = Nothing
	lay = NewSequentialLayout()
	obj = lay

	hds = obj
	hds.DataSource = ds

	hFont = NewFont( "Arial", 16, 0, 0, 0 )
	pFont = NewFont( "Arial", 12, 0, 1, 0 )

	lay = obj
	lay.YGutter = 2
	lay.SizeOverride( -1 ) = 0
	lay.PadLeft = 8
	lay.PadRight = 8
	lay.PadTop = 4
	lay.PadBottom = 4

	seq = lay
	If IsInterface( seq, iSequentialLayout ) Then
		seq.HotType = %IVSelect.None
		seq.SelectType = %IVSelect.None
		seq.IsHorizontal = 0
		seq.IsCurrentItemARow = 0
		seq.Frozen = 0
		seq.Gutter = 4
		seq.SizeDefault = 16


		m = NewSixRows()
		r = NewRenderIcon(16, %Position.TopLeft, m)
		' Add 5 icons (so we have one with no icon, should render blank)
		SetRenderIcon( r, 4, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(5) ) )
		SetRenderIcon( r, 3, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(4) ) )
		SetRenderIcon( r, 2, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(3) ) )
		SetRenderIcon( r, 1, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(2) ) )
		SetRenderIcon( r, 0, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(1) ) )
		r = IconNudge( r, 3 )

		Select Case st
			Case %IVState.Normal
				p = LeftPrompt( ds, r, RGB(200,156,4 ), pFont )
			Case %IVState.Selected
				p = LeftPrompt( ds, r, GetSysColor( %COLOR_HIGHLIGHTTEXT), pFont )
			Case %IVState.Hot
				p = LeftPrompt( ds, r, RGB(0,0,255), pFont )
		End Select
		seq.ContentOverride( 5, %IVState.Normal )   = p
		seq.ContentOverride( 5, %IVState.Selected ) = p
		seq.ContentOverride( 5, %IVState.Hot )      = p

		r = NewRenderNothing()
		seq.BackOverride( 5, %IVState.Normal ) = r
		seq.BackOverride( 5, %IVState.Selected ) = r
		seq.BackOverride( 5, %IVState.Hot ) = r

		' Headers
		seq.AlignOverride( %IVSpecial.Header ) = %IVAlign.Left
		Select Case st
			Case %IVState.Normal: clr = RGB(255,189,36)
			Case %IVState.Selected: clr = RGB(255,255,255)
			Case %IVState.Hot: clr = RGB(0,0,255)
		End Select
		r = NewRenderBar( clr, %IVSide.Bottom, 1 )
		seq.BackOverride( %IVSpecial.Header, %IVState.Normal ) = r
		seq.BackOverride( %IVSpecial.Header, %IVState.Selected ) = r
		seq.BackOverride( %IVSpecial.Header, %IVState.Hot ) = r

		' Backs
'    r = NewRenderBevel( %IVFrame.SunkenOuter ):
'    seq.BackDefault( %IVState.Normal )    = r
'    seq.BackDefault( %IVState.Selected )    = r
'    seq.BackDefault( %IVState.Hot )    = r

		' Content
		Select Case st
			Case %IVState.Normal:
				r = TextNudge( GetSysColor( %COLOR_WINDOWTEXT), hFont, 4 )
				r = LeftPrompt( ds, r, RGB(200,156,4 ), pFont )
			Case %IVState.Selected:
				r = TextNudge( GetSysColor( %COLOR_HIGHLIGHTTEXT), hFont, 4 )
				r = LeftPrompt( ds, r, GetSysColor( %COLOR_HIGHLIGHTTEXT), pFont )
			Case %IVState.Hot:
				r = TextNudge( RGB(0,0,255), hFont, 4 )
				r = LeftPrompt( ds, r, RGB(0,0,255), pFont )
		End Select
		seq.ContentDefault( %IVState.Normal ) = r
		seq.ContentDefault( %IVState.Selected ) = r
		seq.ContentDefault( %IVState.Hot ) = r

		' Focus
		r = NewRenderFocus():  seq.DrawFocus = r
	End If

	Function = obj
End Function

Function LeftPrompt( ds As iDataSource, cRender As iRender, ByVal clrPrompt As Dword, ByVal pFont As iFont ) As iRender
	Local p As iRender
	Local c As iRenderCompound
	Local pr As iRender

	p = NewRenderCompound()
	c = p
	pr = NewRenderOffset( 0, -1, 0, 0 ):                                c.Add( pr )
	pr = NewRenderText( "", ByVal %NULL, %DT_LEFT, clrPrompt, pFont ):  c.Add( pr )
	pr = NewRenderOffset( 0, 1, 0, 0 ):                                 c.Add( pr )

	Function = NewRenderBound( cRender, ds, %IVAlign.Middle Or %IVAlign.Left Or %IVAlign.Reverse, 40, p )
End Function

Function SequentialFormBottom( ByVal st As Long, ds As iDataSource ) As iRender
	Local obj As iRender
	Local seq As iFlowLayout
	Local lay As iLayout
	Local hFont As iFont
	Local pFont As iFont
	Local r As iRender
	Local p As iRender
	Local win As iWin
	Local i As Long
	Local hds As iHasDataSource
	Local ivhds As iHasDataSource
	Local clr As Dword
	Local m As iValueToLong

	win = Nothing
	lay = NewFlowLayout()
	obj = lay

	hds = obj
	hds.DataSource = ds

	hFont = NewFont( "Arial", 16, 0, 0, 0 )
	pFont = NewFont( "Arial", 12, 0, 1, 0 )

	lay.YGutter = 2
	lay.XGutter = 2
	lay.SizeOverride( -1 ) = 0

	lay.PadLeft = 8
	lay.PadRight = 8
	lay.PadTop = 4
	lay.PadBottom = 4

	seq = lay
	If IsInterface( seq, iFlowLayout ) Then
		seq.Width = -2
		seq.Height = 26
		seq.HotType = %IVSelect.None
		seq.SelectType = %IVSelect.None
		seq.IsRightDown = 0
		seq.IsCurItemARow = 0

		m = NewSixRows()
		r = NewRenderIcon(16, %Position.TopLeft, m)
		' Add 5 icons (so we have one with no icon, should render blank)
		SetRenderIcon( r, 4, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(5) ) )
		SetRenderIcon( r, 3, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(4) ) )
		SetRenderIcon( r, 2, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(3) ) )
		SetRenderIcon( r, 1, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(2) ) )
		SetRenderIcon( r, 0, LoadIcon( GetModuleHandle( ByVal 0 ), ByVal MAKEINTRESOURCE(1) ) )
		r = IconNudge( r, 3 )

		Select Case st
			Case %IVState.Normal:   p = PromptBottom( ds, r, RGB(200,156,4), pFont )
			Case %IVState.Selected: p = PromptBottom( ds, r, GetSysColor( %COLOR_HIGHLIGHTTEXT), pFont )
			Case %IVState.Hot:      p = PromptBottom( ds, r, RGB(0,0,255), pFont )
		End Select
		seq.ContentOverride( 5, %IVState.Normal ) = p
		seq.ContentOverride( 5, %IVState.Selected ) = p
		seq.ContentOverride( 5, %IVState.Hot ) = p

'    r = NewRenderNothing()
'    seq.BackOverride( 5, %IVState.Normal ) = r
'    seq.BackOverride( 5, %IVState.Selected ) = r
'    seq.BackOverride( 5, %IVState.Hot ) = r

		' Headers
		'seq.AlignOverride( -1 ) = %IVAlign.Left
		Select Case st
			Case %IVState.Normal: clr = RGB(255,189,36)
			Case %IVState.Selected: clr = RGB(255,255,255)
			Case %IVState.Hot: clr = RGB(0,0,255)
		End Select
		r = NewRenderBar( clr, %IVSide.Bottom, 1 )
		seq.BackOverride( -1, %IVState.Normal ) = r
		seq.BackOverride( -1, %IVState.Selected ) = r
		seq.BackOverride( -1, %IVState.Hot ) = r

		' Backs
'    r = NewRenderBevel( %IVFrame.SunkenOuter ):
'    seq.BackDefault( %IVState.Normal )    = r
'    seq.BackDefault( %IVState.Selected )    = r
'    seq.BackDefault( %IVState.Hot )    = r

		' Content
		Local c As iRenderCompound
		Local pr As iRender
		Select Case st
			Case %IVState.Normal:
				r = TextNudge( GetSysColor( %COLOR_WINDOWTEXT ), hFont, 4 )
				r = PromptBottom( ds, r, RGB(200,156,4), pFont )
			Case %IVState.Selected:
				r = TextNudge( GetSysColor( %COLOR_HIGHLIGHTTEXT ), hFont, 4 )
				'r = NewSysRenderText( "", %DT_LEFT, %COLOR_HIGHLIGHTTEXT, hFont )
				r = PromptBottom( ds, r, GetSysColor( %COLOR_HIGHLIGHTTEXT), pFont )
			Case %IVState.Hot:
				r = TextNudge( RGB(0,0,255), hFont, 4 )
				'r = NewRenderText( "", ByVal %NULL, %DT_LEFT, RGB(0,0,255), hFont )
				r = PromptBottom( ds, r, RGB(0,0,255), pFont )
		End Select
		seq.ContentDefault( %IVState.Normal ) = r
		seq.ContentDefault( %IVState.Selected ) = r
		seq.ContentDefault( %IVState.Hot ) = r

		' Focus
		r = NewRenderFocus():  seq.DrawFocus = r
	End If

	Function = obj
End Function

Function BackNudge( clr As Dword, ByVal amt As Long ) As iRender
	Local p As iRender
	Local c As iRenderCompound
	Local pr As iRender

	p = NewRenderCompound()
	c = p
	pr = NewRenderOffset( 0, 0, 0, -amt ):              c.Add( pr )
	pr = NewRenderFill( clr ):                          c.Add( pr )
	pr = NewRenderOffset( 0, 0, 0, amt ):              c.Add( pr )
	Function = p
End Function

Function IconNudge( rIcon As iRender, ByVal amt As Long ) As iRender
	Local p As iRender
	Local c As iRenderCompound
	Local pr As iRender

	p = NewRenderCompound()
	c = p
	pr = NewRenderOffset( 0, -amt, 0, 0 ):              c.Add( pr )
	c.Add( rIcon )
	pr = NewRenderOffset( 0, -amt, 0, 0 ):              c.Add( pr )
	Function = p
End Function

Function TextNudge( ByVal clrText As Dword, ByVal hFont As iFont, ByVal amt As Long, Optional b As iRender ) As iRender
	Local p As iRender
	Local c As iRenderCompound
	Local pr As iRender

	p = NewRenderCompound()
	c = p
	If IsFalse IsMissing( b ) Then
		c.Add( b )
	End If
	pr = NewRenderOffset( 0, -amt, 0, 0 ):              c.Add( pr )
	pr = NewRenderText( "", ByVal %NULL, %DT_LEFT, clrText, hFont ): c.Add( pr )
	pr = NewRenderOffset( 0, amt, 0, 0 ):               c.Add( pr )
	Function = p
End Function

Function PromptBottom( ds As iDataSource, cRender As iRender, ByVal clrPrompt As Dword, ByVal pFont As iFont ) As iRender
	Local p As iRender
	Local c As iRenderCompound
	Local pr As iRender

	p = NewRenderCompound()
	c = p
	pr = NewRenderOffset( 4, -4, -4, 0 ):                               c.Add( pr )
	pr = NewRenderBar( clrPrompt, %IVSide.Top, 1 ):                     c.Add( pr )
	pr = NewRenderOffset( -4, 0, 4, 0 ):                                c.Add( pr )
	pr = NewRenderText( "", ByVal %NULL, %DT_LEFT, clrPrompt, pFont ):  c.Add( pr )
	pr = NewRenderOffset( 0, 4, 0, 0 ):                                 c.Add( pr )

	Function = NewRenderBound( cRender, ds, %IVAlign.Bottom Or %IVAlign.Left, 10, p )
End Function

'=============================================
' Data
'=============================================
Function LoadPeople() As iDataSource
	Function = LoadDataFile( "People.txt" )
End Function

Function LoadProducts() As iDataSource
	Function = LoadDataFile( "Products.txt" )
End Function

Function LoadSample() As iDataSource
	Dim ds As iDataSource

	ds = NewTestDataSource()
	ds.RowCount = 100
	ds.ColCount = 30
	Function = ds
End Function

Function LoadDataFile( filename As String ) As iDataSource
	Dim dt As iDataTable

	dt = DataTableFromTSV(filename)
	Function = NewDataTableDataSource( dt )
End Function

Function DataTableFromTSV( ByRef filename As String ) As iDataTable
	Local l() As String
	Local n As String
	Local i As Long
	Local dt As iDataTable


	' Name datatable
	n = filename
	i = InStr(-1, n, "." )
	If i>0 Then n = Mid$(n, 1, i-1)

	dt = NewDataTable( n )

	Call LoadFile(filename, l())
	dt.AddDelimetedColumns(l(0), $Tab): ' Use the first row as column names

	For i=1 To UBound(l())
		If Trim$(l(i))<>"" Then dt.AddNewDelimetedRow( l(i), $Tab )
	Next
	Function = dt
End Function

Sub LoadFile( filename As String, ByRef l() As String )
	Local dta As String
	Local cnt As Long

	Open filename For Binary As #1
	Get$ #1, Lof(1), dta
	Close #1

	cnt = ParseCount( dta, $CrLf)
	ReDim l(cnt-1)

	Parse dta, l(), $CrLf
End Sub
