
#Include Once "UxTheme.inc"
#Include Once "VsStyle.inc"
#Include Once "VsSym32.inc"

$IV_CLASS = "lcInfoView"

Global givTrack As iWinTrack

%IVPaintTimer = 101
%IVDragTimer = 102

Sub IVClearTrack() Common
	Local cnt As Long
	cnt = givTrack.Count

	givTrack.Clear()
	givTrack = Nothing
End Sub

Function NewIVBase( ByVal hParent As Dword, _
										Optional ByRef l As Long, _
										Optional ByRef t As Long, _
										Optional ByRef w As Long, _
										Optional ByRef h As Long, _
										Optional ByRef childId As Long ) Common Export As iWin
	Local obj As iWin
	obj = Class "cIVBase"
	obj.Parent = hParent
	If IsFalse IsMissing( l ) And IsFalse IsMissing( t ) Then
		obj.Move( l, t )
	End If
	If IsFalse IsMissing( w ) And IsFalse IsMissing( h ) Then
		obj.Resize( w, h )
	End If
	If IsFalse IsMissing( childId ) Then
		obj.ChildId = childId
	End If
	Function = obj
End Function

Class cIVBase Guid$("{f8d6731b-a1e4-4243-9edf-f6b169a0f471}") Common
	Instance displaymode_ As Long
	Instance curRow_ As Long
	Instance curCol_ As Long
	Instance ds_ As iDataSource
	Instance extensions_ As iExtensionList
	Instance views_ As iExtensionList
	Instance hWnd_ As Dword
	Instance childId_ As Long

	Class Method Create()
		Local e As iExtend
		Local win_ As iWin
		Local base_ As iIVBase

		base_ = Me
		win_ = Me

		If IsFalse IsInterface( givTrack, iWinTrack ) Then
			givTrack = NewWinTrack()
		End If

		views_ = NewExtensionList()

		extensions_ = NewExtensionList()

		Call Me.RegisterClasses()

		childId_ = GetNextChildId()

		hWnd_ = CreateWindowEx( 0, $IV_CLASS, "", %WS_Child Or %WS_TabStop Or %WS_Visible, 0, 0, 10, 10, %HWND_MESSAGE, childId_, GetModuleHandle( ByVal 0), ByVal 0 )

		base_.RowCount = 1
		base_.ColCount = 1
		If IsInterface( givTrack, iWinTrack ) Then
			givTrack.Add( win_ )
		End If
	End Method

	Class Method Destroy()
		views_ = Nothing
		extensions_ = Nothing
	End Method

	Class Method OnDestroy()
		Local win_ As iWin
		win_ = Me
		givTrack.Remove( win_ )
		If IsObject( extensions_ ) Then
			extensions_.Reset()
			While extensions_.Next()
				extensions_.Current.Unextend()
			Wend
			extensions_.Clear()
		End If
		If IsObject( views_ ) Then
			views_.Reset
			While views_.Next()
				views_.Current.Unextend()
			Wend
			views_.Clear()
		End If
		KillTimer( hWnd_, %IVPaintTimer )
		KillTimer( hWnd_, %IVDragTimer )
		ds_ = Nothing
		hWnd_ = 0
	End Method

	Class Method OnActivate( ByVal wParam As Dword) As Long
		If Lo(Word, wParam) <> %WA_INACTIVE Then SetFocus( hWnd_ )
		Method = %MA_ACTIVATE
	End Method

	Class Method OnDlgCode( ByVal vKey As Dword, ByVal ptmsg As tagMSG Ptr ) As Long
		' Adapted from code by Dominic Mitchel
		' http://www.powerbasic.com/support/pbforums/showthread.php?t=47631&page=6
		Local ret As Long
		If IsFalse ptmsg Then Exit Method
		If @ptmsg.message = %WM_KeyUp Then
			Select Case vKey
				Case %VK_A, %VK_ESCAPE, %VK_C
					ret = %DlgC_WantMessage
			End Select
		End If
		If @ptmsg.message = %WM_Char Then
			Select Case vKey
				Case 1, 3, 27
					ret = %DlgC_WantMessage
			End Select
		End If
		If @ptmsg.message = %WM_KeyDown Then
			Select Case vKey
				Case %VK_Left, %VK_Right, %VK_Up, %VK_Down, %VK_Prior, %VK_Next, %VK_Home, %VK_End, %VK_A, %VK_ESCAPE, %VK_C
					ret = %DlgC_WantMessage
			End Select
		End If
		Method = ret
	End Method

	Class Method OnSysColorChange()
		' Ensure any syscolors are updated
		Call IVColor_OnSysColorChange()
	End Method

	Class Method OnThemeChanged()
		Call Render_OnThemeChanged()
	End Method

	Class Method OnMouseMove( ByVal wParam As Dword, ByVal lParam As Dword )
		If IsFalse IsWindow( hWnd_ ) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method
		' IVPaintTimer ensuring window is invalidated once after mouse
		' leaves window.
		SetTimer( hWnd_, %IVPaintTimer, 50, %NULL )
	End Method

	Class Method OnTimer( ByVal timerId As Dword )
		Local cursor As PointAPI
		Local rc As RECT


		If IsFalse IsWindow( hWnd_ ) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		If timerId = %IVPaintTimer Then
			GetCursorPos(cursor)
			MapWindowPoints( %NULL, hWnd_, VarPtr(cursor), 1 )
			GetClientRect( hWnd_, rc )
			If IsFalse PtInRect( rc, cursor ) Then
				InvalidateRect( hWnd_, ByVal %NULL, 0 )
			End If
			KillTimer( hWnd_, %IVPaintTimer )
		End If
	End Method


	Class Method RegisterClasses()
		Static init As Long
		Local wc As WNDCLASSEX
		Local className As WStringZ*20


		If init Then Exit Method
		init = -1
		If GetClassInfoEx(%NULL, $IV_CLASS, wc) Then Exit Method: ' Already registered

		className = $IV_CLASS

		wc.cbsize = SizeOf(wc)
		wc.style = %CS_GLOBALCLASS Or %CS_DBLCLKS
		wc.lpfnWndProc = CodePtr( IV_ControlProc )
		wc.cbClsExtra = 0
		wc.cbWndExtra = 0
		wc.hInstance = GetModuleHandle( ByVal 0 )
		wc.hIcon = %NULL
		wc.hCursor = LoadCursor(%NULL, ByVal %IDC_ARROW)
		wc.hbrBackground = CreateSolidBrush(RGB(255,255,255))
		wc.lpszMenuName =  0
		wc.lpszClassName = VarPtr(className)
		wc.hIconSm = 0
		If RegisterClassEx( wc ) = 0 Then
			MsgBox "Failed to register class " + className
		End If
	End Method

	Interface iIVBase Guid$("{ca082619-262a-4bdc-8799-6179c35ee9ce}")
		Inherit IUnknown

		Property Get Row() As Long
			Property = curRow_
		End Property
		Property Set Row( ByVal value As Long )
			curRow_ = Max&( 0, Min&( Me.RowCount-1, value ) )
		End Property

		Property Get RowCount() As Long
			If IsObject( ds_ ) Then
				Property = ds_.RowCount()
			End If
		End Property
		Property Set RowCount( ByVal value As Long )
			If IsObject( ds_ ) Then
				ds_.RowCount = value
			End If
		End Property

		Property Get Col() As Long
			Property = curCol_
		End Property
		Property Set Col( ByVal value As Long )
			curCol_ = Max&( 0, Min&( Me.ColCount-1, value ) )
		End Property

		Property Get ColCount() As Long
			If IsObject( ds_ ) Then
				Property = ds_.ColCount
			End If
		End Property
		Property Set ColCount( ByVal value As Long )
			If IsObject( ds_ ) Then
				ds_.ColCount = value
			End If
		End Property

		Property Get Views() As iExtensionList
			Property = views_
		End Property
		Property Get Extensions() As iExtensionList
			Property = extensions_
		End Property

		Method ActivateView()
			Local hNorm As Dword
			hNorm = LoadCursor( %NULL, ByVal %IDC_ARROW )
			SetClassLong( hWnd_, %GCL_HCURSOR, hNorm )
			SendMessage( hWnd_, %WM_Activate, 0, 0 )
		End Method
	End Interface
	Interface iWin Guid$("{9880cedb-b3de-4997-b6bb-d6c1178788d8}")
		Inherit IUnknown

		Method Proc( ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long, ByRef ret As Long) As Long
			Local v As iExtend
			Method = -1: ' Handled
			' ret already defaulting to 0

			' Check if extension is handling message
			If IsObject( extensions_ ) Then
				extensions_.Reset()
				While extensions_.Next
					If extensions_.Current.Execute( wMsg, wParam, lParam, ret ) Then Exit Method
				Wend
			End If

			Select Case As Const wMsg
				Case %WM_ThemeChanged:    Call Me.OnThemeChanged()
				Case %WM_Timer:           Call Me.OnTimer( wParam )
				Case %WM_GetDlgCode:
					ret = Me.OnDlgCode( wParam, lParam )
					If ret<>0 Then
						Exit Method
					End If
				Case %WM_MouseActivate:   ret = Me.OnActivate( Mak(Dword, %WA_ACTIVE, 0 )): Exit Method
				Case %WM_SetFocus, %WM_KillFocus: InvalidateRect( hWnd_, ByVal %NULL, 0 ): Exit Method
				Case %WM_Activate:        Call Me.OnActivate( wParam )
				Case %WM_EraseBkGnd:      Exit Method
				Case %WM_SysColorChange:  Call Me.OnSysColorChange(): Exit Method
				Case %WM_MouseMove:       Call Me.OnMouseMove( wParam, lParam )
				Case %WM_Destroy:         Call Me.OnDestroy(): Exit Method
			End Select


			If IsTrue IsObject( views_ ) Then
				' Check if current view is handling message
				If wMsg = %WM_Timer Then
					v = v
				End If
				v = views_.Current
				If IsObject( v ) Then
					If v.Execute( wMsg, wParam, lParam, ret ) Then Exit Method
				End If
			End If

			Method = 0: ' Unhandled
		End Method

		Property Get HWnd() As Dword
			Property = hWnd_
		End Property

		Property Get Parent() As Dword
			Property = GetParent( hWnd_ )
		End Property
		Property Set Parent( ByVal value As Dword )
			SetParent( hWnd_, value )
		End Property

		Method Resize( ByVal w As Long, ByVal h As Long )
			SetWindowPos( hWnd_,  0, 0, 0, w, h, %SWP_NOMOVE Or %SWP_NOZORDER )
		End Method

		Method Move( ByVal l As Long, ByVal t As Long )
			SetWindowPos( hWnd_,  0, l, t, 0, 0, %SWP_NOSIZE Or %SWP_NOZORDER )
		End Method

		Property Get ChildId() As Long
			Property = childId_
		End Property
		Property Set ChildId( ByVal childId As Long )
			childId_ = childId
			SetWindowLong( hWnd_, %GWL_ID, childId )
		End Property
	End Interface
	Interface iHasDatasource Guid$("{33e74a9a-2739-4180-a894-3fc9cd8614b3}")
		Inherit IUnknown

		Property Get DataSource() As iDataSource
			Property = ds_
		End Property
		Property Set DataSource( ByRef value As iDataSource )
			Local hds As iHasDataSource
			Local base_ As iIVBase
			Local e As iExtend
			Local i As Long
			If ObjPtr( value ) <> ObjPtr( ds_ ) Then
				ds_ = value
				base_ = Me
				If IsInterface( base_, iIVBase ) Then
					base_.Row = 0
					base_.Col = 0
					base_.ActivateView()
				End If
				For i=0 To views_.Count - 1
					e = views_.Item(i)
					hds = e
					If IsInterface( hds, iHasDataSource ) Then
						hds.DataSource = ds_
					End If
				Next
			End If
		End Property
	End Interface
End Class

Function GetIV_ControlProc() Common As Dword
	Function = CodePtr( IV_ControlProc )
End Function

Function IV_ControlProc( ByVal hWnd As Dword, ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long) Common As Long
	Local obj As iWin
	Local ret As Long
	If wMsg = %WM_Timer Then
		ret = ret
	End If

	If IsFalse IsObject( givTrack ) Then Exit Function
	obj = givTrack.Get( hWnd )
	If IsInterface( obj, iWin ) Then
		If obj.Proc( wMsg, wParam, lParam, ret ) Then
			Function = ret
			Exit Function
		End If
	End If

	Function = DefWindowProc( hWnd, wMsg, wParam, lParam )
End Function
