%IVDragTimer = 102

Function NewIVCol( win As iWin ) Common Export As iExtend
	Local obj As iExtend
	obj = Class "cIVCol"

	obj.Extend( win )
	Function = obj
End Function

Class cIVCol Guid$("{c8fecdbf-e537-4ade-bb2e-9dfdb5d8bb9d}") Common
	Instance copyHeaders_ As Dword

	Instance drawControlBack As iRender
	Instance layout_ As iLayout
	Instance xpadding_ As Long
	Instance ypadding_ As Long
	Instance dragging_ As Long
	Instance hWnd_ As Dword
	Instance dataSource_ As iDataSource
	Instance padLeft_ As Long
	Instance padRight_ As Long
	Instance padTop_ As Long
	Instance padBottom_ As Long

	Instance drawOverride As iUserRender

	Instance base_ As iIVBase
	Instance ctl_ As iIVCol

	Class Method Create()
		ctl_ = Me

		layout_ = NewSequentialLayout()

		xpadding_ = 4
		ypadding_ = 8
		copyHeaders_ = -1
	End Method
	Class Method Destroy()
	End Method

	Class Method SetHWnds()
		Local lay As iLayout
		lay = drawControlBack: If IsObject(lay) Then lay.HWnd = hWnd_
		lay = layout_:         If IsObject(lay) Then lay.HWnd = hWnd_
	End Method

	Class Method PaintPart( ByVal hdc As Long, ByRef rc As RECT, ByVal r As Long, ByVal c As Long, ByRef value As WString, ByVal part As Long, ByVal state As Long, rn As iRender )
		Local userHandled As Long
		Local e As iExtend
		Local v As iValue
		Local a As iAlign
		Local seq As iSequentialLayout

		If IsInterface( drawOverride, iUserRender ) Then
			e = Me
			userHandled = drawOverride.Render( hdc, rc, r, c, value, part, State, rn )
		End If
		If IsFalse userHandled And IsInterface( rn, iRender ) Then
			v = rn: If IsObject( v ) Then v.Value = value
			seq = layout_
			a = rn:
			If IsObject( a ) And IsObject( seq ) Then
				If r<0 Then
					a.Align = seq.GetAlign( -1 )
				Else
					a.Align = seq.GetAlign( c )
				End If
			End If
			rn.Render( hdc, rc, r, c )
		End If
	End Method

	Class Method FlagForPaint()
		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method
		InvalidateRect( hWnd_, ByVal %NULL, 0 )
	End Method

	Class Method OnPaint()
		Local rn As iRender: ' working renderer
		Local hdc As Dword: ' Paint hdc
		Local ps As PAINTSTRUCT: ' Paint struct
		Local mhdc As Dword: ' Memory hdc
		Local hImg As Dword: ' Memory image
		Local crc As RECT: ' Client rect

		If IsFalse IsObject( base_ ) Then Exit Method
		If IsFalse IsObject( layout_ ) Then Exit Method
		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		hdc = BeginPaint( hWnd_, ps )

		GetClientRect( hWnd_, crc )

		hImg = CreateCompatibleBitmap( hdc, crc.Right, crc.Bottom )
		mhdc = CreateCompatibleDC( hdc )
		SelectObject( mhdc, hImg )

		rn = Me
		rn.Render( mhdc, crc, base_.Row, 0 )

		GetClientRect( hWnd_, crc )
		Call BitBlt( hdc, 0,0, crc.right, crc.bottom, mhdc, 0, 0, %SRCCOPY )
		DeleteDc( mhdc )
		DeleteObject( hImg )
		EndPaint( hWnd_, ps )
	End Method

	Class Method OnSize( ByVal wParam As Dword )
		Local si As SCROLLINFO
		Local rc As RECT

		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		GetClientRect( hWnd_, rc )
		rc.Top += ypadding_: rc.Bottom -= ypadding_
		layout_.EnsureLayoutUpdated( rc )

		si.cbSize = SizeOf(si)
		si.fMask = %SIF_All: '%SIF_Range Or %SIF_Page Or %SIF_Pos

		GetScrollInfo( hWnd_, %SB_Horz, si)
		If si.nMin<>0 Or si.nMax<>0 Or si.nPage<>0 Then
			si.nMin = 0
			si.nMax = 0
			si.nPage = 0
			SetScrollInfo( hWnd_, %SB_Horz, si, %TRUE)
		End If

		GetScrollInfo( hWnd_, %SB_Vert, si)
		si.nMin = layout_.MinFirst
		si.nMax = layout_.ItemCount - 1
		si.nPage = Max&( 0, Min&( layout_.PageItemCount, layout_.ItemCount-layout_.MinFirst+1 ) )
		Local v As WString
		v = Str$(si.nMin) + ", " + Str$(si.nMax) + ", " + Str$(si.nPage) + ", " + Str$(layout_.VisibleCount)
		SetWindowText( GetParent( hWnd_ ), ByVal StrPtr(v) )
		SetScrollInfo( hWnd_, %SB_Vert, si, %TRUE)

		Me.FlagForPaint()
	End Method

	Class Method OnVScroll( ByVal wParam As Long ) As String
		layout_.FirstItem = Me.OnScroll( %SB_Vert, wParam )
		Me.OnSize( wParam )
		Me.FlagForPaint()
	End Method

	Class Method OnScroll(ByVal pDirection As Long, ByVal scrollType As Long) As Long
		Local si As SCROLLINFO
		Local rc As RECT
		Local i As Long
		Local w As Long

		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		si.cbSize = SizeOf(si)
		si.fMask = %SIF_All
		GetScrollInfo( hWnd_, pDirection, si)
		Select Case LoWrd(scrollType)
			Case %SB_Top:        si.nPos = si.nMin
			Case %SB_Bottom:     si.nPos = si.nMax
			Case %SB_LineUp:     Decr si.nPos
			Case %SB_LineDown:   Incr si.nPos
			Case %SB_PageUp:     si.nPos -= si.nPage
			Case %SB_PageDown:   si.nPos += si.nPage
			Case %SB_ThumbTrack: si.nPos = si.nTrackPos
		End Select
		SetScrollPos( hWnd_, pDirection, si.nPos, %TRUE)
		Method = GetScrollPos( hWnd_, pDirection )
	End Method

	Class Method OnMouseWheel( ByVal wParam As Dword )
		Local dir As Dword
		Local r As Long
		Local rc As RECT
		Local cursor As Point

		If IsFalse IsObject( base_ ) Then Exit Method
		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		GetClientRect( hWnd_, rc )
		GetCursorPos(cursor)
		MapWindowPoints( %NULL, hWnd_, VarPtr(cursor), 1 )

		If IsFalse PtInRect( rc, cursor ) Then Exit Method
		If GetFocus()<>hWnd_ Then Exit Method

		If (Lo(Word, wParam) And %MK_CONTROL)=0 Then
			dir = IIf&( Hi( Integer, wParam ) < 0, 1, -1 )
			r = base_.Row + dir
			r = Max&( 0, Min&( base_.RowCount-1, r ) )
			base_.Row = r
			layout_.OtherItem = r
			Me.FlagForPaint()
		Else
			dir = IIf&( Hi( Integer, wParam ) < 0, %SB_LineDown, %SB_LineUp )
			Call Me.OnVScroll( dir )
		End If
	End Method

	Class Method OnMouseMove( ByVal wParam As Long, ByVal x As Long, ByVal y As Long ) As String
		Local c As Long
		Local rc As RECT
		Local crc As RECT
		Local t As Long
		Local pt As Point

		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		If layout_.IsHotTracking Then Me.FlagForPaint()

		If dragging_ Then
			GetClientRect( hWnd_, rc )

			' Get past headers and frozen lines
			For t=0 To layout_.VisibleCount-1
				If layout_.ItemIndex( t ) >= layout_.FirstItem Then
					layout_.GetRect( t, crc )
					rc.Top = crc.Top
					Exit For
				End If
			Next

			pt.x = x
			pt.y = y

			If PtInRect( rc, pt ) Then
				' Point is in rect
				' Span all content rows
				layout_.SetOtherBounds( rc.Left, rc.Right )
				c = layout_.Hit( x, y )
				If c<0 Then c = layout_.VisibleCount-1
				c = layout_.ItemIndex( c )
				If c<0 Then c=layout_.CurItem

				Me.Goto( base_.Row, c )
				Exit Method:
			End If

			' Only use timer if mouse isn't moving
			SetTimer( hWnd_, %IVDragTimer, 100, 0 )
			c = layout_.CurItem

			' Point is outside window
			If y<rc.Top Then
				Decr c
			ElseIf y>rc.Bottom Then
				Incr c
			End If
			Me.Goto( base_.Row, c )
			Exit Method
		End If
	End Method

	Class Method OnMouseUp( ByVal x As Long, ByVal y As Long ) As String
		If dragging_ Then
			dragging_ = 0
			ReleaseCapture()
			If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method
			KillTimer( hWnd_, %IVDragTimer )
			Exit Method
		End If
	End Method

	Class Method OnMouseDown( ByVal wParam As Long, ByVal x As Long, ByVal y As Long )
		Local c As Long

		c = layout_.Hit( x, y )
		c = layout_.ItemIndex( c )
		If c > -1 Then
			base_.Col = c
			layout_.CurItem = c
			If (wParam And %MK_SHIFT)=0 Then layout_.SelStart = c
			dragging_ = -1
			If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method
			SetCapture( hWnd_ )
			Me.FlagForPaint()
		End If
	End Method

	Class Method OnActivate()
		Local rc As RECT

		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method
		GetClientRect( hWnd_, rc )
		layout_.RequestLayoutUpdate( rc )
		Me.Goto( base_.Row, base_.Col )
		layout_.SelStart = layout_.CurItem
		layout_.FirstItem = base_.Col
		Me.OnSize( Mak(Dword, rc.Right, rc.Bottom ) )
	End Method

	Class Method OnTimer( ByVal timerId As Dword )
		Local cursor As PointAPI

		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method
		If timerId = %IVDragTimer Then
			GetCursorPos(cursor)
			MapWindowPoints( %NULL, hWnd_, VarPtr(cursor), 1 )
			SendMessage( hWnd_, %WM_MouseMove, 0, Mak(Dword, cursor.x, cursor.y)  ): ' Synthetic mouse move :)
		End If
	End Method

	Class Method GoTo( ByVal r As Long, ByVal c As Long )
		Local msg As TblNotify
		Local rc As RECT
		Local lr As Long
		Local lc As Long

		If IsFalse IsObject( base_ ) Then Exit Method
		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		c = Max&( 0, Min&( layout_.ItemCount-1, c ) )
		r = Max&( 0, Min&( base_.RowCount-1, r ) )

		lr = base_.Row
		lc = layout_.CurItem
		GetClientRect( hWnd_, rc )
		If lc<>c And c<>-1 Then
			layout_.GotoItem( c )
			rc.Top += ypadding_: rc.Bottom -= ypadding_
			layout_.EnsureLayoutUpdated( rc )
			SetScrollPos( hWnd_, %SB_Vert, layout_.FirstItem, %TRUE)
			base_.Col = c
		End If

		base_.Row = r
		layout_.OtherItem = r

		If lc<>c Or lr<>r Then
			Me.FlagForPaint()
			msg.hdr.code = %TBN_CellChg
			msg.hdr.idFrom = GetDlgCtrlID( hWnd_ )
			msg.hdr.hWndFrom = hWnd_
			msg.r = r
			msg.c = c

			SendMessage( GetParent(hWnd_), %WM_Notify, hWnd_, VarPtr(msg)  )
		End If
	End Method

	Class Method OnCopy()
		Local r As Long
		Local c As Long
		Local sc As Long
		Local ec As Long
		Local tx As WString
		Local sb As IStringBuilderW

		If Not IsObject( base_ ) Then Exit Method
		If Not IsObject( dataSource_ ) Then Exit Method

		sb = Class "StringBuilderW"

		r = base_.Row
		sc = layout_.SelStart
		ec = layout_.CurItem
		If sc>ec Then Swap sc, ec

		For c=sc To ec
			If copyHeaders_ Then
				sb.Add( dataSource_.Value( -1, c ) )
				sb.Add( $Tab )
			End If
			sb.Add( dataSource_.Value( r, c ) )
			sb.Add( $CrLf )
		Next
		Clipboard Reset
		Clipboard Set Text sb.String
	End Method

	Class Method OnKeyDown( ByVal vKey As Dword )
		Local sk As ShiftKeys
		Local r As Long
		Local c As Long
		Local rc As RECT

		If IsFalse IsObject( base_ ) Then Exit Method
		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		GetClientRect( hWnd_, rc )
		Call GetShifts( sk )
		r = base_.Row
		c = base_.Col

		Select Case vKey
			Case %VK_A
				' Select All
				layout_.SelStart = layout_.ItemCount-1
				layout_.CurItem = 0
				layout_.FirstItem = 0
				base_.Col = 0
				rc.Top += ypadding_: rc.Bottom -= ypadding_
				layout_.RequestLayoutUpdate( rc )
				Exit Method
			Case %VK_ESCAPE
				' Cancel select
				layout_.SelStart = layout_.CurItem
				layout_.GotoItem( layout_.CurItem )
				Exit Method
			Case %VK_C
				' Copy
				If sk.isCtrl And Not (sk.isAlt Or sk.isShift) Then
					Call Me.OnCopy()
				End If
				Exit Method
			Case %VK_UP
				If Not (sk.isCtrl Or sk.isAlt) Then
					Decr c
				Else
					Exit Method
				End If
			Case %VK_DOWN
				If Not (sk.isCtrl Or sk.isAlt) Then
					Incr c
				Else
					Exit Method
				End If
			Case %VK_PRIOR:
				If Not (sk.isCtrl Or sk.isAlt) Then
					Decr r
				Else
					Exit Method
				End If
			Case %VK_NEXT:
				If Not (sk.isCtrl Or sk.isAlt) Then
					Incr r
				Else
					Exit Method
				End If
			Case %VK_END:
				If Not (sk.isCtrl Or sk.isAlt) Then
					c = layout_.ItemCount - 1
				ElseIf sk.isCtrl And Not sk.isAlt Then
					c = layout_.ItemCount - 1
					r = base_.RowCount - 1
				Else
					Exit Method
				End If
			Case %VK_HOME
				If Not (sk.isCtrl Or sk.isAlt) Then
					c = 0
				ElseIf sk.isCtrl And Not sk.isAlt Then
					c = 0
					r = 0
				Else
					Exit Method
				End If
			Case Else
				Exit Method
		End Select
		Me.Goto( r, c )
		If Not sk.isShift Then layout_.SelStart = layout_.CurItem
	End Method

	Interface iIVCol Guid$("{8f4b4ef3-665d-4824-8221-90f5e6167bf4}")
		Inherit IUnknown

		Property Get Layout() As iLayout
			Property = layout_
		End Property
		Property Set Layout( ByRef value As iLayout )
			Local rc As RECT
			If IsInterface( value, iLayout ) And ObjPtr( value ) <> ObjPtr( layout_ ) Then
				layout_ = value
				layout_.HWnd = hWnd_
				If IsFalse IsWindow( hWnd_ ) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Property
				GetClientRect( hWnd_, rc )
				layout_.RequestLayoutUpdate( rc )
			End If
		End Property

		Property Get CopyHeaders() As Long
			Property = copyHeaders_
		End Property
		Property Set CopyHeaders( ByVal value As Long )
			copyHeaders_ = IIf&( value, -1, 0 )
		End Property

		Property Get DrawControlBack() As iRender
			Property = drawControlBack
		End Property
		Property Set DrawControlBack( ByRef value As iRender )
			If ObjPtr( value ) <> ObjPtr( drawControlBack ) Then
				drawControlBack = value
				Call Me.SetHwnds()
				Me.FlagForPaint()
			End If
		End Property
	End Interface

	Interface iExtend Guid$("{071a4670-b6c6-4fd2-8d44-5d4caa0af66b}")
		Inherit IUnknown

		Method Extend( ByRef value As iWin )
			base_ = value
			If IsTrue IsInterface( value, iWin ) Then
				hWnd_ = value.hWnd
				Call Me.SetHwnds()
			End If
		End Method

		Method Unextend()
			base_ = Nothing
			ctl_ = Nothing
		End Method

		Method Execute( ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long, ByRef ret As Long) As Long
			Method = -1: ' Handled
			' ret already defaulting to 0

			Select Case As Const wMsg
				Case %WM_Activate:        Call Me.OnActivate(): Exit Method
				Case %WM_Paint:           Call Me.OnPaint()
				Case %WM_Size:            Call Me.OnSize( lParam ): Exit Method
				Case %WM_VScroll:         Call Me.OnVScroll( wParam ): Exit Method
				Case %WM_MouseWheel:      Call Me.OnMouseWheel( wParam ): Exit Method
				Case %WM_MouseMove:       Call Me.OnMouseMove( wParam, Lo(Integer, lParam), Hi(Integer, lParam) ): Exit Method
				Case %WM_Timer:           Call Me.OnTimer( wParam )
				Case %WM_LButtonDown:     Call Me.OnMouseDown( wParam, Lo(Integer, lParam), Hi(Integer, lParam) ): Exit Method
				Case %WM_LButtonUp:       Call Me.OnMouseUp( Lo(Integer, lParam), Hi(Integer, lParam) ): Exit Method
				Case %WM_KeyDown:         Call Me.OnKeyDown( wParam ): Exit Method
			End Select
			Method = 0: ' Unhandled
		End Method
	End Interface
	Interface iHasDatasource Guid$("{33e74a9a-2739-4180-a894-3fc9cd8614b3}")
		Inherit IUnknown

		Property Get DataSource() As iDataSource
			Property = dataSource_
		End Property
		Property Set DataSource( ByRef value As iDataSource )
			Local hds As iHasDatasource
			dataSource_ = value
			hds = layout_: If IsTrue IsInterface( hds, iHasDataSource ) Then hds.DataSource = value
		End Property
	End Interface

	Interface iLayout Guid$( "{b87daa5f-0140-4b31-8bd1-ff4f0c56e666}")
		Inherit IUnknown

		Property Get PadLeft() As Long
			Property = padleft_
		End Property
		Property Set PadLeft( ByRef value As Long )
			padleft_ = value
		End Property

		Property Get PadTop() As Long
			Property = padtop_
		End Property
		Property Set PadTop( ByRef value As Long )
			padtop_ = value
		End Property

		Property Get PadRight() As Long
			Property = padright_
		End Property
		Property Set PadRight( ByRef value As Long )
			padright_ = value
		End Property

		Property Get PadBottom() As Long
			Property = padbottom_
		End Property
		Property Set PadBottom( ByRef value As Long )
			padbottom_ = value
		End Property

		Property Get OtherLayout() As iLayout
			Property = layout_.OtherLayout
		End Property
		Property Set OtherLayout( value As iLayout )
			layout_.OtherLayout = value
		End Property

		Property Get SuspendPaint() As Long
			Property = layout_.SuspendPaint
		End Property
		Property Set SuspendPaint( ByVal value As Long )
			layout_.SuspendPaint = value
		End Property

		Property Get XGutter() As Long
			Property = layout_.XGutter
		End Property
		Property Set XGutter( ByRef value As Long )
			layout_.XGutter = value
		End Property

		Property Get YGutter() As Long
			Property = layout_.YGutter
		End Property
		Property Set YGutter( ByRef value As Long )
			layout_.YGutter = value
		End Property

		Property Get CurItem() As Long
			Property = layout_.CurItem
		End Property
		Property Set CurItem( ByVal value As Long )
			layout_.CurItem = value
		End Property

		Property Get OtherItem() As Long
			Property = layout_.OtherItem
		End Property
		Property Set OtherItem( ByVal value As Long )
			layout_.OtherItem = value
		End Property

		Property Get OtherItemCurrent() As Long
			Property = layout_.OtherItemCurrent
		End Property
		Property Set OtherItemCurrent( ByVal value As Long )
			layout_.OtherItemCurrent = value
		End Property

		Method SetOtherBounds( ByVal start As Long, ByVal final As Long  )
			layout_.SetOtherBounds( start, final )
		End Method

		Property Get IsHotTracking() As Long
			Property = layout_.IsHotTracking
		End Property

		Property Get HWnd() As Dword
			Property = hWnd_
		End Property
		Property Set HWnd( ByVal value As Dword )
			hWnd_ = value
			Call Me.SetHwnds()
		End Property

		Method GotoItem( ByVal offset As Long )
			layout_.GotoItem( offset )
		End Method

		Property Get SizeItem( ByVal offset As Long ) As Long
			Property = layout_.SizeItem( offset )
		End Property

		Property Get SizeOverride( ByVal offset As Long ) As Long
			Property = layout_.SizeOverride(offset)
		End Property
		Property Set SizeOverride( ByVal offset As Long, ByVal value As Long ): ' <0 = remove custom size
			layout_.SizeOverride(offset) = value
		End Property
		Method SizeOverrideClear( ByVal offset As Long )
			layout_.SizeOverrideClear( offset )
		End Method

		Property Get FirstItem() As Long
			Property = layout_.FirstItem
		End Property
		Property Set FirstItem( value As Long )
			layout_.FirstItem = value
		End Property

		Property Get MinFirst() As Long
			Property = layout_.MinFirst
		End Property
		Property Get MaxFirst() As Long
			Property = layout_.MaxFirst
		End Property

		Property Get SelStart() As Long
			Property = layout_.SelStart
		End Property
		Property Set SelStart( ByVal value As Long )
			layout_.SelStart = value
		End Property

		Property Get ItemCount() As Long
			Property = layout_.ItemCount
		End Property

		Property Get VisibleCount() As Long
			Property = layout_.VisibleCount
		End Property
		Property Get PageItemCount() As Long
			Property = layout_.PageItemCount
		End Property

		Property Get ItemIndex( ByVal offset As Long ) As Long
			Property = layout_.ItemIndex(offset)
		End Property

		Method GetFullBounds( rc As RECT )
			layout_.GetFullBounds( rc )
		End Method

		Method GetDrawnBounds( rc As RECT )
			layout_.GetDrawnBounds( rc )
		End Method

		Method GetRect( ByVal offset As Long, rc As RECT )
			layout_.GetRect( offset, rc )
		End Method

		Method GetBorder( ByVal x As Long, ByVal y As Long ) As Long
			Method = layout_.GetBorder( x, y )
		End Method

		Method Hit( ByVal x As Long, ByVal y As Long ) As Long
			Method = layout_.Hit( x, y )
		End Method
		Method EnsureLayoutUpdated( ByRef newBounds As RECT )
			layout_.EnsureLayoutUpdated( newBounds )
		End Method
		Method RequestLayoutUpdate( ByRef newBounds As RECT )
			layout_.RequestLayoutUpdate( newBounds )
		End Method
	End Interface

	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local crc As RECT
			Local rn As iRender: ' working renderer
			Local rw As Long: ' Row
			Local cl As Long
			Local hClipRgn As Dword
			Local pRgn As Dword
			Local hPrevRgn As Dword
			Local x As Long

			layout_.SuspendPaint = 1
			layout_.HWnd = hWnd_
			layout_.EnsureLayoutUpdated( rc )

			hPrevRgn = CreateRectRgnIndirect( rc )
			If IsFalse GetClipRgn( hdc, hPrevRgn ) Then
				DeleteObject( hPrevRgn )
				hPrevRgn = 0
			End If
			hClipRgn = CreateRectRgnIndirect( rc )
			SelectClipRgn( hdc, hClipRgn )

			' Draw background
			CopyRect( crc, rc )
			Call Me.PaintPart( hdc, crc, 0, 0, "", %IVPart.ControlBack, %IVState.Normal, drawControlBack )

			rw = layout_.OtherItem
			cl = layout_.CurItem
			rn = layout_

			x = crc.Left

			' Draw columns
			CopyRect( crc, rc )
			crc.Left += layout_.XGutter: crc.Right -= layout_.XGutter
			crc.Top += layout_.YGutter: crc.Bottom -= layout_.YGutter
			layout_.SetOtherBounds( x, crc.Right )
			layout_.OtherItem = r
			Call Me.PaintPart( hdc, crc, r, 0, "", %IVPart.Content, %IVState.Normal, rn )
			'rn.Render( hdc, crc, rw, 0 )

			layout_.OtherItem = rw
			layout_.SetOtherBounds( crc.Left, crc.Right )
			layout_.SuspendPaint = 0

			If hPrevRgn Then
				SelectClipRgn( hdc, hPrevRgn )
				DeleteObject( hPrevRgn )
			End If
			DeleteObject( hClipRgn )
		End Method
	End Interface
End Class
