%IVDragTimer = 102

' Auto-scrolling pointers from Chris Boss and Michael Mattias
' http://www.powerbasic.com/support/pbforums/showthread.php?t=48568
Function NewIVRow( win As iWin ) Common Export As iExtend
	Local obj As iExtend

	obj = Class "cIVRow"

	obj.Extend( win )
	Function = obj
End Function

Class cIVRow Guid$("{7b359a00-534a-45c9-98ec-6a184f115da2}") Common

	Instance drawControlBack As iRender
	Instance layout_ As iLayout
	Instance dragging_ As Long: ' 0= not dragging
	Instance copyHeaders_ As Long
	Instance hWnd_ As Dword

	Instance base_ As iIVBase
	Instance crd_ As iIVRow
	Instance ds_ As iDataSource

	Class Method Create()
		Local i As Long
		Local r As iRender

		crd_ = Me
		copyHeaders_ = -1

		layout_ = NewFlowLayout()

		drawControlBack = NewSysRenderFill( %COLOR_BTNFACE )
	End Method
	Class Method Destroy()
	End Method

	Class Method SetHWnds()
		Local lay As iLayout
		lay = drawControlBack: If IsObject( lay ) Then lay.HWnd = hWnd_
		lay = layout_:         If IsObject( lay ) Then lay.HWnd = hWnd_
	End Method
	Class Method FlagForPaint()
		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method
		InvalidateRect( hWnd_, ByVal %NULL, 0 )
	End Method

	Class Method PaintPart( ByVal hdc As Long, ByRef rc As RECT, ByVal r As Long, ByVal c As Long, ByRef value As WString, ByVal part As Long, ByVal state As Long, rn As iRender )
		Local e As iExtend
		Local v As iValue

		If IsInterface( rn, iRender ) Then
			v = rn: If IsObject( v ) Then v.Value = value
			rn.Render( hdc, rc, r, c )
		End If
	End Method

	Class Method OnPaint()
		Local crc As RECT: ' Client rect
		Local hdc As Dword: ' Paint hdc
		Local ps As PAINTSTRUCT: ' Paint struct
		Local mhdc As Dword: ' Memory hdc
		Local hImg As Dword: ' Memory image
		Local rn As iRender: ' working renderer

		If IsFalse IsObject( crd_ ) Then Exit Method
		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		hdc = BeginPaint( hWnd_, ps )

		GetClientRect( hWnd_, crc )
		hImg = CreateCompatibleBitmap( hdc, crc.Right, crc.Bottom )
		mhdc = CreateCompatibleDC( hdc )
		SelectObject( mhdc, hImg )

		rn = Me
		rn.Render( mhdc, crc, 0, 0 )

		GetClientRect( hWnd_, crc )
		Call BitBlt( hdc, 0,0, crc.right, crc.bottom, mhdc, 0, 0, %SRCCOPY )
		DeleteDc( mhdc )
		DeleteObject( hImg )
		EndPaint( hWnd_, ps )
	End Method

	Class Method OnSize( ByVal wParam As Dword )
		Local c As Long
		Local h As Long
		Local si As SCROLLINFO
		Local rc As RECT
		Local newClientWidth As Long
		Local newClientHeight As Long
		Local cards As Long

		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		GetClientRect( hWnd_, rc )
		layout_.EnsureLayoutUpdated( rc )

		si.cbSize = SizeOf(si)
		si.fMask = %SIF_All: '%SIF_Range Or %SIF_Page Or %SIF_Pos

		GetScrollInfo( hWnd_, %SB_Horz, si)
		If si.nMin<>0 Or si.nMax<>0 Or si.nPage<>0 Then
			si.nMin = 0
			si.nMax = 0
			si.nPage = 0
			SetScrollInfo( hWnd_, %SB_Horz, si, %TRUE)
		End If

		GetScrollInfo( hWnd_, %SB_Vert, si)
		si.nMin = layout_.MinFirst
		si.nMax = layout_.ItemCount - 1
		si.nPage = layout_.PageItemCount
		SetScrollInfo( hWnd_, %SB_Vert, si, %TRUE)

		Me.FlagForPaint()
	End Method

	Class Method OnVScroll( ByVal wParam As Long ) As String
		layout_.FirstItem = Me.OnScroll( %SB_Vert, wParam )
		Me.OnSize( wParam )
		Me.FlagForPaint()
	End Method

	Class Method OnScroll(ByVal pDirection As Long, ByVal scrollType As Long) As Long
		Local si As SCROLLINFO
		Local rc As RECT
		Local i As Long
		Local w As Long

		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method
		si.cbSize = SizeOf(si)
		si.fMask = %SIF_All
		GetScrollInfo( hWnd_, pDirection, si)
		Select Case LoWrd(scrollType)
			Case %SB_Top:        si.nPos = si.nMin
			Case %SB_Bottom:     si.nPos = si.nMax
			Case %SB_LineUp:     si.nPos -= Max&(1,si.nPage/2)
			Case %SB_LineDown:   si.nPos += Max&(1, si.nPage/2)
			Case %SB_PageUp:     si.nPos -= si.nPage
			Case %SB_PageDown:   si.nPos += si.nPage
			Case %SB_ThumbTrack: si.nPos = si.nTrackPos
		End Select
		SetScrollPos( hWnd_, pDirection, si.nPos, %TRUE)
		Method = GetScrollPos( hWnd_, pDirection )
	End Method

	Class Method OnMouseWheel( ByVal wParam As Dword )
		Local dir As Dword
		Local r As Long
		Local rc As RECT
		Local cursor As Point

		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		GetClientRect( hWnd_, rc )
		GetCursorPos(cursor)
		MapWindowPoints( %NULL, hWnd_, VarPtr(cursor), 1 )

		If IsFalse PtInRect( rc, cursor ) Then Exit Method
		If GetFocus()<>hWnd_ Then Exit Method

		dir = IIf&( Hi( Integer, wParam ) < 0, %SB_LineDown, %SB_LineUp )
		Call Me.OnVScroll( dir )
	End Method

	Class Method OnMouseMove( ByVal wParam As Long, ByVal x As Long, ByVal y As Long ) As String
		Local r As Long
		Local rc As RECT
		Local pt As Point
		Local si As SCROLLINFO

		If IsFalse IsObject( base_ ) Then Exit Method
		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		If layout_.IsHotTracking Then Me.FlagForPaint()

		If dragging_ Then
			GetClientRect( hWnd_, rc )
			pt.x = x
			pt.y = y
			If PtInRect( rc, pt ) Then
				' Mouse is in window
				r = layout_.Hit( x, y )
				If r<0 Then Exit Method
				r = layout_.ItemIndex( r )
				If r<0 Then Exit Method
				Me.Goto( r, base_.Col )
				Exit Method
			End If
			' Mouse is outside window
			si.cbSize = SizeOf(si)
			si.fMask = %SIF_All
			GetScrollInfo( hWnd_, %SB_Vert, si)

			r = layout_.CurItem
			' Only use timer if mouse isn't moving
			KillTimer( hWnd_, %IVDragTimer )
			SetTimer( hWnd_, %IVDragTimer, 50, 0 )
			If y<rc.Top Then
				r -= Max&(1, si.nPage / 4)
			ElseIf y>rc.Bottom Then
				r += Max&(1, si.nPage / 4)
			Else
				Exit Method: ' Not moving why waste the cycles
			End If
			Me.Goto( r, base_.Col )
			Exit Method
		End If
	End Method

	Class Method OnMouseDown( ByVal wParam As Long, ByVal x As Long, ByVal y As Long )
		Local r As Long

		If IsFalse IsObject( base_ ) Then Exit Method
		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		r = layout_.Hit( x, y )
		If r > -1 Then
			r = layout_.ItemIndex( r )
			Me.Goto( r, base_.Col )
			If (wParam And %MK_SHIFT)=0 Then layout_.SelStart = r
			Me.FlagForPaint()
			dragging_ = -1
			SetCapture( hWnd_ )
		End If
	End Method

	Class Method OnMouseUp( ByVal x As Long, ByVal y As Long ) As String
		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method
		If dragging_ Then
			dragging_ = 0
			KillTimer( hWnd_, %IVDragTimer )
			ReleaseCapture()
			Exit Method
		End If
	End Method

	Class Method OnTimer( ByVal timerId As Dword )
		Local cursor As PointAPI

		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		If timerId = %IVDragTimer Then
			GetCursorPos(cursor)
			MapWindowPoints( %NULL, hWnd_, VarPtr(cursor), 1 )
			SendMessage( hWnd_, %WM_MouseMove, 0, Mak(Dword, cursor.x, cursor.y)  ): ' Synthetic mouse move :)
		End If
	End Method

	Class Method OnActivate()
		Local rc As RECT
		Local ds As iDataSource

		If IsFalse IsObject( base_ ) Then Exit Method
		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		GetClientRect( hWnd_, rc )
		layout_.RequestLayoutUpdate( rc )
		Me.Goto( base_.Row, base_.Col )
		layout_.SelStart = layout_.CurItem
		layout_.FirstItem = layout_.CurItem
		Me.OnSize( Mak(Dword, rc.Right, rc.Bottom ) )
	End Method

	Class Method GoTo( ByVal r As Long, ByVal c As Long )
		Local msg As TblNotify
		Local rc As RECT
		Local lr As Long
		Local lc As Long

		If IsFalse IsObject( base_ ) Then Exit Method
		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		r = Max&( 0, Min&( layout_.ItemCount-1, r ) )
		c = Max&( 0, Min&( base_.ColCount-1, c ) )

		lr = layout_.CurItem
		lc = base_.Col
		If lr<>r Then
			layout_.GotoItem( r )
			SetScrollPos( hWnd_, %SB_Vert, layout_.FirstItem, %TRUE)
			base_.Row = r
			GetClientRect( hWnd_, rc )
			layout_.RequestLayoutUpdate( rc )
		End If

		base_.Col = c
		layout_.OtherItem = c

		If lc<>c Or lr<>r Then
			Me.FlagForPaint()
			msg.hdr.code = %TBN_CellChg
			msg.hdr.idFrom = GetDlgCtrlID( hWnd_ )
			msg.hdr.hwndFrom = hWnd_
			msg.r = r
			msg.c = c

			SendMessage( GetParent(hWnd_), %WM_Notify, hWnd_, VarPtr(msg)  )
		End If
	End Method

	Class Method OnCopy()
		Local r As Long
		Local c As Long
		Local sr As Long
		Local er As Long
		Local sc As Long
		Local ec As Long
		Local tx As WString
		Local sb As IStringBuilderW

		If Not IsObject( base_ ) Then Exit Method
		If Not IsObject( ds_ ) Then Exit Method

		sb = Class "StringBuilderW"

		sr = layout_.SelStart
		er = layout_.CurItem
		If sr>er Then Swap sr, er

		sc = 0
		ec = base_.ColCount
		If sc>ec Then Swap sc, ec

		If copyHeaders_ Then
			For c = sc To ec
				If c<>sc Then sb.Add($Tab)
				sb.add( ds_.Value( -1, c ) )
			Next c
			sb.Add( $CrLf )
		End If

		For r=sr To er
			For c=sc To ec
				If c<>sc Then sb.Add($Tab)
				sb.Add( ds_.Value( r, c ) )
			Next
			sb.Add( $CrLf )
		Next
		Clipboard Reset
		Clipboard Set Text sb.String
	End Method

	Class Method OnKeyDown( ByVal vKey As Dword )
		Local sk As ShiftKeys
		Local r As Long
		Local c As Long
		Local moveLeft As Long
		Local moveDown As Long
		Local rc As RECT

		If IsFalse IsObject( base_ ) Then Exit Method
		If IsFalse IsWindow( hWnd_) Or IsFalse IsWindowVisible( hWnd_ ) Then Exit Method

		GetClientRect( hWnd_, rc )
		Call GetShifts( sk )
		r = layout_.CurItem
		c = base_.Col

		Select Case vKey
			Case %VK_A
				' Select All
				layout_.SelStart = layout_.ItemCount-1
				layout_.CurItem = 0
				layout_.FirstItem = 0
				base_.Col = 0
				layout_.RequestLayoutUpdate( rc )
				Exit Method
			Case %VK_ESCAPE
				' Cancel select
				layout_.SelStart = layout_.CurItem
				layout_.GotoItem( layout_.CurItem )
				Exit Method
			Case %VK_C
				' Copy
				If sk.isCtrl And Not (sk.isAlt Or sk.isShift) Then
					Call Me.OnCopy()
				End If
				Exit Method
			Case %VK_UP
				If Not (sk.isCtrl Or sk.isAlt) Then
					Decr r
				Else
					Exit Method
				End If
			Case %VK_DOWN
				If Not (sk.isCtrl Or sk.isAlt) Then
					Incr r
				Else
					Exit Method
				End If
			Case %VK_PRIOR:
				If Not (sk.isCtrl Or sk.isAlt) Then
					r -= (layout_.VisibleCount-1)
				Else
					Exit Method
				End If
			Case %VK_NEXT:
				If Not (sk.isCtrl Or sk.isAlt) Then
					r += (layout_.VisibleCount-1)
				Else
					Exit Method
				End If
			Case %VK_END:
				If Not (sk.isCtrl Or sk.isAlt) Then
					r = layout_.ItemCount-1
				Else
					Exit Method
				End If
			Case %VK_HOME
				If Not (sk.isCtrl Or sk.isAlt) Then
					r = 0
				Else
					Exit Method
				End If
			Case Else
				Exit Method
		End Select
		Me.Goto( r, c )
		If Not sk.isShift Then layout_.SelStart = layout_.CurItem
	End Method

	Interface iIVRow Guid$("{fc4dcd27-c340-45f3-82b4-1ff1a0e77f5d}")
		Inherit IUnknown

		Property Get CopyHeaders() As Long
			Property = copyHeaders_
		End Property
		Property Set CopyHeaders( ByVal value As Long )
			copyHeaders_ = IIf&( value, -1, 0 )
		End Property

		Property Get Layout() As iLayout
			Property = layout_
		End Property
		Property Set Layout( ByRef value As iLayout )
			Local rc As RECT
			If IsInterface( value, iLayout ) And ObjPtr( value ) <> ObjPtr( layout_ ) Then
				layout_ = value
				Call Me.SetHWnds()
				layout_.FlagForPaint()
			End If
		End Property

		Property Get DrawControlBack() As iRender
			Property = drawControlBack
		End Property
		Property Set DrawControlBack( ByRef value As iRender )
			If ObjPtr( value ) <> ObjPtr( drawControlBack ) Then
				drawControlBack = value
				Call Me.SetHWnds()
				Me.FlagForPaint()
			End If
		End Property
	End Interface
	Interface iExtend Guid$("{071a4670-b6c6-4fd2-8d44-5d4caa0af66b}")
		Inherit IUnknown

		Method Extend( ByRef value As iWin )
			base_ = value
			If IsTrue IsInterface( value, iWin ) Then
				hWnd_ = value.HWnd
				Call Me.SetHWnds()
			End If
		End Method

		Method Unextend()
			base_ = Nothing
			crd_ = Nothing
		End Method

		Method Execute( ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long, ByRef ret As Long) As Long
			Method = -1: ' Handled
			' ret already defaulting to 0

			Select Case As Const wMsg
				Case %WM_Activate:        Call Me.OnActivate(): Exit Method
				Case %WM_Paint:           Call Me.OnPaint()
				Case %WM_Size:            Call Me.OnSize( lParam ): Exit Method
				Case %WM_VScroll:         Call Me.OnVScroll( wParam ): Exit Method
				Case %WM_MouseWheel:      Call Me.OnMouseWheel( wParam ): Exit Method
				Case %WM_MouseMove:       Call Me.OnMouseMove( wParam, Lo(Integer, lParam), Hi(Integer, lParam) ): Exit Method
				Case %WM_LButtonDown:     Call Me.OnMouseDown( wParam, Lo(Integer, lParam), Hi(Integer, lParam) ): Exit Method
				Case %WM_LButtonUp:       Call Me.OnMouseUp( Lo(Integer, lParam), Hi(Integer, lParam) ): Exit Method
				Case %WM_KeyDown:         Call Me.OnKeyDown( wParam ): Exit Method
				Case %WM_Timer:           Call Me.OnTimer( wParam )
			End Select
			Method = 0: ' Unhandled
		End Method
	End Interface
	Interface iHasDatasource Guid$("{33e74a9a-2739-4180-a894-3fc9cd8614b3}")
		Inherit IUnknown

		Property Get DataSource() As iDataSource
			Property = ds_
		End Property
		Property Set DataSource( ByRef value As iDataSource )
			Local hds As iHasDatasource
			ds_ = value
			hds = layout_: If IsTrue IsObject( hds ) Then hds.DataSource = ds_
		End Property
	End Interface
	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local crc As RECT
			Local rn As iRender

			layout_.HWnd = hWnd_
			layout_.RequestLayoutUpdate( rc )
			' Draw background
			CopyRect( crc, rc )
			Call Me.PaintPart( hdc, crc, 0, 0, "", %IVPart.ControlBack, %IVState.Normal, drawControlBack )

			' Draw cards
			rn = layout_
			CopyRect( crc, rc )
			Call Me.PaintPart( hdc, crc, 0, 0, "", %IVPart.ControlBack, %IVState.Normal, rn )
		End Method
	End Interface
End Class
