Function NewCurrentManager() Common Export As iCurrentManager
	Local obj As iCurrentManager
	obj = Class "cCurrentManager"
	Function = obj
End Function

Class cCurrentManager Guid$("{8c061876-c5fe-40a8-9503-403e1d5bdfe1}") Common
	Instance current_ As Long
	Instance isRowManager_ As Long
	Instance dataSource_ As iDataSource
	Instance send_ As iSend
	Instance publish_ As iPublish

	Class Method Create()
		send_ = NewSend()
		publish_ = send_
	End Method
	Class Method Destroy()
	End Method

	Class Method Publish( ByVal msg As Long, ByVal a As Long, ByVal b As Long )
		Local s As iSend
		s = Me
		publish_.Publish( s, msg, a, b )
	End Method
	Class Method RowCount() As Long
		If IsObject( dataSource_ ) Then
			Method = dataSource_.RowCount
		End If
	End Method
	Class Method ColCount() As Long
		If IsObject( dataSource_ ) Then
			Method = dataSource_.ColCount
		End If
	End Method

	Interface iCurrentManager Guid$("{6c2b88cc-7bc5-4ea5-b9c3-c053fb8aa9dd}")
		Inherit IUnknown

		Property Get IsRowManager() As Long
			Property = isRowManager_
		End Property
		Property Set IsRowManager( ByVal value As Long )
			Local v As Long
			v = IIf&( value, -1, 0 )
			If v <> isRowManager_ Then
				isRowManager_ = v
				Me.Publish( %Message.DataSourceChanged, Me.RowCount, Me.ColCount )
			End If
		End Property

		Property Get Current() As Long
			Property = current_
		End Property
		Property Set Current( ByRef value As Long )
			Local v As Long
			If IsObject( dataSource_ ) Then
				v = Max&( 0, Min&( Me.Count-1, value ) )
				If v <> current_ Then
					current_ = v
					If isRowManager_ Then
						Me.Publish( %Message.RowChanged, current_, 0 )
					Else
						Me.Publish( %Message.ColChanged, 0, current_ )
					End If
				End If
			End If
		End Property

		Property Get Count() As Long
			If IsObject( dataSource_ ) Then
				Property = IIf&(isRowManager_, dataSource_.RowCount, dataSource_.ColCount)
			End If
		End Property
	End Interface

	Interface iHasDatasource Guid$("{33e74a9a-2739-4180-a894-3fc9cd8614b3}")
		Inherit IUnknown

		Property Get DataSource() As iDataSource
			Property = dataSource_
		End Property
		Property Set DataSource( ByRef value As iDataSource )
			Dim s As iSend
			Dim r As iReceive
			r = Me
			If ObjPtr( dataSource_ ) = ObjPtr( value ) Then Exit Property
			s = dataSource_
			If IsObject( s ) Then s.Unsubscribe(r)
			dataSource_ = value
			current_ = 0
			s = dataSource_
			If IsObject( s ) Then s.SubScribe(r)
			Me.Publish( %Message.DatasourceChanged, Me.RowCount, Me.ColCount )
		End Property
	End Interface

	Interface iReceive Guid$("{113f4bfe-80c4-4dbe-954e-f99ad27a731f}")
		Inherit IUnknown
		Method Receive( sender As iSend, ByVal msg As Long, ByVal a As Long, ByVal b As Long )
			' Forwarding datasource events
			Me.Publish( msg, a, b )
		End Method
	End Interface

	Interface iSend Guid$("{7b1b3f52-c3bc-40b0-bf3f-9e239ed67dc8}")
		Inherit IUnknown
		Method Subscribe( value As iReceive )
			send_.Subscribe( value )
		End Method
		Method Unsubscribe( value As iReceive )
			send_.Unsubscribe( value )
		End Method
	End Interface
End Class
