Function NewDataColumn() Common As iDataColumn
	Function = Class "cDataColumn"
End Function

Class cDataColumn Guid$("{df3c744e-3b4a-4bdd-aa77-3dc2ea827195}") Common
	Instance columnName_ As String
	Instance heading_ As String
	Instance dataTable_ As iDataTable

	Interface iDataColumn Guid$("{544c7676-bd96-4276-aaae-ba007f2e03a2}")
		Inherit IUnknown

		Property Get ColumnName() As String
			Property = columnName_
		End Property
		Property Set ColumnName( ByRef value As String )
			columnName_ = Trim$( value )
			If heading_ = "" Then
				heading_ = ToCaption( columnName_ )
			End If
		End Property

		Property Get Heading() As String
			Property = heading_
		End Property
		Property Set Heading( ByRef value As String )
			heading_ = value
		End Property

		Property Get DataTable() As iDataTable
			Property = dataTable_
		End Property
		Property Set DataTable( ByRef value As iDataTable )
			' Write-once
			If Not IsInterface( dataTable_, iDataTable ) Then
				dataTable_ = value
			End If
		End Property
	End Interface
End Class

Function ToCaption( ByVal value As String ) As String
	Local i As Long

	If value = "" Then
		Function = ""
		Exit Function
	End If
	Replace "_" With " " In value
	For i = Len(value) - 1 To 2 Step -1
		If IsUpper( Mid$( value, i, 1 ) ) And ( IsLower( Mid$( value, i + 1, 1 ) ) Or IsLower( Mid$( value, i-1, 1 ) ) ) And InStr( "!@#$%^&*()-+=[]{}|\;:'""<>,./?", Mid$( value, i - 1, 1 ) ) = 0 Then
			Mid$(value, i, 1) = UCase$( Mid$( value, i, 1) )
			InsertString( value, i-1, " " )
		End If
	Next
	Replace "  " With " " In value
	value = LCase$( value )
	Mid$( value, 1, 1 ) = UCase$( Mid$( value, 1, 1 ) )
	Function = value
End Function

Sub InsertString( ByRef value As String, ByVal p As Long, ByRef ins As String )
	value = Mid$( value, 1, p ) + ins + Mid$( value, p+1 )
End Sub

Function IsUpper( ByRef letter As String ) As Long
	Function = IIf&( IsAlpha(letter) And letter = UCase$(letter), -1, 0 )
End Function

Function IsLower( ByRef letter As String ) As Long
	Function = IIf&( IsAlpha(letter) And letter=LCase$(letter), -1, 0 )
End Function

Function IsAlpha( ByRef letter As String ) As Long
	Function = IIf&(InStr("abcdefghijklmnopqrstuvwxyz", LCase$( letter ) )>0, -1, 0 )
End Function
