#Include Once "Win32api.inc"

Function BufferToString( ByRef buf() As Byte ) Common Export As String
	Local i As Long
	Local l As Long
	Local sb As IStringBuilderA
	sb = Class "StringBuilderA"
	l = UBound( buf() )
	For i=0 To l
		sb.Add( Hex$( buf(i), 2 ) )
	Next
	Function = sb.String
End Function

Sub StringToBuffer( ByRef value As String, ByRef buf() As Byte ) Common Export
	Local i As Long
	Local o As Long
	Local sb As IStringBuilderA
	sb = Class "StringBuilderA"
	o = 0
	ReDim buf( Len(value) / 2 )
	For i=1 To Len( value ) Step 2
		sb.Add("&h")
		sb.Add( Mid$(value,i,2) )
		buf(o) = Val( sb.String )
		Incr o
	Next
End Sub

Function NewDataRow() Common As iDataRow
	Function = Class "cDataRow"
End Function

Class cDataRow Guid$("{a22b79bd-867b-407d-9fe9-5d90a8010dbf}") Common
	Instance value_() As String
	Instance isNull_() As Long
	Instance cols As Long
	Instance dataTable_ As iDataTable


	Class Method ReformatDateTime( ByVal dttm As String ) As String
		Dim pt As IPowerTime
		Dim y As String
		Dim m As String
		Dim d As String
		Dim h As String
		Dim mn As String
		Dim s As String

		pt = Me.StringToPowerTime(dttm)
		If IsObject( pt ) Then
			y = Format$( pt.Year(), "0000")
			m = Format$( pt.Month(), "00")
			d = Format$( pt.Day(), "00" )
			h = Format$( pt.Hour(), "00")
			mn = Format$( pt.Minute(), "00")
			s = Format$( pt.Second(), "00" )
			Method = Build$( y, "-", m, "-", d, " ", h, ":", mn, ":", s )
		End If
	End Method

	Class Method ReformatTime( ByVal tm As String ) As String
		Dim pt As IPowerTime
		Dim h As String
		Dim m As String
		Dim s As String

		pt = Me.StringToPowerTime(tm)
		If IsObject( pt ) Then
			h = Format$( pt.Hour(), "00")
			m = Format$( pt.Minute(), "00")
			s = Format$( pt.Second(), "00" )
			Method = Build$( h, ":", m, ":", s )
		End If
	End Method

	Class Method ReformatDate( ByVal dt As String ) As String
		Dim pt As IPowerTime
		Dim y As String
		Dim m As String
		Dim d As String

		pt = Me.StringToPowerTime(dt)
		If IsObject( pt ) Then
			y = Format$( pt.Year(), "0000")
			m = Format$( pt.Month(), "00")
			d = Format$( pt.Day(), "00" )
			Method = Build$( y, "-", m, "-", d )
		End If
	End Method

	Class Method StringToPowerTime(ByVal sDate As String) As IPowerTime
		Local pt As IPowerTime
		Local vDate As String
		Local vTime As String
		Local sep As String
		Dim segments(3) As String
		Local p As Long
		Local mon As Long
		Local day As Long
		Local yer As Long
		Local hor As Long
		Local mn As Long
		Local sec As Long
		Local fmt As String
		Local dtSep As String
		Local tmSep As String
		Local seps As String
		Local pMon As Long
		Local pDay As Long
		Local pYr As Long
		Local part As String
		Local i As Long

		fmt = Me.GetLocaleString( %LOCALE_SSHORTDATE )
		dtSep = Me.GetLocaleString(%LOCALE_SDATE)
		tmSep = Me.GetLocaleString(%LOCALE_STIME)

		p = InStr(sDate, " ")
		If p>0 Then
			vDate = Trim$( Left$( sdate, p-1 ) )
			vTime = Trim$( Mid$( sDate, p+1 ) )
		Else
			p = InStr( sDate, ":" )
			If p> 0 Then
				vTime = Trim$( sDate )
			Else
				vDate = Trim$( sDate )
			End If
		End If

		For i = 1 To ParseCount( fmt, dtSep )
			part = LCase$( Mid$( Parse$( fmt, dtSep, i ), 1, 1 ) )
			Select Case As Const$ part
				Case "m": pMon = i-1
				Case "d": pday = i-1
				Case "y": pYr = i-1
			End Select
		Next


		seps = dtSep + "/-."
		For i=1 To Len(seps)
			p = InStr( vDate, Mid$( seps, i, 1 ) )
			If p>0 Then
				sep = Mid$( seps, i, 1 )
				Exit For
			End If
		Next

		If sep<>"" Then
			Parse vDate, segments(), sep
			If Val(segments(0)) > 31 Then
				yer = Val( segments(0) )
				mon = Val( segments(1) )
				day = Val( segments(2) )
			Else
				mon = Val(segments( pMon ))
				day = Val(segments( pDay ))
				yer = Val(segments( pYr ))
			End If
		End If

		seps = tmSep + ":"
		sep = ""
		For i=1 To Len(seps)
			p = InStr( vTime, Mid$( seps, i, 1 ) )
			If p>0 Then
				sep = Mid$( seps, i, 1 )
				Exit For
			End If
		Next
		If sep<>"" Then
			Parse vTime, segments(), sep
			hor = Val(segments(0))
			mn = Val(segments(1))
			sec = Val(segments(2))
		End If

		pt = Class "PowerTime"
		If yer<>0 Then
			pt.NewDate( yer, mon, day )
			If ObjResult<>%S_Ok Then Exit Method
		End If
		If sep<>"" Then
			pt.NewTime( hor, mn, sec )
			If ObjResult<>%S_Ok Then Exit Method
		End If
		Method = pt
	End Method

	Class Method GetLocaleString(ByVal lLocaleNum As Long) As String
		Local lBuffSize As Long
		Local sBuffer As String
		Local lRet As Long

		lBuffSize = 256
		sBuffer = Repeat$(lBuffSize, $Nul)

		lRet = GetLocaleInfo(LOCALE_SYSTEM_DEFAULT, lLocaleNum, ByVal StrPtr(sBuffer), lBuffSize)

		If lRet > 0 Then
			Method = Left$(sBuffer, lRet - 1)
		End If
	End Method

	Interface iDataRow Guid$("{7c95c6c5-e752-4bd2-89be-65180f2afca2}")
		Inherit IUnknown

		Property Get IsNull( ByVal offset As Long ) As Long
			If offset>=0 And offset<cols Then
				Property = isNull_( offset )
			Else
				Property = -1
			End If
		End Property
		Method SetNull( ByVal offset As Long, ByVal value As Long )
			If offset>=0 And offset<cols Then
				isNull_( offset ) = IIf&( value, -1, 0 )
				dataTable_.NextVersion()
			End If
		End Method
		Method SetAllNull( ByVal value As Long )
			Local i As Long
			For i=0 To cols-1
				isNull_(i) = IIf&(value,-1,0)
			Next
			If IsInterface( dataTable_, iDataTable) Then dataTable_.NextVersion()
		End Method

		Property Get Value(ByVal offset As Long) As String
			If offset>=0 And offset<cols Then
				If isNull_(offset) Then
					Property = dataTable_.NullDisplayValue
				Else
					Property = value_(offset)
				End If
			End If
		End Property
		Property Set Value(ByVal offset As Long, ByRef value As String )
			If offset>=0 And offset<cols Then
				If value_(offset) <> value Then
					value_(offset) = value
					isNull_(offset) = 0
					dataTable_.NextVersion()
				End If
			End If
		End Property
		Property Get DataTable() As iDataTable
			Property = dataTable_
		End Property
		Property Set DataTable( ByRef value As iDataTable )
			Local i As Long
			If Not IsInterface( dataTable_, iDataTable ) And IsInterface( value, iDataTable) Then
				dataTable_ = value
				cols = dataTable_.ColCount()
				ReDim value_( cols-1 )
				ReDim isNull_( cols-1 )
				Me.SetAllNull( 0 )
			End If
		End Property

		Property Get AsLong( ByVal offset As Long ) As Long
			If offset>=0 And offset<cols Then
				Property = CLng( Val( value_( offset ) ) )
			End If
		End Property
		Property Set AsLong( ByVal offset As Long, ByVal value As Long )
			If offset>=0 And offset<cols Then
				value_( offset ) = Format$( value, "00000000000" )
			End If
		End Property

		Property Get AsCur( ByVal offset As Long ) As Currency
			If offset>=0 And offset<cols Then
				Property = CCur( Val( value_( offset ) ) )
			End If
		End Property
		Property Set AsCur( ByVal offset As Long, ByVal value As Currency )
			If offset>=0 And offset<cols Then
				value_( offset ) = Format$( value, "00000000000000.0000" )
			End If
		End Property

		Property Get AsDbl( ByVal offset As Long, fmt As String ) As Double
			If offset>=0 And offset<cols Then
				Property = CDbl( Val( value_( offset ) ) )
			End If
		End Property
		Property Set AsDbl( ByVal offset As Long, fmt As String, ByVal value As Double )
			If offset>=0 And offset<cols Then
				value_( offset ) = Format$( value, fmt )
			End If
		End Property
		Property Get AsBool( ByVal offset As Long ) As Long
			If offset>=0 And offset<cols Then
				Property = IIf&( CLng( Val( value_( offset ) ) ), -1, 0 )
			End If
		End Property
		Property Set AsBool( ByVal offset As Long, ByVal value As Long )
			If offset>=0 And offset<cols Then
				value_( offset ) = IIf$( value, "1", "0" )
			End If
		End Property

		Property Get AsDate( ByVal offset As Long ) As String
			If offset>=0 And offset<cols Then
				Property = Me.ReformatDate( value_( offset ) )
			End If
		End Property
		Property Set AsDate( ByVal offset As Long, ByVal value As String )
			If offset>=0 And offset<cols Then
				value_( offset ) = value
			End If
		End Property

		Property Get AsTime( ByVal offset As Long ) As String
			If offset>=0 And offset<cols Then
				Property = Me.ReformatTime( value_( offset ) )
			End If
		End Property
		Property Set AsTime( ByVal offset As Long, ByVal value As String )
			If offset>=0 And offset<cols Then
				value_( offset ) = value
			End If
		End Property

		Property Get AsDateTime( ByVal offset As Long ) As String
			If offset>=0 And offset<cols Then
				Property = Me.ReformatDateTime( value_( offset ) )
			End If
		End Property
		Property Set AsDateTime( ByVal offset As Long, ByVal value As String )
			If offset>=0 And offset<cols Then
				value_( offset ) = value
			End If
		End Property
	End Interface
End Class
