
'#Include Once "datatable\DataTable.inc"

Function DataView_FilterAll( ByVal dr As iDataRow ) Common Export As Long
	Function = -1
End Function

Function NewDataView( ByRef dt As iDataTable ) Common Export As iDataView
	Dim dv As iDataView
	dv = Class "cDataView"
	dv.DataTable = dt
	Function = dv
End Function

Class cDataView  Guid$("{fc2ab219-55f6-4a4d-8f68-5774b5d0daa1}") Common
	Instance dataTable_ As iDataTable
	Instance lastVersion_ As Long
	Instance sort_ As String
	Instance caseSensitive_ As Long

	Instance filtered_() As Long
	Instance rows_ As Long
	Instance key_() As String
	Instance tag_() As Long

	Instance filterMethod_ As Dword

	Interface iDataView Guid$("{675f95e9-9184-43c4-aa58-2694a8053e82}")
		Inherit IUnknown

		Property Get DataTable() As iDataTable
			Property = dataTable_
		End Property
		Property Set DataTable( ByRef value As iDataTable )
			dataTable_ = value
			lastVersion_ = -1
		End Property

		Property Get FilterMethod() As Dword
			Property = filterMethod_
		End Property
		Property Set FilterMethod( ByVal value As Dword )
			If value<>filterMethod_ Then
				filterMethod_ = value
				lastVersion_ = -1
			End If
		End Property

		Property Get Sort() As String
			Property = sort_
		End Property
		Property Set Sort( ByRef value As String )
			If sort_ <> value Then
				sort_ = value
				lastVersion_ = -1
			End If
		End Property
		Property Get CaseSensitive() As Long
			Property = caseSensitive_
		End Property
		Property Set CaseSensitive( ByVal value As Long )
			If value Then value=-1
			If value<>caseSensitive_ Then
				caseSensitive_ = value
				lastVersion_ = -1
			End If
		End Property

		Property Get Rows() As Long
			If Not IsInterface( dataTable_, iDataTable ) Then Exit Property
			Property = rows_
		End Property

		Property Get Row( ByVal offset As Long ) As iDataRow
			If Not IsInterface( dataTable_, iDataTable ) Then Exit Property
			Dim u As Long
			Dim v As Long
			u = UBound( tag_() )
			v = UBound( key_() )
			Dim r As Long
			r = tag_( offset )

			If offset>=0 And offset < rows_ Then
				Property = dataTable_.Row( tag_( offset ) )
			End If
		End Property

		Property Get IsCurrent() As Long
			If Not IsInterface( dataTable_, iDataTable ) Then Exit Property
			Property = IIf&(lastVersion_ <> dataTable_.Version,0,-1)
		End Property

		Method Refresh()
			Local i As Long
			Local j As Long
			Local r As Long
			Local key As String
			Local cnt As Long
			Local segments() As Long
			Local desc() As Long
			Local segs() As String
			Local dr As iDataRow
			Local sb As IStringBuilderA
			Local sp As Byte Ptr
			Local v As Byte Ptr
			Local seg As String
			Local descSort() As Byte
			Local ascSort() As Byte

			If Not IsInterface( dataTable_, iDataTable ) Then Exit Method
			If lastVersion_ = dataTable_.Version Then Exit Method: ' Nothing to do
			'=============================
			' Filter
			'=============================
			If UBound( filtered_() ) <> dataTable_.RowCount-1 Then
				ReDim filtered_( dataTable_.RowCount-1 )
			End If
			Local a As Dword
			a = ObjPtr( dataTable_ )
			If filterMethod_ = 0 Then
				' No filter, use all rows
				For i=0 To dataTable_.RowCount-1
					filtered_(i) = i
				Next
				rows_ = dataTable_.RowCount
			Else
				rows_ = 0
				For i=0 To dataTable_.RowCount-1
					Call Dword filterMethod_ Using DataView_FilterAll( dataTable_.Row(i) ) To r
					If r Then
						filtered_(rows_) = i
						Incr rows_
					End If
				Next
			End If

			If rows_ = 0 Then Exit Method: ' Nothing to sort
			If sort_ = "" Then Exit Method

			'=============================
			' Sort
			'=============================
			sb = Class "StringBuilderA"

			cnt = ParseCount( sort_, ",")
			Dim segments( cnt-1 )
			Dim desc( cnt-1 )
			Dim segs( cnt-1 )

			Parse sort_, segs(), ","

			For i=0 To cnt-1
				segments(i) = Abs( Val( segs(i) ) )
				desc(i) = IIf( InStr( segs(i), "-" )>0, -1, 0 ): ' If the value is < 0 then invert sort sense
			Next

			If rows_-1 <> UBound( key_() ) Then
				ReDim key_( rows_-1 )
				ReDim tag_( rows_-1 )
			End If
			Dim descSort(255)
			Dim ascSort(255)
			For i=0 To 255
				If caseSensitive_ Then
					descSort(i) = 255 - i: ' Invert the sense of the sort
					ascSort(i) = i: ' Normal sort
				Else
					descSort(i) = 255 - Asc( UCase$( Chr$( i ) ) ): ' Invert the sense of the sort and fold case (lower=upper)
					ascSort(i) = Asc( UCase$( Chr$( i ) ) ): ' Fold case (lower=upper)
				End If
			Next

			For i = 0 To rows_-1
				dr = dataTable_.Row( filtered_(i) )
				sb.Clear()
				For j=0 To cnt-1
					seg = dr.Value( segments(j) )
					' If case insensitive or this key segment is sorted descending
					If caseSensitive_=0 Or desc(j) Then
						sp = IIf&( desc(j), VarPtr(descSort(0)), VarPtr( ascSort(0) ) )
						v = StrPtr(seg)
						' Translate the string as appropriate
						While @v
							@v = @sp[ @v ]
							Incr v
						Wend
					End If
					sb.Add( seg )
				Next j

				key_(i) = sb.String
				tag_(i) = filtered_(i)
			Next

			Array Sort key_(), TagArray tag_()
			lastVersion_ = dataTable_.Version
		End Method
	End Interface
End Class
