
Function NewDataTableDataSource( Optional dt As iDataTable ) Common Export As iDataSource
	Dim obj As iDataSource
	Dim o As iDataTableDataSource
	obj = Class "cDataTableDataSource"
	If IsFalse IsMissing( dt ) Then
		o = obj
		o.DataTable = dt
	End If
	Function = obj
End Function

Class cDataTableDataSource Guid$("{34fccb1d-d7bc-434e-8f61-d7bf317c236f}") Common
	Instance dt As iDataTable
	Instance pivot_ As Long
	Instance send_ As iSend

	Class Method Create()
		Local s As iSend
		Local r As iReceive
		send_ = NewSend()
		dt = newDataTable("Test")
		s = dt
		r = Me
		If IsObject(s) Then s.Subscribe( r )
	End Method

	Class Method Publish( ByVal msg As Long, ByVal a As Long, ByVal b As Long)
		Local s As iSend
		Local publish_ As iPublish
		publish_ = send_
		s = Me
		publish_.Publish( s, msg, a, b )
	End Method

	Class Method RowCount() As Long
		If IsObject( dt ) Then
			Method = dt.RowCount
		End If
	End Method

	Class Method ColCount() As Long
		If IsObject( dt ) Then
			Method = dt.ColCount
		End If
	End Method

	Interface iDataTableDataSource Guid$("{9700ce15-4961-48e4-a5eb-acd2f30d6304}")
		Inherit IUnknown
		Property Get DataTable() As iDataTable
			Property = dt
		End Property
		Property Set DataTable( ByRef value As iDataTable )
			Local s As iSend
			Local r As iReceive
			Local rw As Long
			Local cl As Long
			If ObjPtr(value) = ObjPtr( dt ) Then Exit Property
			s = dt
			r = Me
			If IsObject( s ) Then s.Unsubscribe( r )
			dt = value
			s = dt
			If IsObject( s ) Then s.Subscribe( r )
			Me.Publish( %Message.DatasourceChanged, Me.RowCount, Me.ColCount )
		End Property
		Property Get Pivot() As Long
			Property = pivot_
		End Property
		Property Set Pivot( ByVal value As Long )
			Local last As Long
			last = pivot_
			pivot_ = IIf&( value, -1, 0 )
			If last<>pivot_ Then
				Me.Publish( %Message.DatasourceChanged, Me.RowCount, Me.ColCount )
			End If
		End Property
	End Interface

	Interface iDataSource Guid$("{f5cec2ff-a658-4126-a99d-6b2f52c6ebaf}")
		Inherit IUnknown

		Property Get Value( ByVal r As Long, ByVal c As Long ) As String
			If IsFalse IsObject( dt ) Then Exit Property
			If pivot_ Then Swap r, c
			If r<0 Then
				If c>=0 And c<dt.ColCount Then
					Property = dt.Column(c).Heading
				End If
			ElseIf r < dt.RowCount And c>=0 And c<dt.ColCount Then
				Property = dt.Row(r).Value(c)
			ElseIf r < dt.RowCount And c<0 Then
				Property = Format$(r+1, "#,##0")
			End If
		End Property
		Property Set Value( ByVal r As Long, ByVal c As Long, ByRef value As String )
			If IsFalse IsObject( dt ) Then Exit Property
			If pivot_ Then Swap r, c
			If r<0 Then
				If c>=0 And c<dt.ColCount Then
					dt.Column(c).Heading = value
					If pivot_ Then Swap r, c
					Me.Publish( %Message.ValueChanged, -1, c )
				End If
			ElseIf r < dt.RowCount And c<dt.ColCount Then
				dt.Row(r).Value(c) = value
				If pivot_ Then Swap r, c
				Me.Publish( %Message.ValueChanged, r, c )
			End If
		End Property

		Property Get RowCount() As Long
			If IsFalse IsObject( dt ) Then Exit Property
			If pivot_ Then
				Property = dt.ColCount
			Else
				Property = dt.RowCount
			End If
		End Property
		Property Set RowCount( ByVal value As Long )
		End Property

		Property Get ColCount() As Long
			If IsFalse IsObject( dt ) Then Exit Property
			If pivot_ Then
				Property = dt.RowCount
			Else
				Property = dt.ColCount
			End If
		End Property
		Property Set ColCount(ByVal value As Long )
		End Property
	End Interface

	Interface iReceive Guid$("{113f4bfe-80c4-4dbe-954e-f99ad27a731f}")
		Inherit IUnknown
		Method Receive( sender As iSend, ByVal msg As Long, ByVal a As Long, ByVal b As Long )
			' Forwarding datatable events
			Me.Publish( msg, a, b )
		End Method
	End Interface

	Interface iSend Guid$("{7b1b3f52-c3bc-40b0-bf3f-9e239ed67dc8}")
		Inherit IUnknown
		Method Subscribe( value As iReceive )
			send_.Subscribe( value )
		End Method
		Method Unsubscribe( value As iReceive )
			send_.Unsubscribe( value )
		End Method
	End Interface
End Class
