Function NewFeatureList() Common Export As iFeatureList
	Local obj As iFeatureList
	obj = Class "cFeatureList"
	Function = obj
End Function

Class cFeatureList Guid$("{59863be1-5a68-4738-a0d9-29dce64ab5b9}") Common
	Instance item_() As iFeature
	Instance count_ As Long

	Interface iFeatureList Guid$("{3822498b-d2c3-4410-8d5d-388bdf01eb1b}")
		Inherit IUnknown

		Property Get Item( ByVal offset As Long ) As iFeature
			If offset>=0 And offset < count_ Then
				Property = item_( offset )
			End If
		End Property
		Property Set Item( ByVal offset As Long, ByRef value As iFeature )
			If offset>=0 And offset < count_ Then
				item_( offset ) = value
			End If
		End Property

		Method Notify()
			Local i As Long
			For i = 0 To count_ - 1
				item_( i ).Execute()
			Next
		End Method

		Method Add( ByRef value As iFeature ) As Long
			ReDim Preserve item_( count_ )
			item_ ( count_ ) = value
			Method = count_
			Incr count_
		End Method

		Method Remove( ByRef value As iFeature )
			Local i As Long
			Local s As Long
			For i = 0 To count_ -1
				If ObjPtr( value ) = ObjPtr( item_( i ) ) Then
					s = i
					Exit For
				End If
			Next
			If IsFalse s Then Exit Method: ' Not found
			For i = s To count_ - 2
				item_( i ) = item_( i + 1 )
			Next
			Decr count_
			If count_ Then
				ReDim Preserve item_( count_-1 )
			Else
				Erase item_()
			End If
		End Method

		Method Clear() As String
			If count_ > 0 Then
				Erase item_()
			End If
			count_ = 0
		End Method
	End Interface
End Class
