Function NewIVBaseSwitchViews( win As iWin, ByVal prevKey As Dword, ByVal nextKey As Dword ) As iExtend
	Local obj As iExtend
	Local o As iIVBaseSwitchViews
	obj = Class "cIVBaseSwitchViews"
	o = obj
	o.PrevKey = prevKey
	o.NextKey = nextKey
	obj.Extend( win )
	Function = obj
End Function

Class cIVBaseSwitchViews Guid$("{b3988568-4f99-4bec-83db-af978f69a28c}") Common
	Instance base_ As iIVBase
	Instance next_ As Dword
	Instance prev_ As Dword
	Instance hWnd As Dword: ' Window handle

	Class Method OnKeyDown( ByVal vKey As Dword ) As Long
		Local sk As ShiftKeys
		GetShifts( sk )
		If IsFalse IsObject( base_ ) Then Exit Method
		Method = -1
		If vKey = next_ And sk.IsAlt Then
			If IsFalse base_.Views.Next() Then base_.Views.Next()
			base_.ActivateView()
		ElseIf vKey = prev_ And sk.IsAlt Then
			If IsFalse base_.Views.Prev() Then base_.Views.Prev()
			base_.ActivateView()
		Else
			Method = 0
		End If
	End Method

	Interface iIVBaseSwitchViews Guid$("{4556544f-1041-49ae-8696-7ec42e936e4e}")
		Inherit IUnknown
		Property Get NextKey() As Dword
			Property = next_
		End Property
		Property Set NextKey( ByVal value As Dword )
			next_ = value
		End Property
		Property Get PrevKey() As Dword
			Property = next_
		End Property
		Property Set PrevKey( ByVal value As Dword )
			prev_ = value
		End Property

		Method Next()
			Me.OnKeyDown( next_ )
		End Method
		Method Prev()
			Me.OnKeyDown( prev_ )
		End Method
	End Interface

	Interface iExtend Guid$("{071a4670-b6c6-4fd2-8d44-5d4caa0af66b}")
		Inherit IUnknown

		Method Extend( ByRef value As iWIn )
			base_ = value
			If IsTrue IsInterface( value, iWIn ) Then
				hWnd = value.hWnd
			End If
		End Method
		Method Unextend()
			base_ = Nothing
		End Method

		Method Execute( ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long, ByRef ret As Long) As Long
			Method=-1
			' ret already defaulting to 0
			Select Case As Const wMsg
				Case %WM_KeyDown, %WM_SysKeyDown:         Method = Me.OnKeyDown(wParam): Exit Method
			End Select

			Method = 0: ' Unhandled
		End Method
	End Interface
End Class
