Function NewTestDatasource() Common Export As iDataSource
	Function = Class "cTestDataSource"
End Function

Class cTestDataSource GUID$("{8702ef21-7100-4c6c-be8f-8fd848e26a1a}")
	Instance pivot_ As Long
	Instance rowCount_ As Long
	Instance colCount_ As Long
	Instance send_ As iSend

	Class Method Create()
		send_ = NewSend()
	End Method

	Class Method Publish( ByVal msg As Long, ByVal a As Long, ByVal b As Long)
		Local s As iSend
		Local publish_ As iPublish
		publish_ = send_
		s = Me
		publish_.Publish( s, msg, a, b )
	End Method

	Interface iTestDataSource Guid$("{218e518f-0b93-4f28-96dc-674d8ddede85}")
		Inherit IUnknown
		Property Get Pivot() As Long
			Property = pivot_
		End Property
		Property Set Pivot( ByVal value As Long )
			Local last As Long
			last = pivot_
			pivot_ = IIf&( value, -1, 0 )
			If pivot_ <> last Then
				Swap rowCount_, colCount_
				Me.Publish( %Message.DatasourceChanged, rowCount_, colCount_ )
			End If
		End Property
	End Interface

	Interface iDataSource Guid$("{f5cec2ff-a658-4126-a99d-6b2f52c6ebaf}")
		Inherit IUnknown

		Property Get Value( ByVal r As Long, ByVal c As Long ) As String
			Local v As String
			If pivot_ Then Swap r, c
			If r>=0 Then
				If c=-1 Then
					v = "R" + Format$(r+1, "#,##0")
				Else
					v = Format$(r+1, "#,##0") + "," + Format$(c+1, "#,##0")
				End If
			ElseIf c>=0 Then
				v = "C"+Format$(c+1, "#,##0")
			End If
			Property = v
		End Property
		Property Set Value( ByVal r As Long, ByVal c As Long, ByRef value As String )
		End Property
		Property Get RowCount() As Long
			Property = rowCount_
		End Property
		Property Set RowCount( ByVal value As Long )
			If rowCount_ <> value Then
				rowCount_ = value
				Me.Publish( %Message.CountChanged, rowCount_, colCount_ )
			End If
		End Property
		Property Get ColCount() As Long
			Property = colCount_
		End Property
		Property Set ColCount( ByVal value As Long )
			If colCount_ <> value Then
				colCount_ = value
				Me.Publish( %Message.CountChanged, rowCount_, colCount_ )
			End If
		End Property
	End Interface

	Interface iSend Guid$("{7b1b3f52-c3bc-40b0-bf3f-9e239ed67dc8}")
		Inherit IUnknown
		Method Subscribe( value As iReceive )
			send_.Subscribe( value )
		End Method
		Method Unsubscribe( value As iReceive )
			send_.Unsubscribe( value )
		End Method
	End Interface
End Class
