Function NewSimpLine() Common Export As iSimpLine
	Local obj As iSimpLine
	obj = Class "cSimpLine"
	Function = obj
End Function

Class cSimpLine Guid$("{1448512a-cf83-4693-9110-eec6c1a486f3}") Common
	Instance count_ As Long
	Instance item_() As iSimpProp
	Instance needCalc_ As Long
	Instance fixedWidth_ As Long
	Instance fixedHeight_ As Long
	Instance relativeWidth_ As Long
	Instance relativeHeight_ As Long

	Class Method Create()
		needCalc_ = 1
	End Method
	Class Method Destroy()
	End Method

	Class Method Recalc()
		Local i As Long
		Local h As Long
		Local w As Long
		Local b As Long

		fixedWidth_ = 0
		relativeWidth_ = 0
		fixedHeight_ = 0
		relativeHeight_ = 0

		For i=0 To count_-1
			h = item_(i).Height
			w = item_(i).Width
			If h<0 Then
				relativeHeight_ = Max&( relativeHeight_, -h )
			Else
				fixedHeight_ = Max&( fixedHeight_, h )
			End If

			If w<0 Then
				relativeWidth_ += -w
			Else
				fixedWidth_ += w
			End If
		Next
		needCalc_ = 0
	End Method

	Interface iSimpLine Guid$("{aad26932-c022-4906-ab3b-1004a5992f5a}")
		Inherit IUnknown

		Property Get Count() As Long
			Property = count_
		End Property

		Property Get Item(ByVal index As Long) As iSimpProp
			If index<0 Or index>count_ Then Exit Property
			needCalc_ = 1: ' Have no idea, err on side of caution
			Property = item_(index)
		End Property

		Property Get FixedWidth() As Long
			If needCalc_ Then Me.ReCalc()
			Property = fixedWidth_
		End Property
		Property Get RelativeWidth() As Long
			If needCalc_ Then Me.ReCalc()
			Property = relativeWidth_
		End Property
		Property Get FixedHeight() As Long
			If needCalc_ Then Me.ReCalc()
			Property = fixedHeight_
		End Property
		Property Get RelativeHeight() As Long
			If needCalc_ Then Me.ReCalc()
			Property = relativeHeight_
		End Property

		Method Add( value As iSimpProp ) As Integer
			Dim ub As Long
			needCalc_ = -1
			ub = UBound( item_() )
			If count_>=ub Then
				ReDim Preserve item_(ub+50)
			End If
			item_(count_) = value
			Method = count_
			Incr count_
		End Method

		Method Remove( value As iSimpProp )
			Local i As Long
			Local j As Long
			needCalc_ = -1
			For i=0 To count_-1
				If ObjPtr( value ) = ObjPtr( item_(i) ) Then
					For j=i To count_-2
						item_(j) = item_(j+1)
					Next
					Decr count_
					item_( count_ ) = Nothing
					Exit Method
				End If
			Next
		End Method

		Method Clear()
			Local i As Long
			needCalc_ = -1
			For i = 0 To count_-1
				item_(i) = Nothing
			Next
			count_ = 0
		End Method
	End Interface
End Class
