Function NewColorList() Common Export As iColorList
	Function = Class "cColorList"
End Function

Class cColorList Guid$("{dceb0e5e-c9d6-4739-b15c-5d7087c5fdd0}") Common
	Instance item_() As iIVColor
	Instance count_ As Long

	Class Method Create()
	End Method
	Class Method Destroy()
	End Method

	Interface iColorList Guid$("{ae17be9b-7785-410f-b0f2-2102322fab48}")
		Inherit IUnknown

		Property Get Item( ByVal offset As Long ) As iIVColor
			If offset<0 Or offset>=count_ Then Exit Property
			Property = item_(offset)
		End Property

		Property Get Count() As Long
			Property = count_
		End Property

		Method Clear() As String
			Local i As Long
			For i=0 To count_-1
				item_(i) = Nothing
			Next
			count_ = 0
		End Method

		Method Add( ByRef value As iIVColor ) As Long
			Local i As Long
			For i=0 To count_-1
				If IsNothing( item_(i) ) Then
					item_(i) = value
					Method = i
					Exit Method
				End If
			Next
			If count_ >= UBound( item_() ) Then
				ReDim Preserve item_( UBound( item_() ) + 10 )
			End If
			item_(count_) = value
			Method = count_
			Incr count_
		End Method

		Method Remove( ByVal offset As Long ) As String
			If offset<0 Or offset>=count_ Then Exit Method
			item_(offset) = Nothing
			While count_ And IsNothing( item_(count_-1) )
				Decr count_
			Wend
		End Method
	End Interface
End Class
