Function NewExtensionList() Common Export As iExtensionList
	Local obj As iExtensionList
	obj = Class "cExtensionList"
	Function = obj
End Function

Class cExtensionList Guid$("{c368dce3-eae3-4781-9bd1-66d419c68289}") Common
	Instance item_() As iExtend
	Instance current_ As Long
	Instance count_ As Long

	Class Method Create()
		current_ = -1
	End Method
	Class Method Destroy()
		Local i As Long
		For i=0 To UBound( item_() )
			item_(i) = Nothing
		Next
		If UBound( item_() )>-1 Then
			Erase item_()
		End If
	End Method

	Interface iExtensionList Guid$("{67140677-dbc0-42c2-b077-48f4301c98ab}")
		Inherit IUnknown

		Method GoTo( ByVal offset As Long )
			If offset < 0 Or offset > UBound( item_() ) Then Exit Method
			current_ = offset
		End Method

		Property Get Current() As iExtend
			Property = Me.Item( current_ )
		End Property
		Method Next() As Long
			If current_ < 0 Or current_ > UBound( item_() ) Then
				current_ = 0
			Else
				Incr current_
			End If
			Method = IIf&( current_ >= 0 And current_ <= UBound( item_() ), -1, 0 )
		End Method
		Method Prev() As Long
			If current_ < 0 Or current_ > UBound( item_() ) Then
				current_ = UBound( item_() )
			Else
				Decr current_
			End If
			Method = IIf&( current_ >= 0 And current_ <= UBound( item_() ), -1, 0 )
		End Method
		Method Reset()
			current_ = -1
		End Method

		Property Get Item( ByVal offset As Long ) As iExtend
			If offset<0 Or offset>UBound( item_() ) Then Exit Property
			Property = item_(offset)
		End Property

		Property Get Count() As Long
			Property = UBound( item_() )+1
		End Property

		Method Add( ByRef value As iExtend ) As String
			Dim ub As Long
			If IsFalse IsInterface( value, iExtend ) Then Exit Method
			ub = UBound( item_() ) + 1
			ReDim Preserve item_( ub )
			item_( ub ) = value
			count_ = ub+1
			If current_ < 0 Then current_ = 0
		End Method

		Method Remove( ByRef offset As Long ) As String
			Local i As Long
			Local ub As Long

			ub = UBound( item_() )

			If offset<0 Or offset>ub Then Exit Method
			If ub=0 Then
				Me.Clear()
			Else
				For i = offset To ub - 1
					item_(i) = Nothing
					item_(i) = item_(i+1)
				Next
				ReDim Preserve item_( ub - 1 )
				count_ = ub
			End If
		End Method

		Method Clear() As String
			If count_>0 And UBound( item_() )>-1 Then
				Erase item_()
			End If
			current_ = -1
		End Method
	End Interface
End Class
