Function NewFont( face_ As WString, ByVal height_ As Long, ByVal bold_ As Long, ByVal italic_ As Long, ByVal angle_ As Long )  Common Export As iFont
	Local obj As iFont
	obj = Class "cFont"
	obj.New( face_, height_, bold_, italic_, angle_ )
	Function = obj
End Function

Class cFont Guid$("{32218b24-75d9-4b92-9c93-0780c77db825}") Common
	Instance baseline_ As Long
	Instance height_ As Long
	Instance descent_ As Long
	Instance externalLeading_ As Long
	Instance internalLeading_ As Long
	Instance avgCharWidth_ As Long
	Instance handle_ As Dword

	Class Method Create()
	End Method
	Class Method Destroy()
		If handle_ Then
			DeleteObject( handle_ )
			handle_ = 0
		End If
	End Method

	Interface iFont Guid$("{59e9afd4-3272-48ae-a3c9-a59a71b704f6}")
		Inherit IUnknown

		Property Get Baseline() As Long
			Property = baseline_
		End Property

		Property Get Height() As Long
			Property = height_
		End Property

		Property Get Width( value As WString ) As Long
			Local hdc As Dword
			Local hdsk As Dword
			Local pmap As Dword
			Local pfont As Dword
			Local sz As Size

			If handle_ Then
				hdsk = GetDesktopWindow()
				hdc = GetDC( hdsk )
				pmap = SetMapMode (hdc, %MM_TEXT)
				pfont = SelectObject( hdc, handle_ )
				GetTextExtentPoint32( hdc, ByVal StrPtr(value), Len(value), sz )
				SelectObject( hdc, pfont )
				SetMapMode( hdc, pmap )
				ReleaseDC( hdsk, hdc )
				Property = sz.cx
			End If
		End Property

		Property Get AvgCharWidth() As Long
			Property = avgCharWidth_
		End Property

		Property Get Handle() As Dword
			Property = handle_
		End Property
		Property Set Handle( ByVal value As Dword )
			Local tm As TEXTMETRIC
			Local hdc As Dword
			Local hdsk As Dword
			Local pmap As Dword
			Local pfont As Dword

			If handle_ Then DeleteObject( handle_ )
			handle_ = value

			height_ = 0
			baseline_ = 0
			descent_ = 0
			externalLeading_ = 0
			internalLeading_ = 0
			avgCharWidth_ = 0
			If handle_ Then
				' Get height and baseline in pixels
				hdsk = GetDesktopWindow()
				hdc = GetDC( hdsk )
				pmap = SetMapMode (hdc, %MM_TEXT)
				pfont = SelectObject( hdc, handle_ )
				GetTextMetrics(hdc, tm)
				height_ = tm.tmHeight
				baseline_ = tm.tmAscent
				descent_ = tm.tmDescent
				externalLeading_ = tm.tmExternalLeading
				internalLeading_ = tm.tmInternalLeading
				avgCharWidth_ = tm.tmAveCharWidth
				SelectObject( hdc, pfont )
				SetMapMode( hdc, pmap )
				ReleaseDC( hdsk, hdc )
			End If
		End Property

		Method New( face_ As WString, ByVal height_ As Long, ByVal bold_ As Long, ByVal italic_ As Long, ByVal angle_ As Long )
			Local lFont As LOGFONT

			If handle_ Then DeleteObject( handle_ )
			handle_ = 0

			angle_ Mod= 360
			If angle_ = 0 Then angle_ = 360

			lFont.lfescapement  = angle_ * 10
			lFont.lforientation = angle_ * 10
			lFont.lfHeight = height_
			lFont.lfWeight = IIf&(bold_,%FW_BOLD,%FW_NORMAL)
			lFont.lfItalic = IIf&(italic_,%TRUE,%FALSE)
			lFont.lfCharSet = %ANSI_CHARSET
			lFont.lfOutPrecision = %OUT_TT_PRECIS
			lFont.lfClipPrecision =%CLIP_DEFAULT_PRECIS
			lFont.lfQuality = %DEFAULT_QUALITY
			lFont.lfPitchAndFamily = %FF_DONTCARE
			lFont.lfFaceName = face_

			Me.Handle = CreateFontIndirect(ByVal VarPtr(lFont))
		End Method
	End Interface
End Class
