Function NewLongLongMap() Common Export As iLongLongMap
	Dim o As iLongLongMap
	o = Class "cLongLongMap"
	Function = o
End Function

Class cLongLongMap Guid$("{66233564-4e01-48f6-8011-50ac550d438e}") Common
	Instance bag_ As iBag
	Class Method Create()
		bag_ = NewBag()
	End Method

	Interface iLongLongMap Guid$("{83a6cfd5-ce9f-4db2-a7e5-7b1b319a21fd}")
		Inherit IUnknown

		' Returns index of added item
		Method Add( ByVal pKey As Long, ByVal pItem As Long ) As Long
			Dim be As iBagEntry
			be = NewLongLongMapEntry( pKey, pItem )
			bag_.Add( be )
		End Method

		' Empty the bag
		Method Clear()
			bag_.Clear()
		End Method

		' -1 if found, 0 if not found
		Property Get Contains( ByRef pKey As Long ) As Long
			Dim be As iBagEntry
			be = NewLongLongMapEntry( pKey, 0 )

			Property = bag_.Contains( be )
		End Property

		' Number of items in the bag
		Property Get Count() As Long
			Property = bag_.Count
		End Property


		' Index of item if found, -1 if not found
		Method IndexOf( ByRef pKey As Long ) As Long
			Dim be As iBagEntry
			be = NewLongLongMapEntry( pKey, 0 )
			Method = bag_.IndexOf( be )
		End Method

		Method Remove( ByRef pKey As Long )
			Dim be As iBagEntry
			be = NewLongLongMapEntry( pKey, 0 )
			bag_.Remove( be )
		End Method

		Method RemoveAt( ByVal i As Long )
			bag_.RemoveAt( i )
		End Method

		' Get an item by index, returns empty string if out of bounds
		Property Get Value( ByVal pKey As Long ) As Long
			Dim be As iBagEntry
			Dim iv As iLongLongPair
			Local idx As Long
			Property = 0
			idx = Me.IndexOf( pKey )
			be = bag_.Item( idx )
			iv = be
			If IsObject( iv ) Then
				Property = iv.Value
			End If
		End Property
		Property Set Value( ByVal pKey As Long, value As Long )
			Dim be As iBagEntry
			Dim iv As iLongLongPair
			Local idx As Long
			idx = Me.IndexOf( pKey )
			be = bag_.Item( idx )
			iv = be
			If IsObject( iv ) Then
				iv.Value = value
			End If
		End Property
		Property Get Key( ByVal index As Long ) As Long
			Dim be As iBagEntry
			Dim iv As iLongLongPair
			Property = 0
			be = bag_.Item( index )
			iv = be
			If IsObject( iv ) Then
				Property = iv.Key
			End If
		End Property
	End Interface
End Class

Function NewLongLongMapEntry( ByRef key As Long, ByRef value As Long ) As iBagEntry
	Local a As iBagEntry
	Local b As iLongLongPair

	a = Class "cLongLongMapEntry"
	b = a
	b.Key = key
	b.Value = value
	Function = a
End Function

'=================================================================
' LongLongMap entries (internal implementation class)
'=================================================================
Class cLongLongMapEntry Guid$("{c2fe2be7-103b-4948-a68b-ec023958fe0a}") Common
	Instance vHashCode As Long
	Instance vNext As Long
	Instance vKey As Long
	Instance vValue As Long

	Interface iLongLongPair Guid$("{bffad939-059f-41a6-b081-618363e9fb55}")
		Inherit IUnknown

		Property Get Value() As Long
			Property = vValue
		End Property
		Property Set Value( ByVal value As Long )
			vValue = value
		End Property

		Property Get Key () As Long
			Property = vKey
		End Property
		Property Set Key ( ByVal pVal  As Long)
			Local vHashCode As Long
			Local p As Byte Ptr
			Local i As Long

			If vKey <> pVal Then
				vKey  = pVal

				vHashCode = 1

				p = VarPtr( vKey )
				For i=1 To SizeOf(vKey)
					vHashCode = 1610612741 * vHashCode + @p
					Incr p
				Next
				vHashCode And= &H7FFFFFFF
			End If
		End Property
	End Interface

	Interface iBagEntry Guid$("{88765CD3-3E71-41CC-B0F3-29C8A4CE395A}")
		Inherit IUnknown

		Method Same( ByVal value As iBagEntry ) As Long
			Local a As iLongLongPair
			Local b As iLongLongPair
			a = Me
			b = value
			If IsObject(a) And IsObject(b) Then
				Method = IIf&( a.Key = b.Key, 1, 0 )
			End If
		End Method

		Property Get HashCode () As Long
			Property = vHashCode
		End Property
		Property Set HashCode ( ByVal pHashCode  As Long)
			vHashCode  = pHashCode
		End Property

		Property Get Next () As Long
			Property = vNext
		End Property
		Property Set Next ( ByVal pNext  As Long)
			vNext  = pNext
		End Property
	End Interface
End Class
