' General support routines

' Gets the next child id for a window
Function GetNextChildId() Common Export As Long
	Static lastId As Long

	' Another alternative would be to enumerate child windows, getting max ID
	' this seems faster, but has to be used consistently to work
	If lastId = 0 Then lastId = 1000
	Incr lastId
	lastId = Min&( lastId Mod 32760, 1000 ): ' Recycle

	Function = lastId
End Function

Sub DrawGradientBar( ByVal hdc As Dword, ByRef rc As RECT, ByVal c1 As Dword, ByVal c2 As Dword, ByVal vert As Long ) Common Export
	Local gRect As GRADIENT_RECT
	Local cc As CCOver
	Dim vert(1) As TRIVERTEX

	cc.v = c1
	vert(0).x     = rc.Left
	vert(0).y     = rc.Top
	vert(0).Red   = Mak(Word, 0, cc.p.r )
	vert(0).Green = Mak(Word, 0, cc.p.g )
	vert(0).Blue  = Mak(Word, 0, cc.p.b )
	vert(0).Alpha = &hff00
	cc.v = c2
	vert(1).x     = rc.Right
	vert(1).y     = rc.Bottom
	vert(1).Red   = Mak(Word, 0, cc.p.r )
	vert(1).Green = Mak(Word, 0, cc.p.g )
	vert(1).Blue  = Mak(Word, 0, cc.p.b )
	vert(1).Alpha = &hff00
	gRect.UpperLeft  = 0
	gRect.LowerRight = 1
	GradientFill( hdc, vert(0), 2, gRect, 1, IIf&(vert, %GRADIENT_FILL_RECT_V, %GRADIENT_FILL_RECT_H) )
End Sub

Function SystemError() Common Export As WString
		Static buffer As WStringZ * 512
		Local errorCode As Long
		errorCode = GetLastError()
		FormatMessage( %FORMAT_MESSAGE_FROM_SYSTEM, ByVal %NULL, errorCode, %NULL, buffer, SizeOf(buffer), ByVal %NULL )
		Function = buffer
End Function


Function ICreateFont( face_ As WString, ByVal height_ As Long, ByVal bold_ As Long, ByVal italic_ As Long, ByVal angle_ As Long ) As Dword
	Local lFont As LOGFONT

	angle_ Mod= 360
	If angle_ = 0 Then angle_ = 360

	lFont.lfescapement  = angle_ * 10
	lFont.lforientation = angle_ * 10
	lFont.lfHeight = height_
	lFont.lfWeight = IIf&(bold_,%FW_BOLD,%FW_NORMAL)
	lFont.lfItalic = IIf&(italic_,%TRUE,%FALSE)
	lFont.lfCharSet = %ANSI_CHARSET
	lFont.lfOutPrecision = %OUT_TT_PRECIS
	lFont.lfClipPrecision =%CLIP_DEFAULT_PRECIS
	lFont.lfQuality = %DEFAULT_QUALITY
	lFont.lfPitchAndFamily = %FF_DONTCARE
	lFont.lfFaceName = face_

	Function = CreateFontIndirect(ByVal VarPtr(lFont))
End Function

Sub GetShifts( ByRef sk As ShiftKeys ) Common
	sk.isShift = IIf&( (GetKeyState(%VK_Shift)   And &h80) <> 0, -1, 0)
	sk.isCtrl  = IIf&( (GetKeyState(%VK_CONTROL) And &h80) <> 0, -1, 0)
	sk.isAlt   = IIf&( (GetKeyState(%VK_Menu)    And &h80) <> 0, -1, 0)
	sk.isWnd   = IIf&( (GetKeyState(%VK_Apps)    And &h80) <> 0, -1, 0)
End Sub
