Interface iWin Guid$("{9880cedb-b3de-4997-b6bb-d6c1178788d8}")
	Inherit IUnknown
	Method Proc( ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long, ByRef ret As Long) As Long
	Property Get HWnd() As Dword
	Property Get Parent() As Dword
	Property Set Parent( ByVal value As Dword )
	Method Resize( ByVal w As Long, ByVal h As Long )
	Method Move( ByVal l As Long, ByVal t As Long )
	Property Get ChildId() As Long
	Property Set ChildId( ByVal childId As Long )
End Interface

Function NewWinTrack() Common Export As iWinTrack
	Function = Class "cWinTrack"
End Function

Class cWinTrack Guid$("{6F2EBA08-D8F2-4101-9D9D-E184E49A7DD2}") Common
	Instance objs_() As iWin
	Instance cnt_ As Long
	Class Method Destroy()
		Local i As Long
		For i=0 To UBound( objs_() )
			objs_(i) = Nothing
		Next
		Erase objs_()
	End Method
	Interface iWinTrack Guid$("{2E27A20C-3F8C-405A-8DEA-B03EC6FB0EFC}")
		Inherit IUnknown

		Method Add( ByRef obj As iWin )
			Local i As Long
			Local ub As Long
			If IsFalse IsInterface( obj, iWin ) Then
				Exit Method
			End If
			If IsWindow( obj.HWnd ) = 0 Then Exit Method

			' Reuse slots for destroyed windows
			For i=0 To cnt_-1
				If IsFalse IsObject( objs_(i) ) Then Exit For
			Next
			ub = UBound( objs_() )
			If i = cnt_ And cnt_ >= ub Then
				ReDim Preserve objs_( ub + 10 )
			End If
			objs_(i) = obj
			SetWindowLong( obj.HWnd, %GWL_USERDATA, i )
			If i=cnt_ Then Incr cnt_
		End Method
		Property Get Count() As Long
			Property = cnt_
		End Property
		Method Clear()
			Local i As Long
			For i=0 To cnt_
				objs_(i) = Nothing
			Next
			Erase objs_()
		End Method
		Method Remove( ByRef obj As iWin ) As iWin
			Local idx As Long
			Local hWnd As Dword

			If IsFalse IsInterface( obj, iWin ) Then Exit Method
			hWnd = obj.HWnd
			If hWnd = 0 Then Exit Method
			idx = GetWindowLong( hWnd, %GWL_USERDATA )
			If idx>=0 And idx<cnt_ Then
				Method = objs_(idx)
				objs_(idx) = Nothing
			End If
		End Method

		Property Get Get( ByVal hWnd As Dword ) As iWin
			Local idx As Long
			idx = GetWindowLong( hWnd, %GWL_USERDATA )
			If idx>=0 And idx<cnt_ Then
				Property = objs_(idx)
			End If
		End Property
	End Interface
End Class
