Function NewRenderFill( ByVal color1 As Dword, Optional ByRef color2 As Dword, Optional ByRef radius As Long, Optional ByRef angle As Long ) Common Export As iRender
	Local obj As iRenderFill
	Local o As iRender

	obj = Class "cRenderFill"
	o = obj
	obj.Color1.Value = color1
	If IsFalse IsMissing( color2 ) Then
		obj.Color2.Value = color2
	Else
		obj.Color2.Value = color1
	End If
	If IsFalse IsMissing( radius ) Then
		obj.Radius = radius
	End If
	If IsFalse IsMissing( angle ) Then
		obj.Angle = angle
	End If
	Function = o
End Function

Function NewSysRenderFill( ByVal color1 As Dword, Optional ByRef color2 As Dword, Optional ByRef radius As Long, Optional ByRef angle As Long ) Common Export As iRender
	Local obj As iRenderFill
	Local o As iRender

	obj = Class "cRenderFill"
	o = obj
	obj.Color1.SysColor = color1
	If IsFalse IsMissing( color2 ) Then
		obj.Color2.SysColor = color2
	Else
		obj.Color2.SysColor = color1
	End If
	If IsFalse IsMissing( radius ) Then
		obj.Radius = radius
	End If
	If IsFalse IsMissing( angle ) Then
		obj.angle = Angle
	End If
	Function = o
End Function

Class cRenderFill Guid$("{9f1aec23-a281-4ace-9396-122302ce894c}") Common
	Instance color1_ As iIVColor
	Instance color2_ As iIVColor
	Instance radius_ As Long
	Instance angle_ As Long

	Class Method Create()
		color1_ = NewIVColor(0)
		color2_ = NewIVColor(0)
		radius_ = 0
		angle_ = 0
	End Method
	Class Method Destroy()
		color1_.TestRelease()
		color2_.TestRelease()
		color1_ = Nothing
		color2_ = Nothing
	End Method

	Interface iRenderFill Guid$("{c8ba9b69-5fc2-4422-a88c-3869afe5488e}")
		Inherit IUnknown

		Property Get Color1() As iIVColor
			Property = color1_
		End Property
		Property Get Color2() As iIVColor
			Property = color2_
		End Property
		Property Get Radius() As Long
			Property = radius_
		End Property
		Property Set Radius( ByRef value As Long )
			radius_ = value
		End Property
		Property Get Angle() As Long
			Property = angle_
		End Property
		Property Set Angle( ByVal value As Long )
			angle_ = value
		End Property
	End Interface

	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local hClipRgn As Dword
			Local br As Dword
			Local a As Long

			If radius_ > 0 Then
				hClipRgn = CreateRoundRectRgn( rc.Left, rc.Top, rc.Right+1, rc.Bottom+1, radius_, radius_ )
				SelectClipRgn( hdc, hClipRgn )
			End If
			If color2_.Value <> color1_.Value Then
				a = angle_ Mod 90
				If a=0 Then
					DrawGradient2( hdc, rc, color1_.Value, color2_.Value, angle_ )
				Else
					DrawGradient( hdc, rc, color1_.Value, color2_.Value, angle_ )
				End If
			Else
				' Solid Fill
				br = CreateSolidBrush( color1_.Value )
				FillRect( hdc, rc, br )
				DeleteObject( br )
			End If
			If radius_ > 0 Then
				SelectClipRgn( hdc, %NULL )
				DeleteObject( hClipRgn )
			End If
		End Method
	End Interface
End Class

Sub DrawGradient2( ByVal hdc As Dword, ByRef rc As RECT, ByVal color1 As Long, ByVal color2 As Long, ByVal Angle As Long )
	Local gRect As GRADIENT_RECT
	Local br As Dword
	Local cc As CCOver
	Local dir As Long
	Dim vert(1) As TRIVERTEX

				' Gradient field
	angle Mod=360

	If angle Mod 180 = 0 Then
		dir = %GRADIENT_FILL_RECT_V
	Else
		dir = %GRADIENT_FILL_RECT_H
	End If
	cc.v = color1
	vert(0).x     = rc.Left
	vert(0).y     = rc.Top
	vert(0).Red   = Mak(Word, 0, cc.p.r )
	vert(0).Green = Mak(Word, 0, cc.p.g )
	vert(0).Blue  = Mak(Word, 0, cc.p.b )
	vert(0).Alpha = &hff00

	cc.v = color2
	vert(1).x     = rc.Right
	vert(1).y     = rc.Bottom
	vert(1).Red   = Mak(Word, 0, cc.p.r )
	vert(1).Green = Mak(Word, 0, cc.p.g )
	vert(1).Blue  = Mak(Word, 0, cc.p.b )
	vert(1).Alpha = &hff00

	If angle = 0 Or angle=-90 Or angle=270 Then
		gRect.UpperLeft  = 0
		gRect.LowerRight = 1
	Else
		gRect.UpperLeft  = 1
		gRect.LowerRight = 0
	End If

	GradientFill( hdc, vert(0), 2, gRect, 1, dir )
End Sub

' Adapted from http://www.powerbasic.com/support/pbforums/showthread.php?t=43475&highlight=AnyAngle
' Jordi Valls
' and http://www.powerbasic.com/support/pbforums/showthread.php?t=47539&highlight=fast+pixel+createdibsection
' Gary Beene
Sub DrawGradient( ByVal hdc As Dword, ByRef rc As RECT, ByVal colour1 As Long, ByVal colour2 As Long, ByVal Angle As Single )
	Register i As Long, j As Long
	Local Colour, R1, G1, B1, R2, G2, B2, distR, distG, distB As Long
	Local iIn, jIn, iEnd, jEnd, ScanW, Offset As Long
	Local gr, uSin, uCos, Quadr, lGrad() As Long
	Local h As Long
	Local w As Long
	Local AngleDist, AngleComp As Single
	Local pBits As Long Ptr
	Local cc As CCOver

	Local mhdc As Dword
	Local hImg As Dword
	Local pImg As Dword
	Local bm As Bitmap
	Local bmi As BitMapInfo

	'--- set current board contents as DIB in a dynamic string
	w = rc.Right - rc.Left
	h = rc.Bottom - rc.Top
	mhdc = CreateCompatibleDC(hdc)          'create compatible memory DC
	bmi.bmiHeader.biSize        = SizeOf(bmi.bmiHeader) 'set bmi info (needed for GetDIBits)
	bmi.bmiHeader.biWidth       = w
	bmi.bmiHeader.biHeight      = - h
	bmi.bmiHeader.biPlanes      = 1
	bmi.bmiHeader.biBitCount    = 32
	bmi.bmiHeader.biCompression = %BI_RGB
	hImg = CreateDIBSection(mhdc, bmi, %DIB_RGB_COLORS, 0, 0, 0)
	pImg = SelectObject(mhdc,hImg)                        'put hImg section into memory DC
	GetObject(hImg, SizeOf(bm), bm)                  'get info about the bitmap
	pBits = bm.bmBits

	'--- normalize angle (0 to 360)
	'invert value needed if DIB string is used ???
	'not needed if StretchDIBits API is used   ???
	Angle = (Angle Mod 360) * -1
	If (Angle < 0) Then Angle = 360 + Angle
	'--- get quadrant (0 - 3)
	Quadr = Angle \ 90
	'--- normalize to 0 90
	Angle = Angle Mod 90
	'--- calculate gradient length ('distance')
	If (Quadr Mod 2 = 0) Then
		AngleDist = Atn(w / h) * 57.29577951308232##
	Else
		AngleDist = Atn(h / w) * 57.29577951308232##
	End If
	AngleComp = (90 - Abs(Angle - AngleDist)) * 0.017453292519943##
	Angle = Angle * 0.017453292519943##
	gr = Sqr(w * w + h * h) * Sin(AngleComp)
	'--- decompose colors
	If (Quadr > 1) Then Swap colour1, colour2
	cc.v = colour1
	r1 = cc.p.r
	g1 = cc.p.g
	b1 = cc.p.b
	cc.v = colour2
	r2 = cc.p.r
	g2 = cc.p.g
	b2 = cc.p.b

	'--- get color distances
	distR = R2 - R1
	distG = G2 - G1
	distB = B2 - B1
	'--- size gradient-colors array
	ReDim lGrad(0 To gr - 1)
	'--- calculate gradient-colors
	iEnd = gr - 1
	For i = 0 To iEnd
		lGrad(i) = B1 + (distB * i) \ iEnd + 256 * (G1 + (distG * i) \ iEnd) + 65536 * (R1 + (distR * i) \ iEnd)
	Next i
	'--- render gradient DIB
	iEnd = w - 1  :  jEnd = h - 1
	Select Case Quadr
		Case 0, 2
			uSin   = Sin(Angle) * 1000
			uCos   = Cos(Angle) * 1000
			Offset = 0
			ScanW  = w
		Case 1, 3
			uSin   = Sin(90 * 0.017453292519943## - Angle) * 1000
			uCos   = Cos(90 * 0.017453292519943## - Angle) * 1000
			Offset = jEnd * w
			ScanW  = -w
	End Select
	jIn = 0
	iIn = 0

	'---fill DIB array with colors
	For j = 0 To jEnd
		iIn = jIn
		For i = 0 To iEnd
			@pBits[i + Offset] = lGrad(iIn \ 1000)
			iIn += uSin
		Next i
		jIn += uCos
		Offset += ScanW
	Next j

	BitBlt( hdc, rc.Left, rc.Top, rc.Right-rc.Left, rc.Bottom-rc.Top, mhdc, 0, 0, %SRCCOPY )
	SelectObject( mhdc, pImg )
	DeleteDC( mhdc )
	DeleteObject( hImg )
End Sub
