' TopHeight > 0 Fixed amount
' TopHeight < 0 Percentage of height
Function NewRenderSplit( ByVal topHeight As Long, ByVal dir As Long, ByVal c1 As Dword, ByVal c2 As Dword, ByVal c3 As Dword, ByVal c4 As Dword ) Common Export As iRender
	Local obj As iRender
	Local o As iRenderSplit
	obj = Class "cRenderSplit"
	o = obj
	o.TopHeight = topHeight
	o.Direction = dir
	o.Color1 = c1
	o.Color2 = c2
	o.Color3 = c3
	o.Color4 = c4
	Function = obj
End Function

Class cRenderSplit Guid$("{e53de032-444d-4b5c-bd22-fda9310ce307}") Common
	Instance topheight_ As Long
	Instance color1_ As Dword
	Instance color2_ As Dword
	Instance color3_ As Dword
	Instance color4_ As Dword
	Instance dir_ As Long

	Class Method Create()
	End Method
	Class Method Destroy()
	End Method

	Interface iRenderSplit Guid$("{d8493414-30f2-4a91-824d-85050f866597}")
		Inherit IUnknown

		Property Get TopHeight() As Long
			Property = topheight_
		End Property
		Property Set TopHeight( ByRef value As Long )
			topheight_ = value
		End Property

		Property Get Direction() As Long
			Property = dir_
		End Property
		Property Set Direction( ByRef value As Long )
			dir_ = value
		End Property

		Property Get Color1() As Dword
			Property = color1_
		End Property
		Property Set Color1( ByRef value As Dword )
			color1_ = value
		End Property

		Property Get Color2() As Dword
			Property = color2_
		End Property
		Property Set Color2( ByRef value As Dword )
			color2_ = value
		End Property

		Property Get Color3() As Dword
			Property = color3_
		End Property
		Property Set Color3( ByRef value As Dword )
			color3_ = value
		End Property

		Property Get Color4() As Dword
			Property = color4_
		End Property
		Property Set Color4( ByRef value As Dword )
			color4_ = value
		End Property
	End Interface
	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local hClipRgn As Dword
			Local gRect As GRADIENT_RECT
			Local br As Dword
			Local cc As CCOver
			Local rc2 As RECT
			Local ys As Long
			Local xs As Long
			Local ye As Long
			Local xe As Long
			Local dir As Long
			Dim vert(1) As TRIVERTEX

			If dir_ <> %IVGradient.Vertical Then
				dir = %GRADIENT_FILL_RECT_H
				xs = topHeight_
				If xs<0 Then
					xs = rc.Left - (rc.Right - rc.Left) * xs / 100
				End If
				xe = xs
				ys = rc.Bottom
				ye = rc.Top
			Else
				dir = %GRADIENT_FILL_RECT_V
				ys = topHeight_
				If ys<0 Then
					ys = rc.Top - (rc.Bottom - rc.Top) * ys / 100
				End If
				ye = ys
				xs = rc.Right
				xe = rc.Left
			End If

			If color1_ <> color2_ Then
				' Gradient fill
				cc.v = color1_
				vert(0).x     = rc.Left
				vert(0).y     = rc.Top
				vert(0).Red   = Mak(Word, 0, cc.p.r )
				vert(0).Green = Mak(Word, 0, cc.p.g )
				vert(0).Blue  = Mak(Word, 0, cc.p.b )
				vert(0).Alpha = &hff00

				cc.v = color2_
				vert(1).x     = xs
				vert(1).y     = ys
				vert(1).Red   = Mak(Word, 0, cc.p.r )
				vert(1).Green = Mak(Word, 0, cc.p.g )
				vert(1).Blue  = Mak(Word, 0, cc.p.b )
				vert(1).Alpha = &hff00

				gRect.UpperLeft  = 0
				gRect.LowerRight = 1

				GradientFill( hdc, vert(0), 2, gRect, 1, dir )
			Else
				' Solid Fill
				br = CreateSolidBrush( color1_ )
				SetRect( rc2, rc.Left, rc.Top, xs, ys )
				FillRect( hdc, rc2, br )
				DeleteObject( br )
			End If


			If color3_ <> color4_ Then
				' Gradient fill
				cc.v = color3_
				vert(0).x     = xe
				vert(0).y     = ye
				vert(0).Red   = Mak(Word, 0, cc.p.r )
				vert(0).Green = Mak(Word, 0, cc.p.g )
				vert(0).Blue  = Mak(Word, 0, cc.p.b )
				vert(0).Alpha = &hff00

				cc.v = color4_
				vert(1).x     = rc.Right
				vert(1).y     = rc.Bottom
				vert(1).Red   = Mak(Word, 0, cc.p.r )
				vert(1).Green = Mak(Word, 0, cc.p.g )
				vert(1).Blue  = Mak(Word, 0, cc.p.b )
				vert(1).Alpha = &hff00

				gRect.UpperLeft  = 0
				gRect.LowerRight = 1

				GradientFill( hdc, vert(0), 2, gRect, 1, dir )
			Else
				' Solid Fill
				br = CreateSolidBrush( color3_ )
				SetRect( rc2, xe, ye, rc.Right, rc.Bottom )
				FillRect( hdc, rc2, br )
				DeleteObject( br )
			End If
		End Method
	End Interface
End Class
