#Include Once "UxTheme.inc"
#Include Once "VsStyle.inc"
#Include Once "VsSym32.inc"

Global RenderThemeHeader_hTheme As Dword

Sub Render_OnThemeChanged() Common
	If RenderThemeHeader_hTheme Then
		CloseThemeData( RenderThemeHeader_hTheme )
	End If
	RenderThemeHeader_hTheme = OpenThemeData( GetDesktopWindow(), "HEADER" )
End Sub

Function NewRenderThemeHeader( ByVal State As Dword ) Common Export As iRender
	Local obj As iRenderThemeHeader
	Local o As iRender

	obj = Class "cRenderThemeHeader"
	o = obj
	obj.State = State
	Function = o
End Function

Class cRenderThemeHeader Guid$("{f28abbaf-e26b-4ebc-847b-5ccce93963fd}") Common
	Instance state_ As Dword
	Instance st_ As Dword

	Class Method Create()
		state_ = %IVState.Normal
	End Method

	Interface iRenderThemeHeader Guid$("{b25f3e55-677b-4eb1-bd9d-7bf635338208}")
		Inherit IUnknown

		Property Get State() As Dword
			Property = state_
		End Property
		Property Set State( ByRef value As Dword )
			state_ = value
			Select Case state_
				Case %IVState.Normal:   st_ = %HIS_NORMAL
				Case %IVState.Selected: st_ = %HIS_PRESSED
				Case %IVState.Hot:      st_ = %HIS_HOT
			End Select
		End Property
	End Interface
	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			If IsFalse RenderThemeHeader_hTheme Then Call Render_OnThemeChanged()
			DrawThemeBackground( RenderThemeHeader_hTheme, hdc, %HP_HEADERITEM, st_, rc, ByVal %NULL )
			DrawThemeEdge( RenderThemeHeader_hTheme, hdc, %HP_HEADERITEM, st_, rc, %BDR_RAISEDOUTER, %BF_RECT, ByVal %NULL )
		End Method
	End Interface
End Class
