' Size is height for top or bottom, width for left or right
Function NewRenderBound( drawContent As iRender, ds As iDataSource, Optional promptLoc As Long, Optional promptSize As Long, Optional drawPrompt As iRender ) Common Export As iRender
	Local obj As iRender
	Local rb As iRenderBound

	obj = Class "cRenderBound"
	rb = obj
	If IsObject( rb ) Then
		rb.DrawContent = drawContent
		rb.DataSource = ds
		If IsFalse IsMissing( promptLoc ) Then
			rb.PromptLoc = promptLoc
		End If
		If IsFalse IsMissing( promptSize ) Then
			rb.PromptSize = promptSize
		End If
		If IsFalse IsMissing( drawPrompt ) Then
			rb.DrawPrompt = drawPrompt
		End If
	End If
	Function = obj
End Function

Class cRenderBound Guid$("{bf619c55-8b95-4ea9-a95a-6893b9b63b67}") Common
	Instance datasource_ As iDataSource
	Instance drawContent_ As iRender
	Instance drawPrompt_ As iRender
	Instance promptLoc_ As Long
	Instance promptSize_ As Long

	Class Method Create()
		promptSize_ = 50
	End Method
	Class Method Destroy()
	End Method

	Interface iRenderBound Guid$("{b8a7ce58-dd65-4dea-85ee-496045412a9c}")
		Inherit IUnknown

		Property Get Datasource() As iDataSource
			Property = datasource_
		End Property
		Property Set Datasource( ByRef value As iDataSource )
			datasource_ = value
		End Property

		Property Get DrawContent() As iRender
			Property = drawContent_
		End Property
		Property Set DrawContent( ByRef value As iRender )
			drawContent_ = value
		End Property

		Property Get DrawPrompt() As iRender
			Property = drawPrompt_
		End Property
		Property Set DrawPrompt( ByRef value As iRender )
			drawPrompt_ = value
		End Property

		Property Get PromptLoc() As Long
			Property = promptLoc_
		End Property
		Property Set PromptLoc( ByRef value As Long )
			promptLoc_ = value
		End Property

		Property Get PromptSize() As Long
			Property = promptSize_
		End Property
		Property Set PromptSize( ByRef value As Long )
			promptSize_ = value
		End Property
	End Interface

	Interface iAlign Guid$("{f8de15d9-b7e2-423a-bb15-72d1882e11da}")
		Inherit IUnknown
		Property Get Align() As Dword
			Local a As iAlign
			If IsFalse IsObject( drawContent_ ) Then Exit Property
			a = drawContent_
			If IsFalse IsObject( a ) Then Exit Property
			Property = a.Align
		End Property
		Property Set Align( ByRef value As Dword )
			Local a As iAlign
			If IsFalse IsObject( drawContent_ ) Then Exit Property
			a = drawContent_
			If IsFalse IsObject( a ) Then Exit Property
			a.Align = value
		End Property
	End Interface
	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local crc As RECT
			Local rc2 As RECT
			Local value As WString
			Local a As iAlign
			Local v As iValue
			Local align As Long
			Local fn As iHasFont
			Local cbase As Long
			Local pbase As Long
			Local mbase As Long

			If IsFalse IsObject( dataSource_ ) Then Exit Method
			CopyRect( crc, rc )
			CopyRect( rc2, rc )
			If promptLoc_<>%IVAlign.None And IsObject( drawPrompt_ ) Then
				a = drawPrompt_
				If IsObject( a ) Then
					' Update rectangles for prompt and content
					Select Case promptLoc_ And 12
						Case %IVAlign.Top
							crc.Bottom = crc.Top + promptSize_
							rc2.Top = crc.Bottom - 2
							a.Align = (promptLoc_ And 3)
						Case %IVAlign.Middle
							If (promptLoc_ And %IVAlign.Right)<>0 Then
								' Right end
								crc.Left = crc.Right - promptSize_
								rc2.Right = crc.Left
								a.Align = %IVAlign.Right Xor IIf&( (promptLoc_ And %IVAlign.Reverse)<>0, 3, 0 )
							Else
								' Left end
								crc.Right = crc.Left + promptSize_
								rc2.Left = crc.Right
								a.Align = %IVAlign.Left Xor IIf&( (promptLoc_ And %IVAlign.Reverse)<>0, 3, 0 )
							End If
						Case %IVAlign.Bottom
							crc.Top = crc.Bottom - promptSize_
							rc2.Bottom = crc.Top + 2
							a.Align = (promptLoc_ And 3)
'            Case %IVAlign.Baseline
'              fn = drawContent_
'              if isObject( fn ) Then
'                cbase = fn.Baseline
'              Else
'                cbase = rc.Bottom
'              End If
'              fn = drawPrompt_
'              if isobject( fn ) Then
'                pbase = fn.Baseline
'              Else
'                pbase = rc.Bottom
'              End If
'              mbase = Max&( cbase, pbase )
'              crc.Top += mbase - pbase
'              crc.Bottom = crc.Top
					End Select
				End If
				v = drawPrompt_
				If IsObject( v ) Then
					v.Value = dataSource_.Value( -1, c )
				End If
				drawPrompt_.Render( hdc, crc, r, c )
			End If

			v = drawContent_
			If IsObject( v ) Then
				v.Value = dataSource_.Value( r, c )
			End If
			drawContent_.Render( hdc, rc2, r, c )
		End Method
	End Interface
End Class
