Function NewRenderBar( ByVal clr As Dword, ByVal side As Long, Optional ByRef thickness As Long ) Common Export As iRender
	Local obj As iRenderBar
	Local o As iRender
	obj = Class "cRenderBar"
	If IsObject( obj ) Then
		o = obj
		obj.Color = clr
		obj.Side = side
		If IsFalse IsMissing( thickness ) Then
			obj.Thickness = thickness
		End If
	End If
	Function = o
End Function

Class cRenderBar Guid$("{c4dc60a5-ef3f-4930-b1f9-9ecdac33232c}") Common
	Instance color_ As Dword
	Instance side_ As Long
	Instance thickness_ As Long

	Class Method Create()
		color_ = RGB(0,0,0)
		side_ = %IVSide.Bottom
		thickness_ = 2
	End Method

	Interface iRenderBar Guid$("{e56043f7-f530-41d8-bf38-101f07f0802d}")
		Inherit IUnknown

		Property Get Color() As Dword
			Property = color_
		End Property
		Property Set Color( ByRef value As Dword )
			color_ = value
		End Property

		Property Get Side() As Long
			Property = side_
		End Property
		Property Set Side( ByVal value As Long )
			Select Case value
				Case %IVSide.Top, %IVSide.Left, %IVSide.Right, %IVSide.VCenter, %IVSide.HCenter
					side_ = value
				Case Else
					side_ = %IVSide.Bottom
			End Select
		End Property

		Property Get Thickness() As Long
			Property = thickness_
		End Property
		Property Set Thickness( ByRef value As Long )
			If value>0 Then
				thickness_ = value
			End If
		End Property
	End Interface
	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local rc2 As RECT
			Local br As Dword
			Local a As Long
			Select Case side_
				Case %IVSide.Top:    SetRect( rc2, rc.Left,             rc.Top,               rc.Right,           rc.Top+thickness_ )
				Case %IVSide.Left:   SetRect( rc2, rc.Left,             rc.Top,               rc.Left+thickness_, rc.Bottom )
				Case %IVSide.Right:  SetRect( rc2, rc.Right-thickness_, rc.Top,               rc.Right,           rc.Bottom )
				Case %IVSide.Bottom: SetRect( rc2, rc.Left,             rc.Bottom-thickness_, rc.Right,           rc.Bottom )
				Case %IVSide.VCenter:
					a = rc.Top + (rc.Bottom - rc.Top - thickness_) / 2
					SetRect( rc2, rc.Left, a, rc.Right, a+thickness_ )
				Case %IVSide.HCenter
					a = rc.left + (rc.Right - rc.Left - thickness_) / 2
					SetRect( rc2, a, rc.Top, a+thickness_, rc.Bottom )
			End Select
			br = CreateSolidBrush( color_ )
			FillRect( hdc, rc2, br )
			DeleteObject( br )
		End Method
	End Interface
End Class
