Function NewRenderOutline( ByVal color1 As Dword, Optional ByRef radius As Long ) Common Export As iRender
	Local obj As iRenderOutline
	Local o As iRender

	obj = Class "cRenderOutline"
	o = obj
	obj.Color1.Value = color1
	If IsFalse IsMissing( radius ) Then
		obj.Radius = radius
	End If
	Function = o
End Function

Function NewSysRenderOutline( ByVal color1 As Dword, Optional ByRef radius As Long ) Common Export As iRender
	Local obj As iRenderOutline
	Local o As iRender

	obj = Class "cRenderOutline"
	o = obj
	obj.Color1.Value = color1
	If IsFalse IsMissing( radius ) Then
		obj.Radius = radius
	End If
	Function = o
End Function

Class cRenderOutline Guid$("{f9835bcf-cbc5-4d9d-af82-fe77c775a5e6}") Common
	Instance color1_ As iIVColor
	Instance radius_ As Long
	Instance penWidth_ As Long

	Class Method Create()
		color1_ = NewIVColor(0)
		radius_ = 0
		penWidth_ = 1
	End Method
	Class Method Destroy()
		color1_.TestRelease()
		color1_ = Nothing
	End Method

	Interface iRenderOutline Guid$("{e966ce5d-f65a-49c2-926d-d6feac369a40}")
		Inherit IUnknown

		Property Get Color1() As iIVColor
			Property = color1_
		End Property
		Property Get Radius() As Long
			Property = radius_
		End Property
		Property Set Radius( ByRef value As Long )
			radius_ = value
		End Property
		Property Get PenWidth() As Long
			Property = penWidth_
		End Property
		Property Set PenWidth( ByVal value As Long )
			If value>0 Then
				penWidth_ = value
			End If
		End Property
	End Interface

	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local hPen As Dword
			Local oldPen As Dword
			Local oldBrush As Dword

			If radius_>0 Then
				' Draw Round Rectangle border
				hPen = CreatePen( %PS_SOLID, penWidth_, color1_.Value )
				oldPen = SelectObject( hdc, hPen )
				oldBrush = SelectObject( hdc, GetStockObject( %NULL_BRUSH ) )
				RoundRect( hdc, rc.Left, rc.Top, rc.Right, rc.Bottom, radius_, radius_ )
				SelectObject( hdc, oldBrush )
				SelectObject( hdc, oldPen )

				DeleteObject( hPen )
			Else
				' Draw Rectangle border
				hPen = CreatePen( %PS_SOLID, penWidth_, color1_.Value )
				oldPen = SelectObject( hdc, hPen )
				oldBrush = SelectObject( hdc, GetStockObject( %NULL_BRUSH ) )
				Rectangle( hdc, rc.Left, rc.Top, rc.Right, rc.Bottom )
				SelectObject( hdc, oldBrush )
				SelectObject( hdc, oldPen )
				DeleteObject( hPen )
			End If
		End Method
	End Interface
End Class
