 Function NewRenderIcon( ByVal siz As Long, Optional position As Long, Optional ByRef map As iValueToLong ) Common Export As iRender
	Local o As iRender
	Local obj As iRenderIcon
	o = Class "cRenderIcon"
	obj = o
	obj.Size = siz
	If IsFalse IsMissing( position ) Then
		obj.Position = position
	End If
	If IsFalse IsMissing( map ) Then
		obj.Map = map
	End If
	Function = o
End Function

Sub SetRenderIcon( ByVal obj As iRender, ByVal offset As Long, ByVal hIcon As Dword ) Common Export
	Local o As iRenderIcon
	o = obj
	If IsInterface( o, iRenderIcon ) Then
		o.Icon( offset ) = hIcon
	End If
End Sub
Sub SetRenderIconList( ByVal obj As iRender, ByRef icons() As Dword ) Common Export
	Local o As iRenderIcon
	Local i As Long
	o = obj
	If IsInterface( o, iRenderIcon ) Then
		For i=0 To UBound( icons() )
			o.Icon(i) = icons(i)
		Next
	End If
End Sub

Class cRenderIcon Guid$("{d9f97968-1edd-48d3-8a94-77aa2e24074f}") Common
	Instance hIcon() As Dword
	Instance size_ As Long
	Instance value_ As WString
	Instance map_ As iValueToLong
	Instance position_ As Long

	Class Method Create()
		size_ = 16
	End Method

	Interface iRenderIcon Guid$("{ab5b28e3-75da-402c-bfff-43b2ebfc351a}")
		Inherit IUnknown
		Property Get Icon( ByVal offset As Long ) As Dword
			If offset>=0 And offset<=UBound( hIcon() ) Then
				Property = hIcon(offset)
			End If
		End Property
		Property Set Icon( ByVal offset As Long, ByVal value As Dword )
			If offset>=0 Then
				If offset > UBound( hIcon() ) Then
					ReDim Preserve hIcon(offset)
				End If
				hIcon( offset ) = value
			End If
		End Property
		Property Get Size() As Long
			Property = size_
		End Property
		Property Set Size( ByVal value As Long )
			size_ = value
		End Property
		Property Get Position() As Long
			Property = position_
		End Property
		Property Set Position( ByVal value As Long )
			position_ = value
		End Property
		Property Get Map() As iValueToLong
			Property = map_
		End Property
		Property Set Map( ByRef value As iValueToLong )
			If IsInterface( value, iValueToLong ) Then
				map_ = value
			Else
				map_ = Nothing
			End If
		End Property
	End Interface

	Interface iValue Guid$("{081a3833-2308-4273-bda0-1c10b35610c3}")
		Inherit IUnknown
		Property Get Value() As WString
			Property = value_
		End Property
		Property Set Value( ByRef value As WString )
			value_ = value
		End Property
	End Interface

	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local item_ As Long
			Local lf, tp As Long
			Local cn, rt, md, bt As Long
			If IsObject( map_ ) Then
				item_ = map_.ValueToLong( value_ )
			Else
				item_ = Val( value_ )
			End If
			If item_ >=0 And item_ <= UBound( hIcon() ) And IsTrue( hIcon(item_) ) Then
				cn = rc.Left + (rc.Right-rc.Left-size_) \ 2
				rt = rc.Right - size_
				md = rc.Top + (rc.Bottom-rc.Top-size_) \ 2
				bt = rc.Bottom - size_
				lf = rc.Left
				tp = rc.Top

				Select Case position_
					Case %Position.TopCenter:     tp = tp: lf = cn
					Case %Position.TopRight:      tp = tp: lf = rt
					Case %Position.MiddleLeft:    tp = md: lf = lf
					Case %Position.MiddleCenter:  tp = md: lf = cn
					Case %Position.MiddleRight:   tp = md: lf = rt
					Case %Position.BottomLeft:    tp = bt: lf = lf
					Case %Position.BottomCenter:  tp = bt: lf = cn
					Case %Position.BottomRight:   tp = bt: lf = rt
					Case Else:                    tp = tp: lf = lf
				End Select

				DrawIconEx( hdc, lf, tp, hIcon(item_), size_, size_, 0, %NULL, %DI_NORMAL )
			End If
		End Method
	End Interface
End Class
