 Function NewRenderImage( Optional ByRef Stretch As Long, Optional ByRef map As iValueToLong ) Common Export As iRender
	Local o As iRender
	Local obj As iRenderImage
	o = Class "cRenderImage"
	obj = o
	If IsFalse IsMissing( Stretch ) Then
		obj.Stretch = Stretch
	End If
	If IsFalse IsMissing( map ) Then
		obj.Map = map
	End If
	Function = o
End Function

Sub SetRenderImage( ByVal obj As iRender, ByVal offset As Long, ByVal hImage As Dword ) Common Export
	Local o As iRenderImage
	o = obj
	If IsInterface( o, iRenderImage ) Then
		o.Image( offset ) = hImage
	End If
End Sub
Sub SetRenderImageList( ByVal obj As iRender, ByRef Images() As Dword ) Common Export
	Local o As iRenderImage
	Local i As Long
	o = obj
	If IsInterface( o, iRenderImage ) Then
		For i=0 To UBound( Images() )
			o.Image(i) = Images(i)
		Next
	End If
End Sub

Class cRenderImage Guid$("{8240c117-df9e-4d28-87c0-c2672d1b2083}") Common
	Instance hImage() As Dword
	Instance value_ As WString
	Instance map_ As iValueToLong
	Instance stretch_ As Dword

	Class Method Create()
		value_ = "0"
		stretch_ = %ImageStretch.Fill
	End Method

	Interface iRenderImage Guid$("{4160209f-b95f-4a60-80ea-80751d3a8bf1}")
		Inherit IUnknown
		Property Get Image( ByVal offset As Long ) As Dword
			If offset>=0 And offset<=UBound( hImage() ) Then
				Property = hImage(offset)
			End If
		End Property
		Property Set Image( ByVal offset As Long, ByVal value As Dword )
			If offset>=0 Then
				If offset > UBound( hImage() ) Then
					ReDim Preserve hImage(offset)
				End If
				hImage( offset ) = value
			End If
		End Property
		Property Get Map() As iValueToLong
			Property = map_
		End Property
		Property Set Map( ByRef value As iValueToLong )
			If IsInterface( value, iValueToLong ) Then
				map_ = value
			Else
				map_ = Nothing
			End If
		End Property
		Property Get Stretch() As Dword
			Property = stretch_
		End Property
		Property Set Stretch( ByVal value As Dword )
			Select Case value
				Case %ImageStretch.None, %ImageStretch.Min, %ImageStretch.Max, %ImageStretch.Fill, %ImageStretch.TileX, %ImageStretch.TileY, %ImageStretch.TileXY, _
					%ImageStretch.TopLeft, %ImageStretch.TopCenter, %ImageStretch.TopRight, %ImageStretch.MiddleLeft, %ImageStretch.MiddleCenter, _
					%ImageStretch.MiddleRight, %ImageStretch.BottomLeft, %ImageStretch.BottomCenter, %ImageStretch.BottomRight
					stretch_ = value
			End Select
		End Property
	End Interface

	Interface iValue Guid$("{081a3833-2308-4273-bda0-1c10b35610c3}")
		Inherit IUnknown
		Property Get Value() As WString
			Property = value_
		End Property
		Property Set Value( ByRef value As WString )
			value_ = value
		End Property
	End Interface

	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local item_ As Long
			Local mhdc As Dword
			Local pImg As Dword
			Local bm As Bitmap
			Local l As Long
			Local t As Long
			Local w As Long
			Local h As Long
			Local s As Single

			item_ = 0
			If IsObject( map_ ) Then
				item_ = map_.ValueToLong( value_ )
			Else
				item_ = Val( value_ )
			End If

			If item_ >=0 And item_ <= UBound( hImage() ) And IsTrue hImage(item_) Then
				mhdc = CreateCompatibleDC( hdc )
				pimg = SelectObject( mhdc, hImage(item_) )

				GetObject ( hImage(item_), SizeOf(bm), bm )

				w = rc.Right - rc.Left
				h = rc.Bottom - rc.Top
				Select Case stretch_
					Case %ImageStretch.TopLeft
						w = bm.bmWidth: h = bm.bmHeight
						l = rc.Left
						t = rc.Top
						Call BitBlt( hdc, l,t,w,h, mhdc, 0, 0, %SRCCOPY )
					Case %ImageStretch.TopCenter
						w = bm.bmWidth: h = bm.bmHeight
						l = rc.Left + (rc.Right-rc.Left - w)/2
						t = rc.Top
						Call BitBlt( hdc, l,t,w,h, mhdc, 0, 0, %SRCCOPY )
					Case %ImageStretch.TopRight
						w = bm.bmWidth: h = bm.bmHeight
						l = rc.Right-w
						t = rc.Top
						Call BitBlt( hdc, l,t,w,h, mhdc, 0, 0, %SRCCOPY )
					Case %ImageStretch.MiddleLeft
						w = bm.bmWidth: h = bm.bmHeight
						l = rc.Left
						t = rc.Top + (rc.Bottom-rc.Top-h)/2
						Call BitBlt( hdc, l,t,w,h, mhdc, 0, 0, %SRCCOPY )
					Case %ImageStretch.MiddleCenter
						w = bm.bmWidth: h = bm.bmHeight
						l = rc.Left + (rc.Right-rc.Left-w)/2
						t = rc.Top + (rc.Bottom-rc.Top-h)/2
						Call BitBlt( hdc, l,t,w,h, mhdc, 0, 0, %SRCCOPY )
					Case %ImageStretch.MiddleRight
						w = bm.bmWidth: h = bm.bmHeight
						l = rc.Right-w
						t = rc.Top + (rc.Bottom-rc.Top-h)/2
						Call BitBlt( hdc, l,t,w,h, mhdc, 0, 0, %SRCCOPY )
					Case %ImageStretch.BottomLeft
						w = bm.bmWidth: h = bm.bmHeight
						l = rc.Left
						t = rc.Bottom - h
						Call BitBlt( hdc, l,t,w,h, mhdc, 0, 0, %SRCCOPY )
					Case %ImageStretch.BottomCenter
						w = bm.bmWidth: h = bm.bmHeight
						l = rc.Left + (rc.Right-rc.Left - w)/2
						t = rc.Bottom - h
						Call BitBlt( hdc, l,t,w,h, mhdc, 0, 0, %SRCCOPY )
					Case %ImageStretch.BottomRight
						w = bm.bmWidth: h = bm.bmHeight
						l = rc.Right - w
						t = rc.Bottom - h
						Call BitBlt( hdc, l,t,w,h, mhdc, 0, 0, %SRCCOPY )

					Case %ImageStretch.None
						Call BitBlt( hdc, rc.Left,rc.Top,w,h, mhdc, 0, 0, %SRCCOPY )
					Case %ImageStretch.Min
						s = Min( CSng(w) / CSng(bm.bmWidth) , CSng(h) / CSng(bm.bmHeight )  )
						w=bm.bmWidth*s
						h=bm.bmHeight*s
						l = rc.Left + ((rc.Right-rc.Left)-w) / 2
						t = rc.Top + ((rc.Bottom-rc.Top)-h) / 2
						SetStretchBltMode( hdc, %HalfTone )
						SetBrushOrgEx( hdc, 0, 0, ByVal %NULL )
						Call StretchBlt( hdc, l,t,w,h, mhdc, 0, 0, bm.bmWidth, bm.bmHeight, %SRCCOPY )
					Case %ImageStretch.Max
						s = Max( CSng(w) / CSng(bm.bmWidth) , CSng(h) / CSng(bm.bmHeight )  )
						w=bm.bmWidth*s
						h=bm.bmHeight*s
						l = rc.Left + ((rc.Right-rc.Left)-w) / 2
						t = rc.Top + ((rc.Bottom-rc.Top)-h) / 2
						SetStretchBltMode( hdc, %HalfTone )
						SetBrushOrgEx( hdc, 0, 0, ByVal %NULL )
						Call StretchBlt( hdc, l,t,w,h, mhdc, 0, 0, bm.bmWidth, bm.bmHeight, %SRCCOPY )
					Case %ImageStretch.Fill
						l = rc.Left
						t = rc.Top
						SetStretchBltMode( hdc, %HalfTone )
						SetBrushOrgEx( hdc, 0, 0, ByVal %NULL )
						Call StretchBlt( hdc, l,t,w,h, mhdc, 0, 0, bm.bmWidth, bm.bmHeight, %SRCCOPY )
					Case %ImageStretch.TileX
						l = rc.Left
						t = rc.Top
						While l<rc.right
							Call BitBlt( hdc, l,t,bm.bmWidth, bm.bmHeight, mhdc, 0, 0, %SRCCOPY )
							l += bm.bmWidth
						Wend
					Case %ImageStretch.TileY
						l = rc.Left
						t = rc.Top
						While t<rc.Bottom
							Call BitBlt( hdc, l,t,bm.bmWidth, bm.bmHeight, mhdc, 0, 0, %SRCCOPY )
							t += bm.bmHeight
						Wend
					Case %ImageStretch.TileXY
						t = rc.Top
						While t<rc.Bottom
							l = rc.Left
							While l<rc.Right
								Call BitBlt( hdc, l,t,bm.bmWidth, bm.bmHeight, mhdc, 0, 0, %SRCCOPY )
								l += bm.bmWidth
							Wend
							t += bm.bmHeight
						Wend
					End Select
				SelectObject( mhdc, pimg )
				DeleteDc( mhdc )
			End If
		End Method
	End Interface
End Class
