Function NewRenderRow( value As WString, Optional map As iValueToString, Optional align As Dword, Optional Color As Dword ) Common Export As iRender
	Local obj As iRenderRow
	Local v As iValue
	Local a As iAlign

	obj = Class "cRenderRow"
	v = obj
	a = obj
	v.Value = value
	If IsFalse IsMissing( map ) Then
		obj.Map = map
	End If
	If IsFalse IsMissing( align ) Then
		a.Align = align
	End If
	If IsFalse IsMissing( Color ) Then
		obj.Color.Value = Color
	End If
	Local rndr As iRender
	rndr = obj
	Function = rndr
End Function

Function NewSysRenderRow( value As WString, Optional align As Dword, Optional Color As Dword ) Common Export As iRender
	Local obj As iRenderRow
	Local v As iValue
	Local a As iAlign

	obj = Class "cRenderRow"
	v = obj
	a = obj
	v.Value = value
	If IsFalse IsMissing( align ) Then
		a.Align = align
	End If
	If IsFalse IsMissing( Color ) Then
		obj.Color.SysColor = Color
	End If
	Local rndr As iRender
	rndr = obj
	Function = rndr
End Function

Class cRenderRow Guid$("{306a14d2-e22b-45b8-bcb4-8ed7e1f3fea3}") Common
	Instance value_ As WString
	Instance align_ As Dword
	Instance color_ As iIVColor
	Instance hFont_ As iFont
	Instance map_ As iValueToString

	Class Method Create()
		color_ = NewIVColor(0)
		color_.SysColor = %COLOR_WINDOWTEXT
		align_ = %DT_LEFT Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_TOP Or %DT_WORD_ELLIPSIS
		hFont_ = NewFont( "Arial", 23, 1, 0, 0 )
	End Method
	Class Method Destroy()
		color_.TestRelease()
		color_ = Nothing
		hFont_ = Nothing
	End Method

	Interface iValue Guid$("{081a3833-2308-4273-bda0-1c10b35610c3}")
		Inherit IUnknown
		Property Get Value() As WString
			Property = value_
		End Property
		Property Set Value( ByRef value As WString )
			value_ = value
		End Property
	End Interface

	Interface iAlign Guid$("{f8de15d9-b7e2-423a-bb15-72d1882e11da}")
		Inherit IUnknown
		Property Get Align() As Dword
			Property = align_
		End Property
		Property Set Align( ByRef value As Dword )
			align_ = value
		End Property
	End Interface

	Interface iRenderRow Guid$("{5f9517d8-a4b4-4aca-9103-0b789bb48d8f}")
		Inherit IUnknown

		Property Get Color() As iIVColor
			Property = color_
		End Property
		Property Set Color( ByRef value As iIVColor )
			color_ = value
		End Property

		Property Get Font() As iFont
			Property = hFont_
		End Property

		Property Get Map() As iValueToString
			Property = map_
		End Property
		Property Set Map( ByRef value As iValueToString )
			If IsInterface( value, iValueToString ) Then
				map_ = value
			Else
				map_ = Nothing
			End If
		End Property
	End Interface

	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local oldColor As Dword
			Local oldMode As Dword
			Local oldFont As Dword
			Local v As WString

			oldColor = SetTextColor( hdc, color_.Value )
			oldMode = SetBkMode( hdc, %TRANSPARENT )
			oldFont = SelectObject( hdc, hFont_.Handle )
			InflateRect( rc, -4, -2 )

			v = "Row " + Format$(r+1, "#,##0")
			DrawText( hdc, ByVal StrPtr(v), Len(v), rc, %DT_CENTER Or %DT_VCENTER Or %DT_SINGLELINE )
			InflateRect( rc, 4, 2 )

			SetTextColor( hdc, oldColor )
			SetBkMode( hdc, oldMode )
			SelectObject( hdc, oldFont )
		End Method
	End Interface
End Class
