Function NewRenderText( value As WString, Optional map As iValueToString, Optional align As Dword, Optional Color As Dword, Optional hFont As iFont ) Common Export As iRender
	Local obj As iRenderText
	Local v As iValue
	Local a As iAlign

	obj = Class "cRenderText"
	v = obj
	a = obj
	v.Value = value
	If IsFalse IsMissing( map ) Then
		obj.Map = map
	End If
	If IsFalse IsMissing( align ) Then
		a.Align = align
	End If
	If IsFalse IsMissing( Color ) Then
		obj.Color.Value = Color
	End If
	If IsFalse IsMissing( hFont ) Then
		obj.Font = hFont
	End If
	Local rndr As iRender
	rndr = obj
	Function = rndr
End Function

Function NewSysRenderText( value As WString, Optional align As Dword, Optional Color As Dword, Optional hFont As iFont ) Common Export As iRender
	Local obj As iRenderText
	Local v As iValue
	Local a As iAlign

	obj = Class "cRenderText"
	v = obj
	a = obj
	v.Value = value
	If IsFalse IsMissing( align ) Then
		a.Align = align
	End If
	If IsFalse IsMissing( Color ) Then
		obj.Color.SysColor = Color
	End If
	If IsFalse IsMissing( hFont ) Then
		obj.Font = hFont
	End If
	Local rndr As iRender
	rndr = obj
	Function = rndr
End Function

Class cRenderText Guid$("{e7732ea5-4d7e-45a2-bacf-7187105d30d8}") Common
	Instance value_ As WString
	Instance align_ As Dword
	Instance color_ As iIVColor
	Instance hFont_ As iFont
	Instance map_ As iValueToString

	Class Method Create()
		color_ = NewIVColor(0)
		color_.SysColor = %COLOR_WINDOWTEXT
		align_ = %DT_LEFT Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_TOP Or %DT_WORD_ELLIPSIS
	End Method
	Class Method Destroy()
		color_.TestRelease()
		color_ = Nothing
	End Method

	Interface iValue Guid$("{081a3833-2308-4273-bda0-1c10b35610c3}")
		Inherit IUnknown
		Property Get Value() As WString
			Property = value_
		End Property
		Property Set Value( ByRef value As WString )
			value_ = value
		End Property
	End Interface

	Interface iAlign Guid$("{f8de15d9-b7e2-423a-bb15-72d1882e11da}")
		Inherit IUnknown
		Property Get Align() As Dword
			Property = align_
		End Property
		Property Set Align( ByRef value As Dword )
			align_ = %DT_NOPREFIX Or %DT_WORD_ELLIPSIS
			Select Case value And 3
				Case %IVAlign.Right:  align_ Or= %DT_RIGHT
				Case %IVAlign.Center: align_ Or= %DT_CENTER
				Case Else:            align_ Or= %DT_LEFT
			End Select
			Select Case value And 12
				Case %IVAlign.Middle: align_ Or= %DT_VCENTER
				Case %IVAlign.Bottom: align_ Or= %DT_BOTTOM
				Case Else:            align_ Or= %DT_TOP
			End Select
			If (value And %IVAlign.MultiLine)=0 Then
				align_ Or= %DT_SINGLELINE
			Else
				align_ Or= %DT_WORDBREAK
			End If
		End Property
	End Interface

	Interface iRenderText Guid$("{ff2bb618-6654-423f-a6ff-7f670b95702e}")
		Inherit IUnknown

		Property Get Color() As iIVColor
			Property = color_
		End Property
		Property Set Color( ByRef value As iIVColor )
			color_ = value
		End Property

		Property Get Font() As iFont
			Property = hFont_
		End Property
		Property Set Font( ByVal value As iFont )
			hFont_ = value
		End Property

		Property Get Map() As iValueToString
			Property = map_
		End Property
		Property Set Map( ByRef value As iValueToString )
			If IsInterface( value, iValueToString ) Then
				map_ = value
			Else
				map_ = Nothing
			End If
		End Property
	End Interface

	Interface iHasFont Guid$("{e2ba5314-8029-4d9a-8255-bba3710a755c}")
		Inherit IUnknown

		Property Get Font() As iFont
			Property = hFont_
		End Property
		Property Set Font( ByVal value As iFont )
			hFont_ = value
		End Property
	End Interface

	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local oldColor As Dword
			Local oldMode As Dword
			Local oldFont As Dword
			Local v As WString

			oldColor = SetTextColor( hdc, color_.Value )
			oldMode = SetBkMode( hdc, %TRANSPARENT )
			If IsObject(hFont_) And hFont_.Handle Then oldFont = SelectObject( hdc, hFont_.Handle )
			InflateRect( rc, -4, -2 )

			If IsObject( map_ ) Then
				v = map_.ValueToString( value_ )
			Else
				v = value_
			End If

			DrawText( hdc, ByVal StrPtr(v), Len(v), rc, align_ )
			InflateRect( rc, 4, 2 )

			SetTextColor( hdc, oldColor )
			SetBkMode( hdc, oldMode )
			If IsObject(hFont_) And hFont_.Handle Then SelectObject( hdc, oldFont )
		End Method
	End Interface
End Class
