Function NewRenderTextRotated( ByRef value As WString, Optional angle As Long, Optional Color As Dword, Optional face As WString, Optional height As Long, _
															Optional Bold As Long, Optional italic As Long ) Common Export As iRender
	Local rt As iRenderTextRotated
	Local v As iValue
	Local obj As iRender
	obj = Class "cRenderTextRotated"
	v = obj
	rt = obj
	v.Value = value
	If IsFalse IsMissing( angle ) Then
		rt.Angle = angle
	End If
	If IsFalse IsMissing( Color ) Then
		rt.Color.Value = Color
	End If
	If IsFalse IsMissing( face ) Then
		rt.Face = face
	End If
	If IsFalse IsMissing( height ) Then
		rt.Height = height
	End If
	If IsFalse IsMissing( Bold ) Then
		rt.Bold = Bold
	End If
	If IsFalse IsMissing( italic ) Then
		rt.Italic = italic
	End If
	Function = obj
End Function


Class cRenderTextRotated Guid$("{179f28c6-6ed6-4f23-a73e-d106dd70e439}") Common
	Instance value_ As WString
	Instance color_ As iIVColor
	Instance angle_ As Long
	Instance face_ As WString
	Instance height_ As Long
	Instance bold_ As Long
	Instance italic_ As Long
	Instance hFont_ As iFont

	Class Method Create()
		color_ = NewSysIVColor( %COLOR_WINDOWTEXT )
		angle_ = 0: ' Left to right Horizontal text
		face_ = "Arial"
		height_ = 16
		bold_ = 0
		italic_ = 0
	End Method
	Class Method Destroy()
		If IsObject(hfont_) Then hFont_ = Nothing
		color_.TestRelease()
		color_ = Nothing
	End Method

	Class Method CreateFont()
		If IsFalse IsObject( hFont_ ) Then
			hFont_ = NewFont( face_, height_, bold_, italic_, angle_ )
		End If
	End Method

	Interface iValue Guid$("{081a3833-2308-4273-bda0-1c10b35610c3}")
		Inherit IUnknown
		Property Get Value() As WString
			Property = value_
		End Property
		Property Set Value( ByRef value As WString )
			value_ = value
		End Property
	End Interface

	Interface iRenderTextRotated Guid$("{2509a589-d875-4a2e-9ade-8802d1dff642}")
		Inherit IUnknown

		Property Get Color() As iIVColor
			Property = color_
		End Property

		Property Get Angle() As Long
			Property = angle_
		End Property
		Property Set Angle( ByRef value As Long )
			angle_ = value Mod 360
			If angle_<0 Then angle_ = 360 - angle_
			If angle_=0 Then angle_ = 360
		End Property

		Property Get Face() As WString
			Property = face_
		End Property
		Property Set Face( ByRef value As WString )
			If value<> face_ Then
				face_ = value
				hFont_ = Nothing
			End If
		End Property

		Property Get Height() As Long
			Property = height_
		End Property
		Property Set Height( ByRef value As Long )
			If height_ <> value Then
				height_ = value
				hFont_ = Nothing
			End If
		End Property

		Property Get Bold() As Long
			Property = bold_
		End Property
		Property Set Bold( ByRef value As Long )
			If bold_<>value Then
				bold_ = value
				hFont_ = Nothing
			End If
		End Property

		Property Get Italic() As Long
			Property = italic_
		End Property
		Property Set Italic( ByRef value As Long )
			If italic_<>value Then
				italic_ = value
				hFont_ = Nothing
			End If
		End Property
	End Interface

	Interface iHasFont Guid$("{e2ba5314-8029-4d9a-8255-bba3710a755c}")
		Inherit IUnknown

		Property Get Font() As iFont
			Property = hFont_
		End Property
		Property Set Font( ByVal value As iFont )
			hFont_ = value
		End Property
	End Interface

	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local lFont As LOGFONT
			Local oldFont As Long
			Local oldMode As Dword
			Local oldColor As Dword
			Local hClipRgn As Dword
			Local pRgn As Dword
			Local hPrevRgn As Dword

			If IsFalse IsObject(hFont_) Then Me.CreateFont()
			oldFont = SelectObject(hdc, hFont_.Handle)
			oldMode = SetBkMode( hdc, %TRANSPARENT )
			oldColor = SetTextColor( hdc, color_.Value )

			Local x As Long, y As Long
			Select Case angle_
				Case 0 To 45, 316 To 360: x =rc.Left: y = rc.top
				Case 45 To 135: x = rc.Left: y = rc.Bottom
				Case 136 To 225: x = rc.Right: y = rc.Bottom
				Case 226 To 315: x = rc.Right: y = rc.Top
			End Select

			hPrevRgn = CreateRectRgnIndirect( rc )
			If IsFalse GetClipRgn( hdc, hPrevRgn ) Then
				DeleteObject( hPrevRgn )
				hPrevRgn = 0
			End If

			hClipRgn = CreateRectRgnIndirect( rc )
			SelectClipRgn( hdc, hClipRgn )

			TextOut( hdc, x, y, ByVal StrPtr( value_ ), Len( value_ ) )

			SetTextColor( hdc, oldColor )
			SetBkMode( hdc, oldMode )
			SelectObject( hdc, oldFont )

			If hPrevRgn Then
				SelectClipRgn( hdc, hPrevRgn )
				DeleteObject( hPrevRgn )
			End If
			DeleteObject( hClipRgn )
		End Method
	End Interface
End Class
